Package: suppr
Title: Supplementary Idiomatic Utilities and Extensions
Version: 1.0.0
Authors@R: 
   person("Luke", "Jenkins", , "luke-jenkins-dev@outlook.com", role = c("aut", "cre", "cph"), comment = c(ORCID = "0000-0002-7206-7242"))
Description: Miscellaneous supplementary functions designed to follow idiomatic 'R' conventions. Some functions are simple wrappers that reduce repetitive code, while others address common tasks or extend existing 'R' functions.
License: MIT + file LICENSE
Encoding: UTF-8
RoxygenNote: 8.0.0
Suggests: rlang, testthat (>= 3.0.0)
Config/testthat/edition: 3
Imports: methods, stats
Depends: R (>= 4.0.0)
URL: https://lj-jenkins.github.io/suppr/,
        https://github.com/LJ-Jenkins/suppr
BugReports: https://github.com/LJ-Jenkins/suppr/issues
NeedsCompilation: yes
Packaged: 2026-08-24 14:59:56 UTC; lukej
Author: Luke Jenkins [aut, cre, cph] (ORCID:
    <https://orcid.org/0000-0002-7206-7242>)
Maintainer: Luke Jenkins <luke-jenkins-dev@outlook.com>
Repository: CRAN
Date/Publication: 2026-09-05 13:30:02 UTC

<!-- README.md is generated from README.Rmd. Please edit that file -->

# suppr <img src="man/figures/logo.png" align="right" height="140" alt="" />

<!-- badges: start -->

[![R-CMD-check](https://github.com/LJ-Jenkins/suppr/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/LJ-Jenkins/suppr/actions/workflows/R-CMD-check.yaml)
<!-- badges: end -->

Supplementary utilities and extensions to `R` that are idiomatic in
style.

## Installation

Install the latest release of suppr from CRAN:

``` r
install.packages("suppr")
```

You can install the development version of suppr from GitHub:

``` r
# install.packages("pak")
pak::pak("LJ-Jenkins/suppr")
```

## Reference

suppr provides miscellaneous supplementary functions for `R`: some are
simple wrappers that save a few keystrokes, others address common tasks,
and others provide new functionality through suppr versions of existing
`R` functions. All are intended to be idiomatic `R`, as if they were
part of the base R packages.

Much of suppr is directly amended from the `R` source code - all credit
to the authors for their great work!

#### Infix Operators

- `%''%` or `%""%` - if the lhs is ““, return the rhs, else return the
  lhs.
- `%!||%` - if the lhs is `NULL`, return the lhs, else return the rhs.
- `%0%` - if the lhs is of length `0`, return the rhs, else return the
  lhs.
- `%allin%`, `%anyin%`, `%nonein%`, `%onein%` and `%notin%` -
  `base::%in%` variants.

``` r
"" %''% "a"
#> [1] "a"
NULL %!||% "a"
#> NULL
c() %0% "a"
#> [1] "a"
c("a", "b") %allin% c("a", "b", "c")
#> [1] TRUE
c("a", "d") %anyin% c("a", "b", "c")
#> [1] TRUE
c("a", "d") %nonein% c("a", "b", "c")
#> [1] FALSE
c("a", "d") %onein% c("a", "b", "c")
#> [1] TRUE
c("a", "d") %notin% c("a", "b", "c")
#> [1] FALSE  TRUE
```

#### Character Operators

- `bckQuote()` - backquotes a string.
- `collapse()` and `collapse0()` - collapse a vector (or vectors) into a
  single string, optionally ‘recursively’ (in the sense of collapse each
  argument individually and then collapse the results).
- `listing()` - turns a character vector into a human-readable list (in
  the grammatical sense), optionally with quoting and/or a conjunction
  like “and” or “or”.
- `cat0()` - `base::cat()` with `sep = ""`.
- `grepf()`, `grepi()`, `greplf()`, `grepli()`, `grepvf()`, `grepvi()`,
  `subf()`, `subi()`, `gsubf()` and `gsubi()` - strongly typed variants
  of `base::grep()`, `base::grepl()`, `base::grepv()`, `base::sub()` and
  `base::gsub()` for the common `fixed = TRUE` and `ignore.case = TRUE`
  cases.
- `anyZchar()` - returns the `1`-based index of the first zero character
  element if any, otherwise `0`.
- `anyWS()` - returns the `1`-based index of the first all whitespace
  element if any, otherwise `0`. Optionally, zero character elements can
  be treated as all whitespace.

``` r
bckQuote(c("a", "b"))
#> [1] "`a`" "`b`"
collapse(c("a", "b", "c"))
#> [1] "abc"
listing(c("a", "b", "c"))
#> [1] "a, b and c."
cat0("a", "b", "c")
#> abc
greplf("foo", c("foo", "Foo", "bar"))
#> [1]  TRUE FALSE FALSE
grepli("foo", c("foo", "Foo", "bar"))
#> [1]  TRUE  TRUE FALSE
anyZchar(c("hi", "bye", " ", ""))
#> [1] 4
anyWS(c("hi", "bye", " ", ""))
#> [1] 3
```

#### Dots (`...`) Operators

- `checkDots()` - version of `base::chkDots()` that can error, not just
  warn.
- `dotsNames()` - returns the names of `...` arguments, returning all
  `""` if unnamed (like `methods::allNames()` but without evaluating
  `...`).
- `subDots()` - substitutes `...` arguments, returning a list of the
  substituted expressions.
- `dp1Dots()` - substitutes `...` arguments, before applying
  `base::deparse1()` to each, returning a character vector of the dot
  arguments.

``` r
f <- function(fn, ...) fn(...)
f(checkDots, a = 1, b = 2)
#> Error:
#> ! In f(checkDots, a = 1, b = 2) :
#>  extra named arguments 'a', 'b' are not allowed.
f(dotsNames, 1, 2)
#> [1] "" ""
f(subDots, x = a + b, y = a * b)
#> $x
#> a + b
#> 
#> $y
#> a * b
f(dp1Dots, x = a + b, y = a * b)
#>       x       y 
#> "a + b" "a * b"
```

#### Warnings and Errors

- `match.argv()` - matches function argument input to a list of valid
  values, not just strings like `base::match.arg()`.
- `stop2()`, `warning2()` and `stopifnot2()` - wrappers for
  `base::stop()`, `base::warning()` and `base::stopifnot()` that enable
  the inclusion of any call on the stack in the error message via a more
  flexible `call.` argument.
- `warningifnot()` - a wrapper for `stopifnot2()` that produces a
  warning instead of an error.
- `stopifnot.with()` - a wrapper for `stopifnot2()` that evaluates
  expressions in a specified environment/data object (like
  `base::with()`).

``` r
match.argv(1:3, list(c("a", "b"), list(1:3), 1:3))
#> [1] 1 2 3
f1 <- function(call.) stop2("error", call. = call.)
f2 <- function(call.) f1(call. = call.)
f2(call. = 2)
#> Error in `f2()`:
#> ! error
f1 <- function(call.) stopifnot2(all.equal(1, 2), call. = call.)
f2(call. = 1)
#> Error in `f1()`:
#> ! 1 and 2 are not equal:
#>   Mean relative difference: 1
warningifnot(1 == 2, 3 > 4, warn.all = TRUE, call. = FALSE)
#> Warning: 1 == 2 is not TRUE
#> Warning: 3 > 4 is not TRUE
stopifnot.with(data.frame(x = 1, y = 2), x == y)
#> Error:
#> ! with data.frame(x = 1, y = 2) : x == y is not TRUE
```

#### Classes

- `addClass()` - adds a class/classes to an object, either preserving
  existing classes (by prepending given classes), or overwriting
  existing classes, and returning the object.
- `isVector()` - wrapper for `base::is.vector()` that allows multiple
  classes to be specified.
- `is.Date()`, `is.datetype()`, `is.POSIXt()`, `is.POSIXct()` and
  `is.POSIXlt()` - date type predicates.
- `is.boolean()`, `is.string()` and `nzstring()` - predicates for common
  scalar values.

``` r
x <- structure(1:3, class = c("a", "b"))
class(addClass(x, "my_new_class"))
#> [1] "my_new_class" "a"            "b"
isVector(1:3, c("character", "list", "numeric"))
#> [1] TRUE
is.Date(Sys.Date())
#> [1] TRUE
is.datetype(Sys.Date())
#> [1] TRUE
is.POSIXt(Sys.time())
#> [1] TRUE
is.POSIXct(Sys.time())
#> [1] TRUE
is.POSIXlt(Sys.time())
#> [1] FALSE
is.boolean(TRUE)
#> [1] TRUE
is.string("")
#> [1] TRUE
nzstring("")
#> [1] FALSE
```

#### Data Wrangling

##### Even/odd

- `is.even()` and `is.odd()` - returns logical vector indicating if
  elements are even or odd, respectively.

``` r
is.even(c(-2:2, NA))
#> [1]  TRUE FALSE  TRUE FALSE  TRUE FALSE
is.odd(c(1, 2, NA, Inf), noparity.na = TRUE)
#> [1]  TRUE FALSE    NA    NA
```

##### Which min/max

- `whichMin()` and `whichMax()` - wrappers for `base::which.min()` and
  `base::which.max()` that offer a new `loc` argument to alternatively
  return the first, last, or all, minima/maxima.

``` r
x <- c(1, 2, 3, 1, 2, 3)
whichMin(x, loc = "first")
#> [1] 1
whichMin(x, loc = "last")
#> [1] 4
whichMin(x, loc = "all")
#> [1] 1 4
```

##### NA’s

- `is.nonfinite()` (and alias `is.nf()`) - returns a logical vector
  indicating which elements are non-finite (i.e., `NA`, `NaN`, `Inf` or
  `-Inf`).
- `anyNF()` - returns the `1`-based index of the first non-finite value
  if any, otherwise `0`.
- `whichNA()` - returns the indices of `NA` values.
- `setNA()` - sets given indices to `NA`.
- `na.vector()` - returns a vector of `NA` values of a given length and
  type.
- `na.refill()` - for an object that has had `NA` values removed by
  `stats::na.omit()`, refill the `NA` values at the original indices,
  returning an object of the same size as the original.

``` r
is.nonfinite(c(1, 2, NA, Inf))
#> [1] FALSE FALSE  TRUE  TRUE
anyNF(c(1, 2, NA, Inf))
#> [1] 3
whichNA(c(1, 2, NA, Inf))
#> [1] 3
x <- c(1, 2, 3, 4)
setNA(x, c(1, 3))
#> [1] NA  2 NA  4
na.vector(5, type = "character")
#> [1] NA NA NA NA NA
x <- stats::na.omit(c(1, 2, NA, 4))
x
#> [1] 1 2 4
#> attr(,"na.action")
#> [1] 3
#> attr(,"class")
#> [1] "omit"
na.refill(x)
#> [1]  1  2 NA  4
#> attr(,"na.action")
#> [1] 3
#> attr(,"class")
#> [1] "refilled"
```

##### Wholeness

- `is.integerish()` - returns `TRUE` if elements are all ‘integerish’ or
  `FALSE` if not.
- `is.whole()` and `is.wholenumber()` - returns a single `TRUE`/`FALSE`,
  or a logical vector, if elements are all whole numbers or not
  (according to an input tolerance), respectively.

``` r
is.integerish(c(1, 1.000000001))
#> [1] FALSE
is.whole(c(1, 1.000000001))
#> [1] TRUE
is.wholenumber(c(1, 2, 3.5, 4))
#> [1]  TRUE  TRUE FALSE  TRUE
```

##### Duplicates

- `repeated()` - returns a logical vector indicating which elements are
  repeated (analogous to
  `duplicated(x, fromLast = FALSE) | duplicated(x, fromLast = TRUE)`).
- `whichRepeated()` - returns the indices of repeated elements.
- `repeats()` (and alias `non.unique()`) - returns repeated elements.

``` r
x <- c(1, 2, 3, 1, 2, 3, 4, 5)
repeated(x)
#> [1]  TRUE  TRUE  TRUE  TRUE  TRUE  TRUE FALSE FALSE
whichRepeated(x)
#> [1] 1 2 3 4 5 6
repeats(x)
#> [1] 1 2 3 1 2 3
```

##### Remove elements

- `rm.first()` and `rm.last()` - removes the first or last ‘n’ elements
  of a vector, respectively.

``` r
x <- 1:10
rm.first(x, 3)
#> [1]  4  5  6  7  8  9 10
rm.last(x, 3)
#> [1] 1 2 3 4 5 6 7
```

#### Utilities

- `predapply()` - applies a predicate function to each element of a
  vector, returning a logical vector. Option to reduce the output to a
  single `TRUE` or `FALSE` value.
- `empty.list()` - wrapper for `base::vector("list", length)` that
  returns an empty list of a given length.
- `path()` - wrapper for `base::file.path()` and
  `base::normalizePath()`. Option to specify if the path is on a shared
  drive, prepending `.Platform$file.sep` if so.
- `dims()` - returns the dimensions of an object, or `c(length(x), 0L)`
  if it has no dim attribute.
- `enumerate()` - returns a list of lists - one for each element of a
  vector, with the corresponding positional list containing the vector
  element, index and name.
- `libraries()` and `requires()` - wrappers for `base::library()` and
  `base::require()` that can load multiple packages at once, either from
  names, strings, or character vectors.

``` r
predapply(1:10, is.even, reduce = "any")
#> [1] TRUE
empty.list(2)
#> [[1]]
#> NULL
#> 
#> [[2]]
#> NULL
path("mysd", "mydir", sharedDrive = TRUE, mustWork = FALSE)
#> [1] "\\\\mysd\\mydir"
dims(1:10)
#> [1] 10  0
enumerate(c("a", el = "b"))
#> [[1]]
#> [[1]]$idx
#> [1] 1
#> 
#> [[1]]$val
#> [1] "a"
#> 
#> [[1]]$name
#> [1] ""
#> 
#> 
#> [[2]]
#> [[2]]$idx
#> [1] 2
#> 
#> [[2]]$val
#> [1] "b"
#> 
#> [[2]]$name
#> [1] "el"
libraries(stats, "utils")
x <- c("stats", "utils")
requires(x, "methods", character.only = TRUE)
```

## Performance

Functions should have similar overhead to their nearest `R` equivalents.
Most of the ‘data wrangling’ functions have been implemented in `C` and
typically perform equivalently to their `R` counterparts.

## Getting help

If you encounter a clear bug, please file an issue with a minimal
reproducible example on
[GitHub](https://github.com/LJ-Jenkins/suppr/issues).

## Code of Conduct

Please note that the suppr project is released with a [Contributor Code
of
Conduct](https://contributor-covenant.org/version/2/1/CODE_OF_CONDUCT.html).
By contributing to this project, you agree to abide by its terms.

#' @title Infix Operator Helpers
#' @description Infix operators for common tasks.
#'
#' `%''%` and `%""%` return the right-hand side if the left-hand side is
#' an empty string (`""`).
#'
#' `%!||%` returns the right-hand side if the left-hand side is not
#' `NULL`.
#'
#' `%0%` returns the right-hand side if the left-hand side has length 0.
#'
#' `%allin%` returns `TRUE` if all elements of `x` are in `table`.
#'
#' `%anyin%` returns `TRUE` if any elements of `x` are in `table`.
#'
#' `%nonein%` returns `TRUE` if none of the elements of `x` are in `table`.
#'
#' `%onein%` returns `TRUE` if exactly one element of `x` is in `table`.
#'
#' `%notin%` returns `TRUE` for elements of `x` that are not in `table`.
#' This is implemented in the same way as base **R** and will be
#' replaced by the base version in the **R** versions that have it.
#' @param lhs left-hand side object.
#' @param rhs right-hand side object.
#' @param x [vector] or `NULL`: the values to be matched.
#' [Long vectors] are supported.
#' @param table vector or `NULL`: the values to be matched against.
#' [Long vectors] are not supported.
#' @return For the non-`%*in%` operators, either the left-hand side or
#' right-hand side, depending on the result of the operator.
#'
#' For `%allin%`, `%anyin%`, `%nonein%`, and `%onein%`
#' a single logical value (or empty logical if `x` has length `0`) is
#' returned. For `%notin%`, a logical vector of the same length as
#' `x` is returned.
#' @details
#' The `%*in%` operators follow the semantics of `%in%` for `NULL`
#' values:
#'
#' * Singular `NULL`'s on the lhs always returns a length `0` logical vector.
#' * `NULL` elements are not considered equal to singular `NULL`'s so will
#' give a `TRUE` for `%nonein%` and `%notin%` and `FALSE` for `%allin%`,
#' `%anyin%` and `%onein%`.
#'
#' See `%in%` semantics:
#' ```{r eval=TRUE}
#' NULL %in% NULL
#' NULL %in% list(1, NULL)
#' list(1, NULL) %in% NULL
#' list(1, NULL) %in% list(1, NULL)
#' ```
#' @name suppr-infix
#' @examples
#' "" %''% "default" # if lhs is "", return rhs
#'
#' NULL %!||% "default" # if lhs is NULL, return *lhs* (NULL)
#' # useful for when using NULL as a default value
#' # or when using elements of a list that may be NULL
#' # e.g.,
#' lst <- list(a = 1, b = 2)
#' x <- lst$nope %!||% mean(lst$nope) # returns NULL
#'
#' integer(0) %0% 5L # if lhs is length 0, return rhs
#'
#' c(1, 2, 3) %allin% c(1, 2, 3, 4) # TRUE
#'
#' c(1, 2, 3) %anyin% c(1, 2, 3, 4) # TRUE
#'
#' c(1, 2, 3) %nonein% c(4, 5, 6) # TRUE
#'
#' c(1, 2, 3) %onein% c(1, 4, 5) # TRUE
#'
#' c(1, 2, 3) %notin% c(4, 5, 6) # TRUE
NULL

#' @rdname suppr-infix
#' @export
`%''%` <- function(lhs, rhs) if (lhs == "") rhs else lhs

#' @rdname suppr-infix
#' @export
`%""%` <- function(lhs, rhs) if (lhs == "") rhs else lhs

#' @rdname suppr-infix
#' @export
`%!||%` <- function(lhs, rhs) if (is.null(lhs)) lhs else rhs

#' @rdname suppr-infix
#' @export
`%0%` <- function(lhs, rhs) if (!length(lhs)) rhs else lhs

#' @rdname suppr-infix
#' @export
`%allin%` <- function(x, table) {
  y <- match(x, table)
  if (!length(y)) {
    logical(0)
  } else {
    !anyNA(y)
  }
}

#' @rdname suppr-infix
#' @export
`%anyin%` <- function(x, table) {
  y <- match(x, table, nomatch = 0L) > 0L
  if (!length(y)) {
    logical(0)
  } else {
    sum(y) >= 1L
  }
}

#' @rdname suppr-infix
#' @export
`%nonein%` <- function(x, table) {
  y <- match(x, table, nomatch = 0L)
  if (!length(y)) {
    logical(0)
  } else {
    sum(y) == 0L
  }
}

#' @rdname suppr-infix
#' @export
`%onein%` <- function(x, table) {
  y <- match(x, table, nomatch = 0L) > 0L
  if (!length(y)) {
    logical(0)
  } else {
    sum(y) == 1L
  }
}

# to match upcoming base R version
#' @rdname suppr-infix
#' @export
`%notin%` <- function(x, table) match(x, table, nomatch = 0L) == 0L

if (exists("%notin%", envir = baseenv())) {
  `%notin%` <- get("%notin%", envir = baseenv())
}

#' @title Are vectors whole or integer-like?
#' @description
#' Tests if numeric vectors are integerish, or whole according to a
#' given tolerance.
#'
#' `is.whole()` and `is.integerish()` check if the entire vector
#' is whole or integerish, whilst `is.wholenumber()` checks element-wise
#' for wholeness.
#' @param x a logical, numeric, or complex vector.
#' @param tol numeric tolerance for wholeness.
#' @return
#' For `is.whole()` and `is.integerish()` a single `TRUE` or `FALSE`.
#'
#' For `is.wholenumber()`, a logical vector of the same length as `x`.
#' @details
#' `is.integerish()` tests if a vector is integerish by evaluating if the
#' remainder of the [absolute][abs] value of `x` divided by `1` is 'equal'
#' to `0.0` in the `C` code.
#'
#' `is.whole()` and `is.wholenumber()` test for wholeness by evaluating
#' if the [absolute][abs] value of `x` minus its rounded value is less than
#' the given tolerance.
#'
#' Both `is.integerish()` and `is.whole()` ignore non-finite values (i.e.,
#' treat them as integerish/whole) and only test finite values for
#' integerishness or wholeness. If you do not want this behavior, use
#' [anyNF], e.g., `!anyNF(x) && is.whole(x)`.
#'
#' `is.wholenumber()` returns `NA` for non-finite elements.
#' @seealso [is.integerish], [anyNF]
#' @examples
#' is.integerish(1)
#' is.integerish(1.0)
#' is.integerish(1.0000000001)
#' is.integerish(1.0000000000000001)
#'
#' is.wholenumber(1)
#' x <- c(1.0, 1.0000001, 1.0000000001)
#' is.wholenumber(x)
#' is.whole(x)
#'
#'
#' # ignores non-finite values:
#' is.integerish(c(Inf, -Inf, NaN, NA))
#' is.whole(c(Inf, -Inf, NaN, NA))
#'
#' # non-finite values flag as NA:
#' is.wholenumber(c(Inf, -Inf, NaN, NA))
#'
#' # all error on non-numeric vector inputs:
#' try(is.integerish("1"))
#' try(is.whole("1"))
#' try(is.wholenumber("1"))
#' @export
is.whole <- function(x, tol = .Machine$double.eps^0.5) {
  .Call(C_is_whole, x, tol)
}

#' @rdname is.whole
#' @export
is.wholenumber <- function(x, tol = .Machine$double.eps^0.5) {
  .Call(C_is_wholenumber, x, tol)
}

#' @rdname is.whole
#' @export
is.integerish <- function(x) {
  .Call(C_is_integerish, x)
}

test_that("is.integerish() recognizes integer-like inputs", {
  expect_true(is.integerish(1L))
  expect_true(is.integerish(c(1L, 2L, NA_integer_)))
  expect_true(is.integerish(c(1, 2, NA_real_, Inf, -Inf, NaN)))
  expect_false(is.integerish(c(1.5, 2)))
})

test_that("is.whole() returns a scalar whole-number status", {
  expect_true(is.whole(1:5))
  expect_true(is.whole(c(1, 2, NA_real_, Inf, NaN)))
  expect_false(is.whole(c(1, 2.5)))
})

test_that("is.wholenumber() works element-wise", {
  x <- c(1, 2.5, NA_real_, Inf, NaN)

  expect_identical(is.wholenumber(x), c(TRUE, FALSE, NA, NA, NA))
  expect_identical(is.wholenumber(1:3), c(TRUE, TRUE, TRUE))
  expect_identical(is.wholenumber(NA_real_), NA)
})

test_that("is.integerish() and is.whole() treat non-finite values as TRUE", {
  expect_true(is.integerish(c(Inf, -Inf, NaN, NA)))
  expect_true(is.whole(c(Inf, -Inf, NaN, NA)))
})

test_that("is.wholenumber() returns NA for non-finite values", {
  expect_identical(
    is.wholenumber(c(Inf, -Inf, NaN, NA)), c(NA, NA, NA, NA)
  )
})

test_that(
  "is.integerish(), is.whole() return bool for empty inputs",
  {
    expect_true(is.integerish(numeric(0)))
    expect_true(is.whole(numeric(0)))
  }
)

test_that("is.wholenumber() returns logical(0) for empty inputs", {
  expect_identical(is.wholenumber(numeric(0)), logical(0))
})

test_that("whole functions work on logical, numeric and complex types", {
  for (tst in list(
    1:10, 1L:10, c(1 + 0i, 2 + 0i, NA_complex_), c(TRUE, FALSE, NA)
  )) {
    expect_no_error(is.integerish(tst))
    expect_no_error(is.whole(tst))
    expect_no_error(is.wholenumber(tst))
  }
})

test_that("whole functions error on incorrect types", {
  for (tst in list(
    list(1:10), environment(), mean, data.frame(x = 1), call("mean"),
    c("1", "2", "3"), factor(c("a", "b", "c"))
  )) {
    expect_error(is.integerish(tst))
    expect_error(is.whole(tst))
    expect_error(is.wholenumber(tst))
  }
})

test_that("is.wholenumber() preserves names", {
  x <- c(a = 1, b = 2.5, c = NA_real_, d = Inf, e = NaN)

  expect_named(is.wholenumber(x), names(x))
})

#' @title Add a Class to an Object
#' @description
#' Add a class to an object, either appending to, or replacing, the
#' existing class vector.
#' @param x an **R** object.
#' @param class character vector, or object coercible to character,
#' of one or more class names to add.
#' @param prepend logical. If `TRUE` the new class(es) are
#' prepended to the existing class vector. If `FALSE`, the class
#' vector is replaced entirely.
#' @return The input object `x` with its class attribute updated.
#' @details
#' With `prepend = TRUE`, `addClass()` is equivalent to:
#' ```{r, eval=FALSE}
#' class(x) <- c(class, class(x))
#' x
#' ```
#' With `prepend = FALSE`:
#' ```{r, eval=FALSE}
#' class(x) <- class
#' x
#' ```
#' @seealso [class], [inherits], [is].
#' @examples
#' x <- structure(1, class = "base_class")
#' y <- addClass(x, c("new_class", "another_class"))
#' class(y)
#'
#' y <- addClass(x, c("new_class", "another_class"), prepend = FALSE)
#' class(y)
#' @export
addClass <- function(x, class, prepend = TRUE) {
  if (isTRUE(prepend)) {
    class(x) <- c(class, class(x))
  } else {
    class(x) <- class
  }

  x
}

#' @title Check if Any of Given Vector Types
#' @description
#' Wrapper around [is.vector] that allows the `mode` argument to
#' accept a character vector of multiple specific types. `TRUE`
#' is returned if the given object is **any** of the given types.
#' @param x an **R** object.
#' @param mode character string (or chr vector) naming an atomic mode
#' or `"list"` or `"expression"` or `"any"`. When using `"any"`, it
#' must be given on its own.
#' @return `TRUE` or `FALSE`.
#' @details
#' See [is.vector] for full details and for the types that can be
#' checked with `mode`.
#' @seealso [is.vector], [typeof].
#' @examples
#' x <- c(a = 1, b = 2)
#' isVector(x) # default `mode` is "any"
#'
#' # "any" can't be given with other types.
#' try(isVector(x, mode = c("numeric", "any")))
#'
#' # `TRUE` is returned if *any* of the types are matched.
#' isVector(x, mode = c("character", "list", "logical", "numeric"))
#' isVector(x, mode = c("character", "list", "logical"))
#' @export
isVector <- function(x, mode = "any") {
  if (length(mode) > 1L && "any" %in% mode) {
    stop(
      "In argument ", sQuote("mode"),
      ": 'any' cannot be given with other types."
    )
  }

  for (i in seq_along(mode)) {
    if (is.vector(x, mode = mode[i])) {
      return(TRUE)
    }
  }

  FALSE
}

#' @title Is object of a Date type?
#' @description
#' Tests if an object inherits from some/all of **R**'s date types:
#' `Date`, `POSIXt`, `POSIXct` and `POSIXlt`.
#' @param x an **R** object.
#' @return `TRUE` or `FALSE`.
#' @details
#' `is.datetype` checks if the object inherits from either `Date` or `POSIXt`.
#'
#' `is.Date` checks if the object inherits from `Date`.
#'
#' `is.POSIXt` checks if the object inherits from `POSIXt`.
#'
#' `is.POSIXct` checks if the object inherits from `POSIXct`.
#'
#' `is.POSIXlt` checks if the object inherits from `POSIXlt`.
#' @seealso [as.Date], [as.POSIXct], [as.POSIXlt].
#' @examples
#' a <- "2020-01-01"
#' b <- as.Date("2020-01-01")
#' c <- 123
#'
#' is.Date(a)
#' is.Date(b)
#' is.Date(c)
#'
#' is.Date(as.POSIXct(a))
#' is.POSIXt(as.POSIXct(a))
#' is.POSIXct(as.POSIXct(a))
#' is.POSIXlt(as.POSIXct(a))
#' is.datetype(as.POSIXct(a))
#' @export
is.datetype <- function(x) {
  inherits(x, c("Date", "POSIXt"))
}

#' @rdname is.datetype
#' @export
is.Date <- function(x) {
  inherits(x, "Date")
}

#' @rdname is.datetype
#' @export
is.POSIXt <- function(x) {
  inherits(x, "POSIXt")
}

#' @rdname is.datetype
#' @export
is.POSIXct <- function(x) {
  inherits(x, "POSIXct")
}

#' @rdname is.datetype
#' @export
is.POSIXlt <- function(x) {
  inherits(x, "POSIXlt")
}

#' @title Value Predicates for Common Object Types
#' @description
#' `is.boolean` checks if an object is a single (non-NA) logical value
#' (`TRUE` or `FALSE`).
#'
#' `is.string` checks if an object is a single (non-NA) character string.
#'
#' `nzstring` checks if an object is a single (non-NA) non-empty character
#' string.
#' @param x an object to be tested.
#' @return
#' `TRUE` or `FALSE`.
#' @details
#' The `string` helpers differ slightly from what you *may* expect
#' from base **R** as `NA_character_` is not considered a string.
#' For example:
#' ```{r, eval=TRUE}
#' nzchar(NA_character_)
#' is.string(NA_character_)
#' nzstring(NA_character_)
#' ```
#' @name suppr-predicates
#' @examples
#' is.boolean(TRUE)
#' is.boolean(NA)
#'
#' is.string("hello")
#' is.string(NA_character_)
#' is.string("")
#'
#' nzstring("")
NULL

#' @rdname suppr-predicates
#' @export
is.boolean <- function(x) is.logical(x) && length(x) == 1L && !is.na(x)

#' @rdname suppr-predicates
#' @export
is.string <- function(x) is.character(x) && length(x) == 1L && !is.na(x)

#' @rdname suppr-predicates
#' @export
nzstring <- function(x) {
  is.character(x) && length(x) == 1L && !is.na(x) && nzchar(x)
}

test_that("addClass() prepends classes without modifying the input", {
  x <- structure(1, class = "base_class")

  y <- addClass(x, c("new_class", "another_class"))

  expect_identical(class(y), c("new_class", "another_class", "base_class"))
  expect_identical(class(x), "base_class")
})

test_that("addClass() can replace the class vector", {
  x <- structure(1, class = "base_class")

  y <- addClass(x, c("new_class", "another_class"), prepend = FALSE)

  expect_identical(class(y), c("new_class", "another_class"))
  expect_identical(class(x), "base_class")
})

test_that(
  "isVector() accepts multiple modes and rejects any with other types",
  {
    x <- c(a = 1, b = 2)

    expect_true(isVector(x))
    expect_true(isVector(x, mode = c("character", "list", "numeric")))
    expect_true(isVector(list(x), mode = "list"))
    expect_false(isVector(x, mode = c("character", "logical")))
    expect_error(isVector(x, mode = c("numeric", "any")))
  }
)

test_that("date helpers detect inherited classes", {
  d <- as.Date("2020-01-01")
  ct <- as.POSIXct("2020-01-01 00:00:00", tz = "UTC")
  lt <- as.POSIXlt(ct)

  expect_true(is.datetype(d))
  expect_true(is.datetype(ct))
  expect_true(is.datetype(lt))
  expect_false(is.datetype("2020-01-01"))

  expect_true(is.Date(d))
  expect_false(is.Date(ct))
  expect_false(is.Date(lt))

  expect_true(is.POSIXt(ct))
  expect_true(is.POSIXt(lt))
  expect_false(is.POSIXt(d))

  expect_true(is.POSIXct(ct))
  expect_false(is.POSIXct(lt))
  expect_false(is.POSIXct(d))

  expect_true(is.POSIXlt(lt))
  expect_false(is.POSIXlt(ct))
  expect_false(is.POSIXlt(d))
})

test_that("logical and string helpers validate scalar inputs", {
  expect_true(is.boolean(TRUE))
  expect_true(is.boolean(FALSE))
  expect_false(is.boolean(NA))
  expect_false(is.boolean(c(TRUE, FALSE)))
  expect_false(is.boolean(1))

  expect_true(is.string("hello"))
  expect_true(is.string(""))
  expect_false(is.string(NA_character_))
  expect_false(is.string(c("a", "b")))
  expect_false(is.string(1))

  expect_true(nzstring("hello"))
  expect_false(nzstring(""))
  expect_false(nzstring(NA_character_))
  expect_false(nzstring(c("a", "b")))
})

#' @title Process the `...` arguments of a function.
#' @description
#' `dotsNames` returns the names of the `...` arguments, or a character
#' vector of empty strings if they are unnamed (without evaluating
#' `...`).
#'
#' `subDots` returns the `...` arguments as a list of expressions.
#'
#' `dp1Dots` returns the `...` arguments as a character vector of deparsed
#' expressions.
#'
#' `checkDots` errors or warns about extraneous arguments in the `...`
#' of its caller.
#' @param ... "the dots", as passed from the caller.
#' @param collapse a string, passed to [paste].
#' @param width.cutoff integer in `[20, 500]` determining the cutoff
#' (in bytes) at which line-breaking is tried.
#' @param error a logical value indicating whether to throw an error (`TRUE`)
#' or a warning (`FALSE`) for extraneous arguments.
#' @param which.call passed to [sys.call]. A caller may use `-2` if the
#' message should mention its caller.
#' @param allowed character vector of named elements in `...` which are
#' "allowed" and hence do not cause an error or warning.
#' @return
#' For `dotsNames`, a character vector of the names of the `...` arguments.
#'
#' For `subDots`, a list of expressions.
#'
#' For `dp1Dots`, a character vector of deparsed expressions.
#'
#' For `checkDots`, `NULL` (invisibly), called for its side effects.
#' @details
#' `dotsNames` is an implementation of [allNames] for `...` arguments.
#'
#' `subDots` is a simple wrapper for `as.list(substitute(...()))`.
#'
#' `dp1Dots` applies [deparse1] to each element of `subDots(...)`.
#'
#' `checkDots` is a variation of [chkDots] for use in functions that want
#' to error in case of extraneous arguments, not just warn. `checkDots`
#' also shows whether extraneous arguments are named or unnamed, and if
#' unnamed, the message will show the deparsed expressions of the unnamed
#' arguments. See examples.
#' @seealso [...], [chkDots], [stop], [warning], [substitute], [deparse1].
#' @examples
#' f <- function(...) dotsNames(...)
#' f(1, 2, mean(1:10))
#' f(a = 1, b = 2, mean(1:10))
#'
#' f <- function(...) subDots(...)
#' f(a = 1, b = 2, mean(1:10))
#'
#' f <- function(...) dp1Dots(...)
#' f(a = 1, b = 2, mean(1:10))
#'
#' f <- function(x, ...) checkDots(..., allowed = "b")
#' f(1, b = 1)
#' try(f(1, a = 1, b = 2, mean(1:10)))
#' @name suppr-dots
NULL

#' @rdname suppr-dots
#' @export
dotsNames <- function(...) {
  nms <- ...names()
  if (is.null(nms)) {
    character(...length())
  } else {
    nms
  }
}

#' @rdname suppr-dots
#' @export
subDots <- function(...) {
  as.list(substitute(...()))
}

#' @rdname suppr-dots
#' @export
dp1Dots <- function(..., collapse = " ", width.cutoff = 500L) {
  vapply(
    X = subDots(...),
    FUN = deparse1,
    FUN.VALUE = character(1),
    collapse = collapse,
    width.cutoff = width.cutoff,
    USE.NAMES = TRUE
  )
}

#' @rdname suppr-dots
#' @export
checkDots <- function(
  ...,
  error = TRUE,
  which.call = -1,
  allowed = character(0)
) {
  if (...length() == 0L) {
    return(invisible(NULL))
  }

  stopifnot(is.character(allowed))

  args <- dp1Dots(...)
  dot_names <- dotsNames(...)

  i <- dot_names %notin% allowed
  args <- args[i]

  if (length(args) == 0L) {
    return(invisible(NULL))
  }

  dot_names <- dot_names[i]

  i_named <- nzchar(dot_names)
  named_args <- dot_names[i_named]
  unnamed_args <- args[!i_named]

  call <- paste(
    deparse(sys.call(which.call), control = c()),
    collapse = "\n"
  )

  parts <- character()

  if (le <- length(named_args)) {
    parts <- c(
      parts,
      sprintf(
        ngettext(
          le,
          "extra named argument %s is not allowed",
          "extra named arguments %s are not allowed"
        ),
        paste(sQuote(named_args), collapse = ", ")
      )
    )
  }

  if (le <- length(unnamed_args)) {
    parts <- c(
      parts,
      sprintf(
        ngettext(
          le,
          "extra unnamed argument %s is not allowed",
          "extra unnamed arguments %s are not allowed"
        ),
        paste(sQuote(unnamed_args), collapse = ", ")
      )
    )
  }

  msg <- sprintf(
    "In %s :\n %s.",
    call,
    paste(parts, collapse = ".\n ")
  )

  if (isTRUE(error)) {
    stop(
      errorCondition(
        msg,
        class = c("chkDotsError", "simpleError")
      )
    )
  } else {
    warning(
      warningCondition(
        msg,
        class = c("chkDotsWarning", "simpleWarning")
      )
    )
  }

  invisible(NULL)
}

test_that("dotsNames() returns chr", {
  f <- function(...) dotsNames(...)

  expect_identical(f(), character(0))
  expect_identical(f(, , ), character(3))
  expect_identical(f(1, 2, 3), character(3))
  expect_identical(f(a = 1, b = 2, 3), c("a", "b", ""))
})

test_that("subDots() returns named list", {
  f <- function(...) subDots(...)

  expect_identical(f(), list())
  expect_identical(f(1, 2, 3), list(1, 2, 3))
  expect_identical(f(a = 1, b = 2, 3), list(a = 1, b = 2, 3))
  expect_identical(
    f(1 + 1, x = 10, mean(1:10)),
    list(call("+", 1, 1), x = 10, call("mean", quote(1:10)))
  )
})

test_that("dp1Dots() returns named chr", {
  f <- function(...) dp1Dots(...)

  expect_identical(f(), character(0))
  expect_identical(f(, , ), character(3))
  expect_identical(f(1, 2, 3), c("1", "2", "3"))
  expect_identical(f(a = 1, b = 2, 3), c(a = "1", b = "2", "3"))
  expect_identical(
    f(1 + 1, x = 10, mean(1:10)),
    c("1 + 1", x = "10", "mean(1:10)")
  )
})

test_that("checkDots() warns", {
  f <- function(one, two, ...) checkDots(..., error = FALSE)

  expect_no_warning(f(on = 1, two = 2))
  expect_warning(f(on = 1, twoo = 2))
  expect_no_warning(f(1, 2))
  expect_warning(f(1, 2, 3))
  expect_warning(f(1, 2, x = 1))
  expect_snapshot({
    f(1, 2, 3, x = 1)
  })
})

test_that("checkDots() errors", {
  f <- function(one, two, ...) checkDots(...)

  expect_no_error(f(on = 1, two = 2))
  expect_error(f(on = 1, twoo = 2))
  expect_no_error(f(1, 2))
  expect_error(f(1, 2, 3))
  expect_error(f(1, 2, x = 1))
  expect_snapshot(error = TRUE, {
    f(1, 2, 3, x = 1)
  })
})

test_that("checkDots() ignores allowed named args", {
  f <- function(one, ...) checkDots(..., allowed = letters[1:3])

  expect_no_error(f(1, a = 1))
  expect_error(f(1, 2, b = 3))
  expect_error(f(1, a = 1, b = 2, c = 3, d = 4))
})

#' @title Are any zero char or all whitespace elements present?
#' @description
#' Tests if a character vector contains any zero character
#' or all whitespace elements.
#' @details
#' `anyZchar()` and `anyWS()` return an index immediately when
#' encountering a zero character or a whitespace element,
#' respectively.
#'
#' Whitespace elements are defined as any character that is a
#' space, horizontal tab, carriage return or newline,
#' aka `"[ \t\r\n]"`. See [trimws] for more details and how to
#' instead match all unicode whitespace.
#'
#' `anyZchar()` implements the same definition of a zero char
#' as [`nzchar`].
#'
#' `NA_character_` is not considered zero char or all whitespace.
#' @param x a character vector.
#' @param zchar if `TRUE` then zero character elements
#' will be treated as all whitespace.
#' @return
#' an integer or real vector of length one with value
#' the `1`-based index of the first zero char/all whitespace value
#' if any, otherwise `0`.
#' @note
#' Unlike the similar base functions, these do not coerce
#' the input to character.
#' @seealso [nzchar], [trimws], [anyNF]
#' @examples
#' anyZchar(c("hi", "bye", " ", ""))
#' anyWS(c("hi", "bye", " ", ""))
#' anyWS(c("hi", "bye", "who", ""), zchar = TRUE)
#' @export
anyZchar <- function(x) {
  .Call(C_anyZchar, x)
}

#' @rdname anyZchar
#' @export
anyWS <- function(x, zchar = FALSE) {
  .Call(C_anyWS, x, zchar)
}

test_that("anyZchar() returns the index of the first non-empty string", {
  expect_identical(anyZchar(c("abc", "", "def")), 2L)
  expect_identical(anyZchar(c("", "", "abc")), 1L)
  expect_identical(anyZchar(c("abc", "def")), 0L)
})

test_that("anyZchar() handles empty and NA inputs", {
  expect_identical(anyZchar(character(0)), 0L)
  expect_identical(anyZchar(c(NA_character_, "abc")), 0L)
  expect_identical(anyZchar(c(NA_character_, "", "abc")), 2L)
})

test_that("anyZchar() and anyWS() error on incorrect types", {
  for (tst in list(
    1:10,
    numeric(),
    logical(),
    list(1:10),
    environment(),
    mean,
    data.frame(x = 1),
    factor(c("a", "b", "c")),
    NULL
  )) {
    expect_error(anyZchar(tst))
    expect_error(anyWS(tst))
  }
})


test_that("anyWS() returns the index of the first all-whitespace string", {
  expect_identical(anyWS(c("abc", "   ", "def")), 2L)
  expect_identical(anyWS(c("   ", "abc", "\t")), 1L)
  expect_identical(anyWS(c("abc", "\t\r\n", "def")), 2L)
  expect_identical(anyWS(c("abc", " \t\r\n ", "def")), 2L)
  expect_identical(anyWS(c("abc", "def")), 0L)
})

test_that("anyWS() only matches the trimws() default whitespace characters", {
  expect_identical(anyWS(c("abc", " \t\r\n", "def")), 2L)
  expect_identical(anyWS(c("abc", "foo bar", "def")), 0L)
  expect_identical(anyWS(c("abc", "  foo", "def")), 0L)
  expect_identical(anyWS(c("abc", "foo  ", "def")), 0L)
  expect_identical(anyWS(c("abc", "\u00a0", "def")), 0L)
})

test_that("anyWS() handles empty strings according to empty", {
  expect_identical(anyWS(c("abc", "", "def")), 0L)
  expect_identical(anyWS(c("abc", "", "   ")), 3L)

  expect_identical(anyWS(c("abc", "", "def"), zchar = TRUE), 2L)
  expect_identical(anyWS(c("abc", "", "   "), zchar = TRUE), 2L)
})

test_that("anyWS() handles NA and empty inputs", {
  expect_identical(anyWS(character(0)), 0L)
  expect_identical(anyWS(c(NA_character_, "abc")), 0L)
  expect_identical(anyWS(c(NA_character_, "   ")), 2L)
  expect_identical(anyWS(c(NA_character_, "")), 0L)
  expect_identical(anyWS(c(NA_character_, "")), 0L)
  expect_identical(anyWS(c(NA_character_, ""), zchar = TRUE), 2L)
})

test_that("anyWS() validates the zchar argument", {
  expect_error(anyWS("abc", zchar = NA))
  expect_error(anyWS("abc", zchar = logical()))
  expect_error(anyWS("abc", zchar = c(TRUE, FALSE)))
  expect_error(anyWS("abc", zchar = 1))
  expect_error(anyWS("abc", zchar = "TRUE"))
})

test_that("anyZchar() and anyWS() return 0 for empty input", {
  expect_identical(anyZchar(character(0)), 0L)
  expect_identical(anyWS(character(0)), 0L)
})

#' @title Miscellaneous Helper Functions
#' @description
#' `path()` builds a file path using [file.path], before normalizing
#' the path with [normalizePath].
#'
#' `dims()` returns the dimensions of an object (from [dim]), but for
#' objects without dimensions the length of the object is returned
#' along with `0L` (e.g., `c(length(x), 0L)`).
#'
#' `enumerate` maps a list to each element of a vector, containing the
#' index, value, and name of each element.
#' @param ...
#' character vectors. [Long vectors] are not supported.
#' @param sharedDrive logical, whether the path is on a shared drive.
#' If `TRUE`, then `.Platform$file.sep` is given as the first element
#' of the path, e.g., `"mysd`, `"mydir"` becomes `"\\\\mysd\\mydir"`
#' (on windows).
#' @param mustWork
#' logical: if `TRUE` then an error is given if the result cannot be
#' determined; if `NA` then a warning; if `FALSE` then no error or
#' warning is given.
#' @param x
#' For `dims()`, an **R** object.
#'
#' For `enumerate()`, a vector or list to be enumerated.
#' @return
#' For `path()`, a character string of the expanded, normalized path.
#'
#' For `dims()`, an integer of length 2 or greater that specifies
#' the dimensions of an object.
#'
#' For `enumerate()`, a list of lists, where each inner list has
#' three elements: `idx`, `val`, and `name`, which are the index,
#' value, and name of the corresponding element.
#' @details
#' `path()` will expand paths, see example.
#'
#' Unnamed elements given to `enumerate()` will have an empty string
#' (`""`) as their name.
#' @name suppr-helpers
#' @examples
#' path("path", "expansion", "occurs", mustWork = FALSE)
#' path("mysd", "mydir", sharedDrive = TRUE, mustWork = FALSE)
#'
#' # objects with dimensions give same output as dim():
#' dims(matrix(1:6, nrow = 2))
#'
#' # those without give length and 0:
#' dims(1:5)
#' dims(list(a = 1, b = 2, c = 3))
#'
#' for (x in enumerate(c(a = 1, b = 2, 3))) print(x)
NULL

#' @rdname suppr-helpers
#' @export
path <- function(..., sharedDrive = FALSE, mustWork = NA) {
  if (isTRUE(sharedDrive)) {
    normalizePath(file.path(.Platform$file.sep, ...), mustWork = mustWork)
  } else {
    normalizePath(file.path(...), mustWork = mustWork)
  }
}

#' @rdname suppr-helpers
#' @export
dims <- function(x) {
  if (is.null(dm <- dim(x))) {
    c(length(x), 0L)
  } else {
    dm
  }
}

#' @rdname suppr-helpers
#' @export
enumerate <- function(x) {
  Map(list, idx = seq_along(x), val = x, name = methods::allNames(x))
}

#' @title Create an Empty list of Given Length
#' @description For a given length, create an empty list of that length.
#' @param length integer, specified length of the output list.
#' @return an empty list of given length.
#' @details This is a simple wrapper of `vector("list", length)` with a
#' clearer naming convention.
#' @seealso [vector], [na.vector]
#' @examples
#' empty.list()
#' empty.list(5L)
#' empty.list(length = 3L)
#' @export
empty.list <- function(length = 0L) {
  vector("list", length = length)
}

test_that("enumerate() pairs indices with values", {
  x <- c(alpha = "a", beta = "b", "c")

  expect_identical(
    enumerate(x),
    list(
      list(idx = 1L, val = "a", name = "alpha"),
      list(idx = 2L, val = "b", name = "beta"),
      list(idx = 3L, val = "c", name = "")
    )
  )
  expect_identical(enumerate(character()), list())
})

test_that("dims() returns dimensions or length and 0", {
  expect_identical(dims(matrix(1:6, nrow = 2)), c(2L, 3L))
  expect_identical(dims(array(1:8, dim = c(2, 2, 2))), c(2L, 2L, 2L))
  expect_identical(dims(1:5), c(5L, 0L))
  expect_identical(dims(list(a = 1, b = 2, c = 3)), c(3L, 0L))
})

test_that("path() combines and normalizes path components", {
  expect_identical(
    path("foo", "bar", mustWork = FALSE),
    normalizePath(file.path("foo", "bar"), mustWork = FALSE)
  )

  expect_identical(
    path("foo", "bar", "baz.txt", mustWork = FALSE),
    normalizePath(file.path("foo", "bar", "baz.txt"), mustWork = FALSE)
  )

  expect_identical(
    path("foo", "bar", mustWork = FALSE),
    normalizePath(file.path("foo", "bar"), mustWork = FALSE)
  )

  expect_identical(
    path("foo", "bar", "baz.txt", mustWork = FALSE),
    normalizePath(file.path("foo", "bar", "baz.txt"), mustWork = FALSE)
  )

  expect_identical(
    path("foo", "bar", "baz.txt", sharedDrive = TRUE, mustWork = FALSE),
    normalizePath(
      file.path(.Platform$file.sep, "foo", "bar", "baz.txt"),
      mustWork = FALSE
    )
  )
})

#' @title Apply a predicate function over a list or vector
#' @description
#' Returns a logical of the same length as `X`, each element of which is
#' the result of applying predicate `FUN` to the corresponding element
#' of `X.`
#' @param X a vector (atomic or list) or an expression object.
#' Other objects (including classed objects) will be coerced by
#' [`as.list`].
#' @param FUN a predicate function to be applied to each element of
#' `X` that returns a single logical value.
#' @param ... optional arguments to `FUN`.
#' @param reduce `NULL` or one of `"all"`, `"any"`, or `"none"`. When
#' non-`NULL`, the output logical vector is reduced to a single boolean
#' value using [all], [any] or `"none"` (implemented as `all(!logi)`).
#' @param na.as logical value to return for `NA` values in the output logical
#' vector (`NA`, `TRUE` or `FALSE`).
#' @details
#' `na.as` is most meaningful when `reduce` is non-`NULL`, as it allows control
#' flow calls (e.g., `if (predapply(...))`) to proceed without error.
#' See examples.
#' @return logical vector or boolean if `reduce` is non-`NULL`.
#' @seealso [apply], [lapply], [mapply], [all], [any].
#' @examples
#' x <- list(a = 1, b = 2, c = NA)
#' predapply(x, is.numeric)
#' predapply(x, is.numeric, reduce = "any")
#'
#' x <- list(a = 1, b = 2, c = 3)
#' predapply(x, is.numeric, reduce = "all")
#'
#' x <- list(a = "1", b = "2", c = "3")
#' predapply(x, is.numeric, reduce = "none")
#'
#' x <- c(1, 2, NA)
#' predapply(x, function(x) x > 0)
#' predapply(x, function(x) x > 0, reduce = "all")
#' predapply(x, function(x) x > 0, reduce = "all", na.as = TRUE)
#' @export
predapply <- function(X, FUN, ..., reduce = NULL, na.as = NA) {
  logi <- vapply(
    X = X,
    FUN = FUN,
    FUN.VALUE = logical(1),
    ...,
    USE.NAMES = TRUE
  )

  if (!is.na(na.as)) {
    stopifnot(is.logical(na.as) && length(na.as) == 1L)
    logi[is.na(logi)] <- na.as
  }

  if (!is.null(reduce)) {
    reduce <- match.arg(reduce, c("all", "any", "none"))

    logi <- switch(reduce,
      all = all(logi),
      any = any(logi),
      none = all(!logi)
    )
  }

  logi
}

test_that("predapply() returns element-wise logical output", {
  x_list <- list(a = 1, b = 2, c = "z")
  expect_identical(
    predapply(x_list, is.numeric),
    c(a = TRUE, b = TRUE, c = FALSE)
  )

  x_vec <- c(a = 1, b = 2, c = 3)
  expect_identical(
    predapply(x_vec, function(x) x > 1),
    c(a = FALSE, b = TRUE, c = TRUE)
  )
})

test_that("predapply() forwards ... to FUN", {
  x <- list("a", "bb", "ccc")

  expect_identical(
    predapply(x, function(x, n) nchar(x) >= n, n = 2),
    c(FALSE, TRUE, TRUE)
  )
})

test_that("predapply() na.as controls missing values in output", {
  x <- c(1, NA, 2)
  pred <- function(x) x > 0

  expect_identical(predapply(x, pred), c(TRUE, NA, TRUE))
  expect_identical(predapply(x, pred, na.as = FALSE), c(TRUE, FALSE, TRUE))
  expect_identical(predapply(x, pred, na.as = TRUE), c(TRUE, TRUE, TRUE))

  x_all <- c(1, NA)

  expect_identical(predapply(x_all, pred, reduce = "all"), NA)
  expect_identical(predapply(x_all, pred, reduce = "all", na.as = FALSE), FALSE)
  expect_identical(predapply(x_all, pred, reduce = "all", na.as = TRUE), TRUE)

  x_any_none <- c(-1, NA)

  expect_identical(
    predapply(x_any_none, pred, reduce = "any"),
    NA
  )
  expect_identical(
    predapply(x_any_none, pred, reduce = "any", na.as = FALSE),
    FALSE
  )
  expect_identical(
    predapply(x_any_none, pred, reduce = "any", na.as = TRUE), TRUE
  )

  expect_identical(
    predapply(x_any_none, pred, reduce = "none"),
    NA
  )
  expect_identical(
    predapply(x_any_none, pred, reduce = "none", na.as = FALSE),
    TRUE
  )
  expect_identical(
    predapply(x_any_none, pred, reduce = "none", na.as = TRUE),
    FALSE
  )
})

test_that("predapply() reduce supports all/any/none", {
  x <- list(a = 1, b = "x", c = 2)

  expect_identical(predapply(x, is.numeric, reduce = "all"), FALSE)
  expect_identical(predapply(x, is.numeric, reduce = "any"), TRUE)
  expect_identical(predapply(x, is.numeric, reduce = "none"), FALSE)

  y <- list("a", "b")
  expect_identical(predapply(y, is.numeric, reduce = "all"), FALSE)
  expect_identical(predapply(y, is.numeric, reduce = "any"), FALSE)
  expect_identical(predapply(y, is.numeric, reduce = "none"), TRUE)
})


test_that("predapply() validates reduce, na.as and FUN output shape", {
  expect_error(predapply(1:3, is.numeric, reduce = "invalid"))
  expect_error(predapply(1:3, is.numeric, na.as = "FALSE"))
  expect_error(predapply(1:3, is.numeric, na.as = c(TRUE, FALSE)))
  expect_snapshot(error = TRUE, {
    predapply(1:3, is.numeric, reduce = "invalid")
  })

  expect_error(predapply(1:3, function(x) c(TRUE, FALSE)))
  expect_error(predapply(1:3, function(x) 1L))
})

#' @title Are non-finite values present?
#' @description
#' Tests if a vector contains non-finite values
#' (`Inf`, `-Inf`, `NaN`, or `NA`).
#' @details
#' `is.nonfinite()` (and alias `is.nf()`) check for non-finite
#' values, returning a logical vector of the same length as `x`,
#' whereas `anyNF()` returns an index immediately when encountering
#' a non-finite value.
#'
#' `is.nonfinite()` and `anyNF()` are S3 generics, so custom
#' methods can be defined for different object types.
#'
#' Similar to `is.finite()` semantics, `is.nonfinite()` returns all
#' `TRUE` for character and raw vectors, and `anyNF()` returns `1L`.
#' @param x
#' **R** object to be tested: the default methods handle atomic vectors.
#' @return
#' For `is.nonfinite()` and `is.nf()`, a logical vector of the same
#' length as `x`.
#'
#' For `anyNF()`, an integer or real vector of length one with value
#' the `1`-based index of the first non-finite value if any,
#' otherwise `0`.
#' @note
#' For character vectors use [is.na] and [anyNA].
#' @seealso [is.finite], [is.whole], [anyZchar], [anyWS]
#' @examples
#' is.nonfinite(1:10)
#' anyNF(1:10)
#'
#' is.nonfinite(c(1, 2, NA, 4))
#' anyNF(c(1, 2, NA, 4))
#'
#' is.nonfinite(c(1, 2, NaN, 4))
#' anyNF(c(1, 2, NaN, 4))
#'
#' is.nonfinite(c(1, 2, Inf, 4))
#' anyNF(c(1, 2, Inf, 4))
#'
#' is.nf(c(1, 2, -Inf, 4))
#' anyNF(c(1, 2, -Inf, 4))
#' @export
is.nonfinite <- function(x) {
  UseMethod("is.nonfinite")
}

#' @export
is.nonfinite.default <- function(x) {
  .Call(C_is_nonfinite, x)
}

#' @export
is.nonfinite.POSIXlt <- function(x) {
  is.nonfinite(as.POSIXct(x))
}

#' @rdname is.nonfinite
#' @export
is.nf <- is.nonfinite

#' @rdname is.nonfinite
#' @export
anyNF <- function(x) {
  UseMethod("anyNF")
}

#' @export
anyNF.default <- function(x) {
  .Call(C_anyNF, x)
}

#' @export
anyNF.POSIXlt <- function(x) {
  anyNF(as.POSIXct(x))
}

#' @title Set given indices as NA
#' @description For given `indices`, set those indices of an object as `NA`.
#' @param x an **R** object.
#' @param indices integer vector of indices to set as `NA`.
#' @param value integer vector of indices to set as `NA` for the replacement
#' function.
#' @return the modified object with given indices set to `NA`.
#' @details
#' This function is a S3 generic. The default method sets indices
#' to `NA` using `[<-`, passing the indices first to [`arrayInd`]
#' if the input has a non-`NULL` `dim` attribute.
#'
#' The `setNA<-` function is meant to be a direct replacement for `is.na<-`
#' with (in my opinion) a clearer naming convention. The base methods are
#' implemented verbatim (for [factor] and [numeric_version] objects),
#' whereas the default method differs by using `arrayInd` (see above),
#' whereas `is.na<-` is implemented just as `x[value] <- NA`.
#' @note
#' Complex inputs will have indices set to `NA_complex_`, meaning that
#' both the real and imaginary parts will be set to `NA`, not just the
#' real part which can happen (depending on **R** version) with
#' `x_complex[indices] <- NA`.
#' @seealso [`is.na<-`], [whichNA]
#' @examples
#' setNA(1:5, c(1, 4))
#' setNA(c("hi", "hello", "bye", "goodbye"), c(1, 4))
#' setNA(matrix(1:4, 2, 2), c(1, 4))
#' setNA(list(1, 2, 3, list(1, 2)), c(1, 4))
#'
#' x <- 1:10
#' setNA(x) <- c(1, 7, 9)
#' x
#' @export
setNA <- function(x, indices) {
  UseMethod("setNA")
}

#' @export
setNA.default <- function(x, indices) {
  if (!is.null(dm <- dim(x))) {
    x[arrayInd(indices, dm)] <- NA
  } else {
    x[indices] <- NA
  }

  x
}

#' @export
setNA.complex <- function(x, indices) {
  # need explicit complex path with due to incosistencies
  # between versions and changes in R behaviour, for example:
  # https://bugs.r-project.org/show_bug.cgi?id=18918&_ts=1786270162
  # https://stat.ethz.ch/pipermail/r-devel/2023-November/083011.html
  # other types auto convert consistently so we don't worry
  if (!is.null(dm <- dim(x))) {
    x[arrayInd(indices, dm)] <- NA_complex_
  } else {
    x[indices] <- NA_complex_
  }

  x
}

#' @rdname setNA
#' @export
`setNA<-` <- function(x, value) {
  UseMethod("setNA<-")
}

#' @export
`setNA<-.default` <- function(x, value) {
  if (!is.null(dm <- dim(x))) {
    x[arrayInd(value, dm)] <- NA
  } else {
    x[value] <- NA
  }

  x
}

#' @export
`setNA<-.complex` <- function(x, value) {
  if (!is.null(dm <- dim(x))) {
    x[arrayInd(value, dm)] <- NA_complex_
  } else {
    x[value] <- NA_complex_
  }

  x
}

#' @export
`setNA<-.factor` <- function(x, value) {
  lx <- levels(x)
  cx <- oldClass(x)
  class(x) <- NULL
  x[value] <- NA
  structure(x, levels = lx, class = cx)
}

#' @export
`setNA<-.numeric_version` <- function(x, value) {
  x[value] <- list(integer())
  x
}

#' @title Create a vector of NA's
#' @description For a given type and length, create a vector of `NA`'s.
#' @param length integer, length of the output vector.
#' @param type character string naming an atomic type that has an
#' equivalent `NA` value (i.e., not [raw]), or `"list"`.
#' @details This function also offers a `"list"` type, which gives a list
#' of single (logical) `NA` values. To initialize an empty list (of `NULL`'s)
#' of a given length, use [empty.list] instead.
#' @return vector of given mode and length filled with `NA` values.
#' @seealso [vector], [whichNA], [setNA]
#' @examples
#' na.vector(5L)
#' x <- na.vector(3L, "character")
#' class(x)
#'
#' x <- complex(1:5, 6:10)
#' y <- na.vector(length(x), typeof(x))
#' class(y)
#' length(y)
#'
#' na.vector(2L, "list")
#' @export
na.vector <- function(
  length = 1L,
  type = c(
    "logical", "integer", "double",
    "character", "complex", "numeric",
    "list"
  )
) {
  type <- match.arg(
    type,
    c(
      "logical", "integer", "double",
      "character", "complex", "numeric",
      "list"
    )
  )

  if (type != "list") {
    x <- switch(type,
      logical = NA,
      integer = NA_integer_,
      double = NA_real_,
      character = NA_character_,
      complex = NA_complex_,
      numeric = NA_real_
    )

    rep.int(x, length)
  } else {
    as.list(rep.int(NA, length))
  }
}

#' @title Refill the NAs for a 'na.action' Object
#' @description
#' For a [na.action] object, use the indices of where `NA`s were removed
#' to refill the object back to its original size with `NA`s in the
#' appropriate positions.
#' @param object a [na.action] object (atomic vector, matrix or data.frame).
#' @param ... further arguments special methods could require.
#' @details For objects where [na.omit] removes whole rows (e.g., matrices,
#' data.frames), the information about that row is lost, so `na.refill`
#' will refill those **entire rows** with `NA`s.
#' @return vector, matrix or data.frame with the indices from `na.action`
#' refilled with `NA`s. [rownames] and [colnames] are preserved.
#'
#' If the object given is not of those types, or not a `na.action` object,
#' it is returned unchanged.
#' @seealso [na.action], [na.omit]
#' @examples
#' x <- c(1, 2, NA, 4, NA, 6)
#' na_x <- na.omit(x)
#' na_x
#' na.refill(na_x)
#'
#' m <- matrix(1:9, 3, 3)
#' m[c(1, 3), 1:2] <- NA
#' dimnames(m) <- list(c("r1", "r2", "r3"), c("a", "b", "c"))
#' na_m <- na.omit(m)
#' na_m
#' na.refill(na_m) # previous data in NA row is lost
#'
#' df <- data.frame(x = 1:5, y = c("a", NA, "c", "d", NA))
#' na_df <- na.omit(df)
#' na_df
#' na.refill(na_df)
#' @export
na.refill <- function(object, ...) {
  UseMethod("na.refill")
}

#' @export
na.refill.default <- function(object, ...) {
  chkDots(...)
  # only handle atomic vectors with na.action class
  if (!is.atomic(object)) {
    return(object)
  }
  na_locs <- stats::na.action(object) %||% return(object)
  le <- length(object) + length(na_locs)
  out <- rep(NA, le)
  out[-na_locs] <- object

  curr_nms <- names(object)
  # only redo names if they still exist
  if (!is.null(curr_nms)) {
    na_names <- names(na_locs)
    nms <- character(le)
    nms[na_locs] <- na_names
    nms[-na_locs] <- curr_nms
    names(out) <- nms
  }

  attr(out, "na.action") <- attr(object, "na.action")
  class(attr(out, "na.action")) <- "refilled"
  out
}

#' @export
na.refill.matrix <- function(object, ...) {
  chkDots(...)
  na_locs <- stats::na.action(object) %||% return(object)
  n <- nrow(object) + length(na_locs)

  out <- matrix(
    na.vector(1L, typeof(object)),
    nrow = n,
    ncol = ncol(object)
  )
  out[-na_locs, ] <- object

  dmn <- dimnames(object)
  # only redo names if they still exist
  if (!is.null(dmn)) {
    # only need to do row names as only these could have been dropped by na.omit
    if (!is.null(dmn[[1]])) {
      rn <- character(n)
      rn[na_locs] <- names(na_locs)
      rn[-na_locs] <- rownames(object)
      dimnames(out) <- list(rn, colnames(object))
    }
  }

  attr(out, "na.action") <- attr(object, "na.action")
  class(attr(out, "na.action")) <- "refilled"
  out
}

#' @export
na.refill.data.frame <- function(object, ...) {
  chkDots(...)
  na_locs <- stats::na.action(object) %||% return(object)

  curr_rn <- attr(object, "row.names")
  # row.names should always exist
  if (is.null(curr_rn)) {
    stop("data.frame should have row.names attribute")
  }

  nr <- nrow(object)
  n <- nr + length(na_locs)

  # this [ indexing keeps attr so we don't need to add,
  # just rename the na.action class
  out <- object[NA, , drop = FALSE]
  out[n, ] <- NA
  out[-na_locs, ] <- object

  na_names <- names(na_locs)
  rn <- if (i <- is.character(curr_rn)) character(n) else integer(n)
  rn[na_locs] <- if (i) na_names else as.integer(na_names)
  # attr for integer rownames
  rn[-na_locs] <- curr_rn
  row.names(out) <- rn

  class(attr(out, "na.action")) <- "refilled"
  out
}

test_that("is.nonfinite() detects non-finite values", {
  expect_identical(is.nonfinite(1:5), rep(FALSE, 5))
  expect_identical(
    is.nonfinite(c(1, 2, NA_real_, Inf, NaN)),
    c(FALSE, FALSE, TRUE, TRUE, TRUE)
  )
  expect_identical(is.nonfinite(c(1, 2, -Inf)), c(FALSE, FALSE, TRUE))
  expect_identical(is.nonfinite(c(1, 2, 3)), c(FALSE, FALSE, FALSE))
  expect_identical(is.nonfinite(c(1 + 0i, NA + 0i)), c(FALSE, TRUE))
  expect_identical(is.nonfinite(c(1L, NA_integer_)), c(FALSE, TRUE))
  expect_identical(is.nonfinite(c(TRUE, FALSE, NA)), c(FALSE, FALSE, TRUE))
})

test_that("is.nonfinite() returns 0 for empty inputs", {
  expect_identical(is.nonfinite(numeric(0)), logical(0))
})

test_that("is.nonfinite() works on logical, numeric and complex types", {
  for (tst in list(
    1:10, 1L:10, c(1 + 0i, 2 + 0i, NA_complex_), c(TRUE, FALSE, NA),
    factor(c("a", "b", "c"))
  )) {
    expect_no_error(is.nonfinite(tst))
  }
})

test_that("is.nonfinite() returns all TRUE for chr, raw", {
  for (tst in list(letters, raw(26))) {
    expect_identical(is.nonfinite(tst), rep(TRUE, 26))
  }
})

test_that("is.nonfinite() errors on incorrect types", {
  for (tst in list(
    list(1:10), environment(), mean, data.frame(x = 1), call("mean")
  )) {
    expect_error(is.nonfinite(tst))
  }

  expect_snapshot(error = TRUE, {
    is.nonfinite(tst)
  })
})

test_that("is.nonfinite() works on POSIXlt objects", {
  x <- as.POSIXlt(c("2020-01-01", "2020-01-02", NA))
  expect_identical(is.nonfinite(x), c(FALSE, FALSE, TRUE))
})

test_that("anyNF() detects non-finite values", {
  expect_identical(anyNF(1:5), 0L)
  expect_identical(anyNF(c(1, 2, NA_real_, Inf, NaN)), 3L)
  expect_identical(anyNF(c(1, 2, -Inf)), 3L)
  expect_identical(anyNF(c(1, 2, 3)), 0L)
  expect_identical(anyNF(c(1 + 0i, NA + 0i)), 2L)
  expect_identical(anyNF(c(1L, NA_integer_)), 2L)
  expect_identical(anyNF(c(TRUE, FALSE, NA)), 3L)
})

test_that("anyNF() returns 0 for empty inputs", {
  expect_identical(anyNF(numeric(0)), 0L)
})

test_that("anyNF() works on logical, numeric and complex types", {
  for (tst in list(
    1:10, 1L:10, c(1 + 0i, 2 + 0i, NA_complex_), c(TRUE, FALSE, NA),
    factor(c("a", "b", "c"))
  )) {
    expect_no_error(anyNF(tst))
  }
})

test_that("anyNF() returns all 1L for chr, raw", {
  for (tst in list(letters, raw(26))) {
    expect_identical(anyNF(tst), 1L)
  }
})

test_that("anyNF() errors on incorrect types", {
  for (tst in list(
    list(1:10), environment(), mean, data.frame(x = 1), call("mean")
  )) {
    expect_error(anyNF(tst))
  }

  expect_snapshot(error = TRUE, {
    anyNF(tst)
  })
})

test_that("anyNF() works on POSIXlt objects", {
  x <- as.POSIXlt(c("2020-01-01", "2020-01-02", NA))
  expect_identical(anyNF(x), 3L)
})

test_that("setNA() tests", {
  expect_identical(
    setNA(1:5, c(2, 4)),
    c(1L, NA_integer_, 3L, NA_integer_, 5L)
  )

  m <- matrix(1:9, nrow = 3, ncol = 3)
  expect_equal(
    setNA(m, c(1, 5, 9)),
    matrix(c(NA, 2, 3, 4, NA, 6, 7, 8, NA), nrow = 3, ncol = 3)
  )

  x <- letters[1:4]
  setNA(x) <- c(1, 3)
  expect_identical(x, c(NA_character_, "b", NA_character_, "d"))

  lst <- list(1, 2, 3)
  expect_identical(setNA(lst, 2), list(1, NA, 3))
})

test_that("setNA() works for vector types", {
  expect_identical(setNA(1:5, 2), c(1L, NA_integer_, 3L, 4L, 5L))
  expect_identical(setNA(c(TRUE, FALSE), 1), c(NA, FALSE))
  expect_identical(setNA(c(1.5, 2.5), 2), c(1.5, NA_real_))
  expect_identical(setNA(c("a", "b"), 1), c(NA_character_, "b"))
  expect_identical(setNA(c(1 + 0i, 2 + 0i), 2), c(1 + 0i, NA_complex_))
})

test_that("setNA() works for types with dims", {
  m <- matrix(1:4, nrow = 2, ncol = 2)
  expect_identical(
    setNA(m, c(1, 4)),
    matrix(c(NA_integer_, 2L, 3L, NA_integer_), nrow = 2, ncol = 2)
  )

  df <- data.frame(x = 1:3, y = c("a", "b", "c"))
  expect_identical(
    setNA(df, c(2, 5)),
    data.frame(x = c(1L, NA, 3L), y = c("a", NA_character_, "c"))
  )

  arr <- array(1:8, dim = c(2, 2, 2))
  expect_identical(
    setNA(arr, 3),
    array(c(1L, 2L, NA, 4L, 5L, 6L, 7L, 8L), dim = c(2, 2, 2))
  )
})

test_that("setNA<-() works for vector types", {
  x <- 1:5
  setNA(x) <- c(2, 4)
  expect_identical(x, c(1L, NA_integer_, 3L, NA_integer_, 5L))

  y <- c(TRUE, FALSE)
  setNA(y) <- 1
  expect_identical(y, c(NA, FALSE))

  z <- c("a", "b")
  setNA(z) <- 2
  expect_identical(z, c("a", NA_character_))
})

test_that("setNA<-() works for types with dims", {
  m <- matrix(1:4, nrow = 2, ncol = 2)
  setNA(m) <- c(1, 4)
  expect_identical(
    m,
    matrix(c(NA_integer_, 2L, 3L, NA_integer_), nrow = 2, ncol = 2)
  )

  df <- data.frame(x = 1:3, y = c("a", "b", "c"))
  setNA(df) <- c(2, 5)
  expect_identical(
    df,
    data.frame(x = c(1L, NA, 3L), y = c("a", NA_character_, "c"))
  )

  arr <- array(1:8, dim = c(2, 2, 2))
  setNA(arr) <- 3
  expect_identical(
    arr,
    array(c(1L, 2L, NA, 4L, 5L, 6L, 7L, 8L), dim = c(2, 2, 2))
  )
})

test_that("na.vector() tests", {
  types <- c(
    "logical", "integer", "double",
    "numeric", "character", "complex",
    "list"
  )

  for (type in types) {
    out <- na.vector(3L, type)
    expect_length(out, 3L)
    expect_type(out, if (type == "numeric") "double" else type)
    expect_true(all(is.na(out)))
  }
})

test_that("na.vector() errors on unsupported types", {
  expect_error(na.vector(3L, "raw"))
  expect_error(na.vector(3L, "data.frame"))
  expect_error(na.vector(3L, "function"))
})

test_that("na.refill() for vectors", {
  x <- c(1, 2, NA, 4, NA, 6)
  na_x <- na.omit(x)
  out <- na.refill(na_x)

  expect_identical(
    out,
    c(1, 2, NA, 4, NA, 6),
    ignore_attr = "na.action"
  )

  expect_identical(
    unclass(attr(out, "na.action")),
    unclass(attr(na_x, "na.action"))
  )
  expect_s3_class(attr(out, "na.action"), "refilled")

  x_named <- stats::setNames(x, paste0("v", seq_along(x)))
  na_x_named <- na.omit(x_named)
  out_named <- na.refill(na_x_named)

  expect_identical(out_named, x_named, ignore_attr = "na.action")
  expect_identical(names(out_named), names(x_named))

  # no re-naming if names removed after na.omit
  x_named <- stats::setNames(x, paste0("v", seq_along(x)))
  na_x_named <- na.omit(x_named)
  names(na_x_named) <- NULL
  expect_null(names(na.refill(na_x_named)))

  expect_identical(na.refill(1:3), 1:3)
  expect_identical(
    na.refill(list(1, NA, 3)),
    list(1, NA, 3)
  )
})

test_that("na.refill() for matrices", {
  m <- matrix(1:9, 3, 3)
  m[c(1, 3), 1:2] <- NA
  dimnames(m) <- list(c("r1", "r2", "r3"), c("a", "b", "c"))

  na_m <- na.omit(m)
  out <- na.refill(na_m)

  expect_identical(dim(out), dim(m))
  expect_identical(colnames(out), colnames(m))
  expect_identical(rownames(out), rownames(m))
  expect_true(all(is.na(out[c(1, 3), ])))
  expect_identical(out[2, ], m[2, ])
  expect_identical(
    unclass(attr(out, "na.action")),
    unclass(attr(na_m, "na.action"))
  )
  expect_s3_class(attr(out, "na.action"), "refilled")

  m <- matrix(1:9, 3, 3)
  m[c(1, 3), 1] <- NA
  na_m <- na.omit(m)
  out <- na.refill(na_m)

  expect_null(dimnames(out))
  expect_true(all(is.na(out[c(1, 3), ])))

  m <- matrix(1:9, 3, 3)
  m[c(1, 3), 1:2] <- NA
  dimnames(m) <- list(NULL, c("a", "b", "c"))
  na_m <- na.omit(m)
  expect_null(rownames(na.refill(na_m)))

  # no re-naming if names removed after na.omit
  m <- matrix(1:9, 3, 3)
  m[c(1, 3), 1:2] <- NA
  dimnames(m) <- list(c("r1", "r2", "r3"), c("a", "b", "c"))
  na_m <- na.omit(m)
  rownames(na_m) <- NULL
  expect_null(rownames(na.refill(na_m)))

  expect_identical(
    na.refill(matrix(1:4, 2, 2)),
    matrix(1:4, 2, 2)
  )
})

test_that("na.refill() for data.frames", {
  df <- data.frame(
    x = 1:5,
    y = c("a", NA, "c", "d", NA),
    stringsAsFactors = FALSE
  )

  na_df <- na.omit(df)
  out <- na.refill(na_df)

  expect_identical(colnames(out), colnames(df))
  expect_identical(rownames(out), rownames(df))
  expect_identical(out[["x"]], c(1L, NA, 3L, 4L, NA))
  expect_identical(out[["y"]], df[["y"]])
  expect_true(all(is.na(out[c(2, 5), ])))
  expect_identical(
    unclass(attr(out, "na.action")),
    unclass(attr(na_df, "na.action"))
  )
  expect_s3_class(attr(out, "na.action"), "refilled")

  nna_sub <- df[c(1, 3, 4), ]
  nna_sub_refill <- out[c(1, 3, 4), ]
  expect_identical(nna_sub_refill, nna_sub, ignore_attr = "na.action")

  df <- data.frame(a = c(1, NA, 3), b = c("x", NA, "z"))
  rownames(df) <- c("r1", "r2", "r3")
  na_df <- na.omit(df)
  out <- na.refill(na_df)

  expect_identical(out, df, ignore_attr = "na.action")
  expect_identical(rownames(out), rownames(df))

  # error if row.names missing
  df <- data.frame(a = c(1, NA, 3), b = c("x", NA, "z"))
  rownames(df) <- c("r1", "r2", "r3")
  na_df <- na.omit(df)
  attr(na_df, "row.names") <- NULL
  expect_error(na.refill(na_df))

  expect_identical(na.refill(data.frame(a = 1:2)), data.frame(a = 1:2))
})

#' @title Ensure the Truth of R Expressions with Call Information
#' @description
#' Wrapper around [stopifnot] that leaves only the `...` argument and
#' adds a `call.` argument that shows a call in the message that
#' is derived from the call stack. `warningifnot()` implements the same
#' functionality but produces a warning instead of an error.
#' @param ... any number of **R** expressions, which should each evaluate
#' to (a logical vector of [all]) [`TRUE`]. If named, the names will be used
#' in lieu of the default error/warning message.
#' @inheritParams stop2 call.
#' @param warn.all logical, indicating if all failed expressions should produce
#' warnings, or only the first failed expression. Default is `FALSE`,
#' which means only the first failed expression will produce a warning.
#' @return Called for side effects only.
#' @details
#' If any of the expressions are not [all] `TRUE`, [stop] or [warning]
#' is called, producing an error/warning message indicating the first
#' (or all, if `warn.all = TRUE` for `warningifnot()`) expression
#' which was not ([all]) true. See [stopifnot] for full details.
#'
#' Special care must be taken for handlers on the call stack, as they
#' may affect the call displayed in the error or warning message. In
#' such instances, passing an environment to `call.` may be helpful.
#' @seealso [stopifnot.with] for a data-masked version of this function.
#' @examples
#' f1 <- function(call.) stopifnot2(1 == 2, call. = call.)
#' f2 <- function(call.) f1(call. = call.)
#' f <- function(call.) f2(call. = call.)
#'
#' try(f(call. = FALSE))
#' try(f(call. = TRUE))
#'
#' try(f(call. = 0))
#' try(f(call. = 1))
#' try(f(call. = 2))
#'
#' f <- function() {
#'   e <- environment()
#'   f1(call. = e)
#' }
#'
#' try(f())
#'
#' try(stopifnot2(all.equal(1, 2)))
#'
#' warningifnot(1 == 2, 2 == 3)
#' warningifnot(1 == 2, 2 == 3, warn.all = TRUE)
#' @export
stopifnot2 <- function(..., call. = TRUE) {
  n <- ...length()
  for (i in seq_len(n)) {
    r <- ...elt(i)

    if (!(is.logical(r) && !anyNA(r) && all(r))) {
      dots <- match.call()[-1L]

      if (is.null(msg <- names(dots)) || !nzchar(msg <- msg[i])) {
        cl.i <- dots[[i]]

        msg <- if (
          is.call(cl.i) && identical(cl.i[[1]], quote(all.equal)) &&
            (
              is.null(ni <- names(cl.i)) || length(cl.i) == 3L ||
                length(cl.i <- cl.i[!nzchar(ni)]) == 3L
            )
        ) {
          sprintf(
            gettext("%s and %s are not equal:\n  %s"),
            Dparse(cl.i[[2]]),
            Dparse(cl.i[[3]]),
            abbrev(r)
          )
        } else {
          le <- length(r)
          if (le == 0L) le <- 1L

          sprintf(
            ngettext(
              le,
              "%s is not TRUE",
              "%s are not all TRUE"
            ),
            Dparse(cl.i)
          )
        }
      }

      call. <- get_call.(call.)
      stop(simpleError(msg, call = call.))
    }
  }

  invisible()
}

#' @rdname stopifnot2
#' @export
warningifnot <- function(..., warn.all = FALSE, call. = TRUE) {
  n <- ...length()
  # anything other than exactly TRUE breaks at first fail
  warn.first.only <- !isTRUE(warn.all)

  for (i in seq_len(n)) {
    r <- ...elt(i)

    if (!(is.logical(r) && !anyNA(r) && all(r))) {
      dots <- match.call()[-1L]

      if (is.null(msg <- names(dots)) || !nzchar(msg <- msg[i])) {
        cl.i <- dots[[i]]

        msg <- if (
          is.call(cl.i) && identical(cl.i[[1]], quote(all.equal)) &&
            (
              is.null(ni <- names(cl.i)) || length(cl.i) == 3L ||
                length(cl.i <- cl.i[!nzchar(ni)]) == 3L
            )
        ) {
          sprintf(
            gettext("%s and %s are not equal:\n  %s"),
            Dparse(cl.i[[2]]),
            Dparse(cl.i[[3]]),
            abbrev(r)
          )
        } else {
          le <- length(r)
          if (le == 0L) le <- 1L

          sprintf(
            ngettext(
              le,
              "%s is not TRUE",
              "%s are not all TRUE"
            ),
            Dparse(cl.i)
          )
        }
      }

      if (i == 1L) {
        call. <- get_call.(call.)
      }

      warning(simpleWarning(.makeMessage(msg), call = call.))

      if (warn.first.only) {
        break
      }
    }
  }

  invisible()
}

#' @title Ensure the Truth of R Expressions in a Data Environment
#' @description
#' Wrapper around [stopifnot2] that evaluates **R** expressions
#' in an environment constructed from `data`.
#' @param data data to use for constructing an environment. This may be an
#' `environment`, a `list`, a `data.frame`, or an `integer` as in
#' `sys.call`.
#' @param ... any number of **R** expressions, which should each evaluate
#' to (a logical vector of [all]) [`TRUE`]. If named, the names will be used
#' in lieu of the default error message.
#' @inheritParams stop2 call.
#' @details
#' If any of the expressions are not [all] `TRUE`, [stop] is called,
#' producing an error message indicating the first expression which
#' was not ([all]) true. See [stopifnot] and [stopifnot2] for full details.
#'
#' Special care must be taken for handlers on the call stack, as they
#' may affect the call displayed in the error message. In
#' such instances, passing an environment to `call.` may be helpful.
#' @return If no errors are thrown, the function returns `data` invisibly.
#' @seealso [stop2] and [warning2] for errors and warnings
#' with call information.
#' @examples
#' try(stopifnot.with(data.frame(x = 1, y = 2), x == y))
#' try(stopifnot.with(list(x = 1, y = 2), all.equal(x, y)))
#'
#' f1 <- function(x, ..., call.) stopifnot.with(x, ..., call. = call.)
#' f2 <- function(x, ..., call.) f1(x, ..., call. = call.)
#' f <- function(x, ..., call.) f2(x, ..., call. = call.)
#'
#' x <- list(a = 1, b = 2)
#' try(f(x, a == b, call. = FALSE))
#' try(f(x, a == b, call. = TRUE))
#'
#' try(f(x, a == 1, b < 1, call. = 0))
#' try(f(x, b > 3, call. = 1))
#' try(f(x, a != 1, call. = 2))
#'
#' f <- function(x, ...) {
#'   e <- environment()
#'   f1(x, ..., call. = e)
#' }
#'
#' try(f(x, a == 1, b < 1))
#' @export
stopifnot.with <- function(data, ..., call. = TRUE) {
  darg <- substitute(data)
  args <- subDots(...)
  n <- length(args)

  for (i in seq_len(n)) {
    # with() but we've already sub'd args
    r <- eval(args[[i]], envir = data, enclos = parent.frame())

    if (!(is.logical(r) && !anyNA(r) && all(r))) {
      if (is.null(msg <- names(args)) || !nzchar(msg <- msg[i])) {
        cl.i <- args[[i]]

        msg <- if (
          is.call(cl.i) && identical(cl.i[[1]], quote(all.equal)) &&
            (
              is.null(ni <- names(cl.i)) || length(cl.i) == 3L ||
                length(cl.i <- cl.i[!nzchar(ni)]) == 3L
            )
        ) {
          sprintf(
            gettext("with %s : %s and %s are not equal:\n  %s"),
            Dparse(darg),
            Dparse(cl.i[[2]]),
            Dparse(cl.i[[3]]),
            abbrev(r)
          )
        } else {
          le <- length(r)
          if (le == 0L) le <- 1L

          sprintf(
            ngettext(
              le,
              "with %s : %s is not TRUE",
              "with %s : %s are not all TRUE"
            ),
            Dparse(darg),
            Dparse(cl.i)
          )
        }
      }

      call. <- get_call.(call.)
      stop(simpleError(msg, call = call.))
    }
  }

  invisible(data)
}

Dparse <- function(call, cutoff = 60L) {
  ch <- deparse(call, width.cutoff = cutoff)
  if (length(ch) > 1L) paste(ch[1L], "....") else ch
}

head <- function(x, n = 6L) {
  x[seq_len(if (n < 0L) max(length(x) + n, 0L) else min(n, length(x)))]
}

abbrev <- function(ae, n = 3L) {
  paste(c(head(ae, n), if (length(ae) > n) "...."), collapse = "\n  ")
}

test_that("warningifnot() passes all TRUE, empty, or no args", {
  expect_invisible(warningifnot(TRUE))
  expect_invisible(warningifnot(TRUE, c(TRUE, TRUE, TRUE)))
  expect_invisible(warningifnot())
  expect_invisible(warningifnot(TRUE, {
    TRUE
  }))
  expect_invisible(warningifnot(logical()))
})

test_that("warningifnot() warns for FALSE/NA", {
  expect_warning(
    warningifnot(FALSE),
    class = "simpleWarning",
    regexp = "^FALSE is not TRUE$"
  )

  expect_warning(
    warningifnot(c(TRUE, FALSE, TRUE)),
    class = "simpleWarning",
    regexp = "^c\\(TRUE, FALSE, TRUE\\) are not all TRUE$"
  )

  expect_warning(
    warningifnot(NA),
    class = "simpleWarning",
    regexp = "^NA is not TRUE$"
  )

  expect_warning(
    warningifnot(c(TRUE, NA)),
    class = "simpleWarning",
    regexp = "^c\\(TRUE, NA\\) are not all TRUE$"
  )
})

test_that("warningifnot() warns for non-logical values", {
  expect_warning(
    warningifnot(1),
    class = "simpleWarning",
    regexp = "^1 is not TRUE$"
  )

  expect_warning(
    warningifnot(0),
    class = "simpleWarning",
    regexp = "^0 is not TRUE$"
  )

  expect_warning(
    warningifnot("TRUE"),
    class = "simpleWarning",
    regexp = '^"TRUE" is not TRUE$'
  )

  expect_warning(
    warningifnot(NULL),
    class = "simpleWarning",
    regexp = "^NULL is not TRUE$"
  )

  expect_warning(
    warningifnot(list(TRUE)),
    class = "simpleWarning",
    regexp = "^list\\(TRUE\\) is not TRUE$"
  )
})

test_that("named warningifnot() arguments use their names as messages", {
  expect_warning(
    warningifnot("my condition" = FALSE),
    regexp = "^my condition$"
  )
})

test_that("all.equal() failures receive special formatting", {
  expect_warning(
    warningifnot(all.equal(1, 2)),
    regexp = "1 and 2 are not equal:"
  )
})

test_that("call. = FALSE removes the call", {
  warning <- rlang::catch_cnd(
    warningifnot(FALSE, call. = FALSE),
    "warning"
  )

  expect_true(inherits(warning, "simpleWarning"))
  expect_null(conditionCall(warning))
})

test_that("call. = TRUE records the caller", {
  helper <- function() {
    rlang::catch_cnd(
      warningifnot(FALSE, call. = TRUE),
      "warning"
    )
  }

  warning <- helper()

  expect_true(inherits(warning, "simpleWarning"))
  expect_identical(
    conditionCall(warning)[[1]],
    quote(helper)
  )
})

test_that("numeric call. = 1 identifies caller", {
  warning <- tryCatch(
    warningifnot(FALSE, call. = 1),
    warning = function(cnd) cnd
  )

  expect_true(inherits(warning, "simpleWarning"))
  expect_identical(
    conditionCall(warning)[[1]],
    quote(doTryCatch)
  )
})

test_that("negative numeric call. values use absolute value", {
  warning <- tryCatch(
    warningifnot(FALSE, call. = 1),
    warning = function(cnd) cnd
  )

  expect_true(inherits(warning, "simpleWarning"))
  expect_identical(
    conditionCall(warning)[[1]],
    quote(doTryCatch)
  )
})

test_that("numeric call. = 0 identifies warningifnot()", {
  warning <- rlang::catch_cnd(
    warningifnot(FALSE, call. = 0),
    "warning"
  )

  expect_identical(
    conditionCall(warning)[[1]],
    quote(warningifnot)
  )
})

test_that("numeric call. = 2 walks further up the stack", {
  outer <- function() {
    inner()
  }

  inner <- function() {
    rlang::catch_cnd(
      warningifnot(FALSE, call. = 2),
      "warning"
    )
  }

  warning <- outer()

  expect_true(inherits(warning, "simpleWarning"))
  expect_identical(class(conditionCall(warning)), "call")
})

test_that("fractional numeric call. values are coerced to integer", {
  helper <- function() {
    rlang::catch_cnd(
      warningifnot(FALSE, call. = 1.9),
      "warning"
    )
  }

  warning <- helper()

  expect_identical(class(conditionCall(warning)), "call")
})

test_that("large numeric call. values are clamped to available stack", {
  helper <- function() {
    rlang::catch_cnd(
      warningifnot(FALSE, call. = 100000),
      "warning"
    )
  }

  warning <- helper()

  expect_identical(class(conditionCall(warning)), "call")
})

test_that("call. rejects logical vectors", {
  expect_error(
    warningifnot(FALSE, call. = c(TRUE, FALSE)),
    regexp = "^Logical `call\\.` inputs must be TRUE or FALSE$"
  )
})

test_that("call. rejects NA logical", {
  expect_error(
    warningifnot(FALSE, call. = NA),
    regexp = "^Logical `call\\.` inputs must be TRUE or FALSE$"
  )
})

test_that("call. rejects numeric vectors", {
  expect_error(
    warningifnot(FALSE, call. = c(1, 2)),
    regexp = "^Numeric `call\\.` inputs must be scalar non-NA$"
  )
})

test_that("call. rejects numeric NA", {
  expect_error(
    warningifnot(FALSE, call. = NA_real_),
    regexp = "^Numeric `call\\.` inputs must be scalar non-NA$"
  )

  expect_error(
    warningifnot(FALSE, call. = NA_integer_),
    regexp = "^Numeric `call\\.` inputs must be scalar non-NA$"
  )
})

test_that("call. rejects character values", {
  expect_error(
    warningifnot(FALSE, call. = "1"),
    regexp = "^`call\\.` must be either a call, an integer, an environment, or TRUE/FALSE$"
  )
})

test_that("call. rejects NULL", {
  expect_error(
    warningifnot(FALSE, call. = NULL),
    regexp = "^`call\\.` must be either a call, an integer, an environment, or TRUE/FALSE$"
  )
})

test_that("call. rejects lists", {
  expect_error(
    warningifnot(FALSE, call. = list(1)),
    regexp = "^`call\\.` must be either a call, an integer, an environment, or TRUE/FALSE$"
  )
})

test_that("call. accepts an environment", {
  helper <- function() {
    env <- environment()

    rlang::catch_cnd(
      warningifnot(FALSE, call. = env),
      "warning"
    )
  }

  warning <- helper()

  expect_true(inherits(warning, "simpleWarning"))
  expect_identical(class(conditionCall(warning)), "call")
})

test_that("call. can identify a parent environment", {
  outer <- function() {
    inner()
  }

  inner <- function() {
    rlang::catch_cnd(
      warningifnot(FALSE, call. = parent.frame()),
      "warning"
    )
  }

  warning <- outer()

  expect_identical(class(conditionCall(warning)), "call")
})

test_that("call stack can be traversed through three functions", {
  level1 <- function() level2()
  level2 <- function() level3()

  level3 <- function() {
    rlang::catch_cnd(
      warningifnot(FALSE, call. = 3),
      "warning"
    )
  }

  warning <- level1()

  expect_identical(class(conditionCall(warning)), "call")
})

test_that("different call depths return different calls", {
  level1 <- function() level2()
  level2 <- function() level3()

  level3 <- function() {
    get_warning <- function(call.) {
      rlang::catch_cnd(
        warningifnot(FALSE, call. = call.),
        "warning"
      )
    }

    list(
      zero = get_warning(0),
      one = get_warning(1),
      two = get_warning(2)
    )
  }

  x <- level1()

  expect_false(identical(
    conditionCall(x$zero),
    conditionCall(x$one)
  ))

  expect_false(identical(
    conditionCall(x$one),
    conditionCall(x$two)
  ))
})

test_that("warningifnot() warns only for the first failure by default", {
  n_warn <- 0

  withCallingHandlers(
    warningifnot(FALSE, FALSE, FALSE),
    warning = function(w) {
      n_warn <<- n_warn + 1
      invokeRestart("muffleWarning")
    }
  )

  expect_identical(as.integer(n_warn), 1L)
})

test_that("warningifnot(warn.all = TRUE) warns for every failure", {
  n_warn <- 0

  withCallingHandlers(
    warningifnot(FALSE, FALSE, FALSE, warn.all = TRUE),
    warning = function(w) {
      n_warn <<- n_warn + 1
      invokeRestart("muffleWarning")
    }
  )

  expect_identical(as.integer(n_warn), 3L)
})

test_that("warningifnot() only enables all warnings for TRUE warn.all", {
  expect_warning(
    warningifnot(FALSE, FALSE, warn.all = 1),
    regexp = "^FALSE is not TRUE$"
  )

  n_warn <- 0

  withCallingHandlers(
    warningifnot(FALSE, FALSE, warn.all = 1),
    warning = function(w) {
      n_warn <<- n_warn + 1
      invokeRestart("muffleWarning")
    }
  )

  expect_identical(as.integer(n_warn), 1L)
})

test_that("warningifnot() snapshot", {
  expect_snapshot({
    warningifnot(all.equal(
      c("a", "b", "c"),
      c("a", "x", "z")
    ))
  })
})

test_that("warningifnot() call information snapshot", {
  helper <- function() {
    warningifnot(
      c(TRUE, FALSE, TRUE),
      call. = TRUE
    )
  }

  expect_snapshot({
    helper()
  })
})

test_that("stopifnot2() passes all TRUE, empty, or no args", {
  expect_invisible(stopifnot2(TRUE))
  expect_invisible(stopifnot2(TRUE, c(TRUE, TRUE, TRUE)))
  expect_invisible(stopifnot2())
  expect_invisible(stopifnot2(TRUE, {
    TRUE
  }))
  expect_invisible(stopifnot2(logical()))
})

test_that("stopifnot2() stops for FALSE/NA", {
  expect_error(
    stopifnot2(FALSE),
    class = "simpleError",
    regexp = "^FALSE is not TRUE$"
  )

  expect_error(
    stopifnot2(c(TRUE, FALSE, TRUE)),
    class = "simpleError",
    regexp = "^c\\(TRUE, FALSE, TRUE\\) are not all TRUE$"
  )

  expect_error(
    stopifnot2(NA),
    class = "simpleError",
    regexp = "^NA is not TRUE$"
  )

  expect_error(
    stopifnot2(c(TRUE, NA)),
    class = "simpleError",
    regexp = "^c\\(TRUE, NA\\) are not all TRUE$"
  )
})

test_that("stopifnot2() stops for non-logical values", {
  expect_error(
    stopifnot2(1),
    class = "simpleError",
    regexp = "^1 is not TRUE$"
  )

  expect_error(
    stopifnot2(0),
    class = "simpleError",
    regexp = "^0 is not TRUE$"
  )

  expect_error(
    stopifnot2("TRUE"),
    class = "simpleError",
    regexp = '^"TRUE" is not TRUE$'
  )

  expect_error(
    stopifnot2(NULL),
    class = "simpleError",
    regexp = "^NULL is not TRUE$"
  )

  expect_error(
    stopifnot2(list(TRUE)),
    class = "simpleError",
    regexp = "^list\\(TRUE\\) is not TRUE$"
  )
})

test_that("stopifnot2() stops at the first failing expression", {
  expect_error(
    stopifnot2(FALSE, stop("this must not be evaluated")),
    regexp = "^FALSE is not TRUE$"
  )
})

test_that("named stopifnot2() arguments use their names as messages", {
  expect_error(
    stopifnot2("my condition" = FALSE),
    regexp = "^my condition$"
  )
})

test_that("all.equal() failures receive special formatting", {
  expect_error(
    stopifnot2(all.equal(1, 2)),
    regexp = "1 and 2 are not equal:"
  )
})

test_that("call. = FALSE removes the call", {
  err <- tryCatch(
    stopifnot2(FALSE, call. = FALSE),
    error = identity
  )

  expect_true(inherits(err, "simpleError"))
  expect_null(conditionCall(err))
})

test_that("call. = TRUE records the caller", {
  helper <- function() {
    stopifnot2(FALSE, call. = TRUE)
  }

  err <- tryCatch(helper(), error = identity)

  expect_true(inherits(err, "simpleError"))
  expect_identical(class(conditionCall(err)), "call")
  expect_identical(conditionCall(err)[[1]], quote(helper))

  outer <- function() {
    inner()
  }

  inner <- function() {
    stopifnot2(FALSE, call. = TRUE)
  }

  err <- tryCatch(outer(), error = identity)

  expect_true(inherits(err, "simpleError"))
  expect_identical(conditionCall(err)[[1]], quote(inner))
})

test_that("numeric call. = 0 identifies stopifnot2()", {
  err <- tryCatch(
    stopifnot2(FALSE, call. = 0),
    error = identity
  )

  expect_identical(conditionCall(err)[[1]], quote(stopifnot2))
})

test_that("numeric call. = 1 identifies caller", {
  helper <- function() {
    stopifnot2(FALSE, call. = 1)
  }

  err <- tryCatch(helper(), error = identity)

  expect_identical(conditionCall(err)[[1]], quote(helper))
})

test_that("numeric call. = 2 walks further up the stack", {
  outer <- function() {
    inner()
  }

  inner <- function() {
    stopifnot2(FALSE, call. = 2)
  }

  err <- tryCatch(outer(), error = identity)

  expect_identical(class(conditionCall(err)), "call")
})

test_that("negative numeric call. values use absolute value", {
  helper <- function() {
    stopifnot2(FALSE, call. = -1)
  }

  err <- tryCatch(helper(), error = identity)

  expect_identical(conditionCall(err)[[1]], quote(helper))
})

test_that("fractional numeric call. values are coerced to integer", {
  helper <- function() {
    stopifnot2(FALSE, call. = 1.9)
  }

  err <- tryCatch(helper(), error = identity)

  expect_identical(class(conditionCall(err)), "call")
})

test_that("large numeric call. values are clamped to available stack", {
  helper <- function() {
    stopifnot2(FALSE, call. = 100000)
  }

  err <- tryCatch(helper(), error = identity)

  expect_identical(class(conditionCall(err)), "call")
})

test_that("call. rejects logical vectors", {
  expect_error(
    stopifnot2(FALSE, call. = c(TRUE, FALSE)),
    regexp = "^Logical `call\\.` inputs must be TRUE or FALSE$"
  )
})

test_that("call. rejects NA logical", {
  expect_error(
    stopifnot2(FALSE, call. = NA),
    regexp = "^Logical `call\\.` inputs must be TRUE or FALSE$"
  )
})

test_that("call. rejects numeric vectors", {
  expect_error(
    stopifnot2(FALSE, call. = c(1, 2)),
    regexp = "^Numeric `call\\.` inputs must be scalar non-NA$"
  )
})

test_that("call. rejects numeric NA", {
  expect_error(
    stopifnot2(FALSE, call. = NA_real_),
    regexp = "^Numeric `call\\.` inputs must be scalar non-NA$"
  )

  expect_error(
    stopifnot2(FALSE, call. = NA_integer_),
    regexp = "^Numeric `call\\.` inputs must be scalar non-NA$"
  )
})

test_that("call. rejects character values", {
  expect_error(
    stopifnot2(FALSE, call. = "1"),
    regexp = "^`call\\.` must be either a call, an integer, an environment, or TRUE/FALSE$"
  )
})

test_that("call. rejects NULL", {
  expect_error(
    stopifnot2(FALSE, call. = NULL),
    regexp = "^`call\\.` must be either a call, an integer, an environment, or TRUE/FALSE$"
  )
})

test_that("call. rejects lists", {
  expect_error(
    stopifnot2(FALSE, call. = list(1)),
    regexp = "^`call\\.` must be either a call, an integer, an environment, or TRUE/FALSE$"
  )
})

test_that("call. accepts an environment", {
  helper <- function() {
    env <- environment()
    stopifnot2(FALSE, call. = env)
  }

  err <- tryCatch(helper(), error = identity)

  expect_true(inherits(err, "simpleError"))
  expect_identical(class(conditionCall(err)), "call")
})

test_that("call. can identify a parent environment", {
  outer <- function() {
    inner()
  }

  inner <- function() {
    stopifnot2(FALSE, call. = parent.frame())
  }

  err <- tryCatch(outer(), error = identity)

  expect_identical(class(conditionCall(err)), "call")
})

test_that("call stack can be traversed through three functions", {
  level1 <- function() level2()
  level2 <- function() level3()
  level3 <- function() stopifnot2(FALSE, call. = 3)

  err <- tryCatch(level1(), error = identity)

  expect_identical(class(conditionCall(err)), "call")
})

test_that("different call depths return different calls", {
  level1 <- function() level2()
  level2 <- function() level3()
  level3 <- function() {
    list(
      zero = tryCatch(
        stopifnot2(FALSE, call. = 0),
        error = identity
      ),
      one = tryCatch(
        stopifnot2(FALSE, call. = 1),
        error = identity
      ),
      two = tryCatch(
        stopifnot2(FALSE, call. = 2),
        error = identity
      )
    )
  }

  x <- level1()

  expect_false(identical(
    conditionCall(x$zero),
    conditionCall(x$one)
  ))

  expect_false(identical(
    conditionCall(x$one),
    conditionCall(x$two)
  ))
})

test_that("stopifnot2() snapshot", {
  expect_snapshot(error = TRUE, {
    stopifnot2(all.equal(
      c("a", "b", "c"),
      c("a", "x", "z")
    ))
  })
})

test_that("stopifnot2() call information snapshot", {
  helper <- function() {
    stopifnot2(
      c(TRUE, FALSE, TRUE),
      call. = TRUE
    )
  }

  expect_snapshot(error = TRUE, {
    helper()
  })
})

test_that("stopifnot.with() passes for TRUE", {
  expect_invisible(
    stopifnot.with(
      list(x = 1, y = 2),
      x == 1,
      y == 2
    )
  )

  expect_invisible(
    stopifnot.with(
      list(x = 10),
      x == 10
    )
  )

  dat <- data.frame(
    x = 1:3,
    y = 5:7
  )

  expect_invisible(
    stopifnot.with(
      dat,
      x < y
    )
  )

  e <- new.env()
  e$x <- 10

  expect_invisible(
    stopifnot.with(e, x == 10)
  )
})

test_that("stopifnot.with() reports failing expression", {
  expect_error(
    stopifnot.with(
      list(x = 1),
      x == 2
    ),
    regexp = "^with list\\(x = 1\\) : x == 2 is not TRUE$"
  )

  expect_error(
    stopifnot.with(
      list(x = c(TRUE, FALSE, TRUE)),
      x
    ),
    regexp = "^with list\\(x = c\\(TRUE, FALSE, TRUE\\)\\) : x are not all TRUE$"
  )

  expect_error(
    stopifnot.with(
      list(x = 1),
      "x must equal two" = x == 2
    ),
    regexp = "^x must equal two$"
  )
})

test_that("stopifnot.with() stops at first failure", {
  expect_error(
    stopifnot.with(
      list(x = 1),
      x == 2,
      stop("must not evaluate")
    ),
    regexp = "^with list\\(x = 1\\) : x == 2 is not TRUE$"
  )
})

test_that("stopifnot.with() handles NA", {
  expect_error(
    stopifnot.with(
      list(x = NA),
      x
    ),
    regexp = "is not TRUE"
  )
})

test_that("stopifnot.with() handles non-logical values", {
  expect_error(
    stopifnot.with(
      list(x = 1),
      x
    ),
    regexp = "is not TRUE"
  )
})

test_that("stopifnot.with() call. = FALSE suppresses call", {
  err <- tryCatch(
    stopifnot.with(
      list(x = 1),
      x == 2,
      call. = FALSE
    ),
    error = identity
  )

  expect_null(conditionCall(err))
})

test_that("stopifnot.with() call. = TRUE includes caller", {
  helper <- function() {
    stopifnot.with(
      list(x = 1),
      x == 2,
      call. = TRUE
    )
  }

  err <- tryCatch(helper(), error = identity)

  expect_identical(class(conditionCall(err)), "call")
  expect_identical(conditionCall(err)[[1]], quote(helper))
})

test_that("stopifnot.with() supports numeric call.", {
  helper <- function() {
    stopifnot.with(
      list(x = 1),
      x == 2,
      call. = 1
    )
  }

  err <- tryCatch(helper(), error = identity)

  expect_identical(conditionCall(err)[[1]], quote(helper))
})

test_that("stopifnot.with() formats all.equal() specially", {
  expect_error(
    stopifnot.with(
      list(x = 1, y = 2),
      all.equal(x, y)
    ),
    regexp = "with list\\(x = 1, y = 2\\) : x and y are not equal:"
  )
})

test_that("stopifnot.with() snapshot", {
  expect_snapshot(error = TRUE, {
    dat <- data.frame(
      expected = c(1, 2, 3),
      actual = c(1, 4, 5)
    )

    stopifnot.with(
      dat,
      all.equal(expected, actual)
    )
  })
})

test_that("stopifnot.with() finds variables in data", {
  dat <- list(x = 1)

  expect_invisible(
    stopifnot.with(
      dat,
      x == 1
    )
  )
})

test_that("stopifnot.with() prefers variables in data over caller", {
  x <- 2

  dat <- list(x = 1)

  expect_invisible(
    stopifnot.with(
      dat,
      x == 1
    )
  )

  expect_error(
    stopifnot.with(
      dat,
      x == 2
    ),
    regexp = "^with dat : x == 2 is not TRUE$"
  )
})

test_that("stopifnot.with() falls back to caller when variable is absent from data", {
  x <- 1

  dat <- list(y = 2)

  expect_invisible(
    stopifnot.with(
      dat,
      x == 1
    )
  )
})

test_that("stopifnot.with() can combine data variables and caller variables", {
  x <- 1

  dat <- list(y = 2)

  expect_invisible(
    stopifnot.with(
      dat,
      x == 1,
      y == 2,
      x + y == 3
    )
  )
})

test_that("stopifnot.with() uses data before parent frame", {
  x <- 100

  check <- function() {
    dat <- list(x = 1)

    stopifnot.with(
      dat,
      x == 1
    )
  }

  expect_invisible(check())
})

test_that("stopifnot.with() falls through multiple enclosing environments", {
  x <- 1

  outer <- function() {
    middle <- function() {
      inner <- function() {
        dat <- list(y = 2)

        stopifnot.with(
          dat,
          x == 1,
          y == 2
        )
      }

      inner()
    }

    middle()
  }

  expect_invisible(outer())
})

test_that("stopifnot.with() uses the nearest enclosing binding", {
  x <- 1

  outer <- function() {
    x <- 2

    inner <- function() {
      dat <- list(y = 3)

      stopifnot.with(
        dat,
        x == 2,
        y == 3
      )
    }

    inner()
  }

  expect_invisible(outer())
})

test_that("data binding shadows a variable in the caller", {
  x <- 1

  check <- function() {
    dat <- list(x = 2)

    stopifnot.with(
      dat,
      x == 2
    )
  }

  expect_invisible(check())
})

test_that("data binding shadows a variable several frames above", {
  x <- 1

  outer <- function() {
    middle <- function() {
      dat <- list(x = 2)

      stopifnot.with(
        dat,
        x == 2
      )
    }

    middle()
  }

  expect_invisible(outer())
})

test_that("missing variables produce an error", {
  dat <- list(y = 2)

  expect_error(stopifnot.with(dat, x == 1))
})

test_that("data frame columns are preferred over caller variables", {
  x <- 100

  dat <- data.frame(
    x = 1:3
  )

  expect_invisible(
    stopifnot.with(
      dat,
      all(x == 1:3)
    )
  )
})

test_that("a local binding takes precedence over a binding farther up", {
  x <- 1

  outer <- function() {
    x <- 2

    inner <- function() {
      x <- 3

      dat <- list(y = 4)

      stopifnot.with(
        dat,
        x == 3
      )
    }

    inner()
  }

  expect_invisible(outer())
})

#' @title Remove First or Last N Elements
#' @description
#' Remove the first or last `n` elements of an **R** object.
#' @param x an **R** object with a `[` method, e.g., a vector, matrix, list.
#' @param n integer, number of elements to remove from the beginning or end.
#' @param ... additional arguments passed to methods.
#' @param value integer, same as `n`.
#' @details
#' The default methods operate on atomic
#' vectors and lists, removing `n` elements from the beginning or end of
#' the object.
#'
#' Dimensional objects ([matrix], [data.frame], [array], etc.) are handled by
#' removing `n` entries along the first dimension ('row-wise' for
#' matrices/data.frames and for each slice of higher-dimensional arrays).
#' Remaining dimensions are preserved.
#' @return The modified object with the first or last `n` elements removed.
#' @examples
#' x <- 1:10
#' rm.first(x, 3)
#' rm.last(x, 3)
#'
#' x <- matrix(1:10, nrow = 5)
#' rm.first(x, 2)
#' rm.last(x, 2)
#'
#' x <- list(a = 1, b = 2, c = 3, d = 4)
#' rm.first(x, 2)
#' rm.last(x, 2)
#'
#' x <- 1:10
#' rm.first(x) <- 3
#' rm.last(x) <- 3
#' x
#' @export
rm.first <- function(x, n = 1L, ...) {
  UseMethod("rm.first")
}

#' @rdname rm.first
#' @export
rm.first.default <- function(x, n = 1L, ...) {
  checkDots(...)
  if (!is.atomic(x) && !is.list(x)) {
    stop(
      "The default method for ", sQuote("rm.first"),
      " is only for atomic vectors and lists."
    )
  }
  stopifnot(length(x) >= n, n > 0L, length(n) == 1L)
  x[-seq_len(n)]
}

#' @export
rm.first.matrix <- function(x, n = 1L, ...) {
  checkDots(...)
  nrows <- dim(x)[1]
  stopifnot(nrows >= n, n > 0L, length(n) == 1L)
  x[-seq_len(n), , drop = FALSE]
}

#' @export
rm.first.data.frame <- function(x, n = 1L, ...) {
  checkDots(...)
  nrows <- dim(x)[1]
  stopifnot(nrows >= n, n > 0L, length(n) == 1L)
  x[-seq_len(n), , drop = FALSE]
}

#' @export
rm.first.array <- function(x, n = 1L, ...) {
  checkDots(...)
  nrows <- dim(x)[1]
  stopifnot(nrows >= n, n > 0L, length(n) == 1L)

  do.call(
    "[",
    c(
      list(x, -seq_len(n)),
      rep(list(TRUE), length(dim(x)) - 1L),
      list(drop = FALSE)
    )
  )
}

#' @rdname rm.first
#' @export
`rm.first<-` <- function(x, ..., value) {
  UseMethod("rm.first<-")
}

#' @rdname rm.first
#' @export
`rm.first<-.default` <- function(x, ..., value) {
  rm.first.default(x, n = value, ...)
}

#' @export
`rm.first<-.matrix` <- function(x, ..., value) {
  rm.first.matrix(x, n = value, ...)
}

#' @export
`rm.first<-.data.frame` <- function(x, ..., value) {
  rm.first.data.frame(x, n = value, ...)
}

#' @export
`rm.first<-.array` <- function(x, ..., value) {
  rm.first.array(x, n = value, ...)
}

#' @rdname rm.first
#' @export
rm.last <- function(x, n = 1L, ...) {
  UseMethod("rm.last")
}

#' @rdname rm.first
#' @export
rm.last.default <- function(x, n = 1L, ...) {
  checkDots(...)
  if (!is.atomic(x) && !is.list(x)) {
    stop(
      "The default method for ", sQuote("rm.last"),
      " is only for atomic vectors and lists."
    )
  }

  x_length <- length(x)
  stopifnot(x_length >= n, n > 0L, length(n) == 1L)
  x[-((x_length - n + 1L):x_length)]
}

#' @export
rm.last.matrix <- function(x, n = 1L, ...) {
  checkDots(...)
  nrows <- dim(x)[1]
  stopifnot(nrows >= n, n > 0L, length(n) == 1L)
  x[-((nrows - n + 1L):nrows), , drop = FALSE]
}

#' @export
rm.last.data.frame <- function(x, n = 1L, ...) {
  checkDots(...)
  nrows <- dim(x)[1]
  stopifnot(nrows >= n, n > 0L, length(n) == 1L)
  x[-((nrows - n + 1L):nrows), , drop = FALSE]
}

#' @export
rm.last.array <- function(x, n = 1L, ...) {
  checkDots(...)
  nrows <- dim(x)[1]
  stopifnot(nrows >= n, n > 0L, length(n) == 1L)

  do.call(
    "[",
    c(
      list(x, -((nrows - n + 1L):nrows)),
      rep(list(TRUE), length(dim(x)) - 1L),
      list(drop = FALSE)
    )
  )
}

#' @rdname rm.first
#' @export
`rm.last<-` <- function(x, ..., value) {
  UseMethod("rm.last<-")
}

#' @rdname rm.first
#' @export
`rm.last<-.default` <- function(x, ..., value) {
  rm.last.default(x, n = value, ...)
}

#' @export
`rm.last<-.matrix` <- function(x, ..., value) {
  rm.last.matrix(x, n = value, ...)
}

#' @export
`rm.last<-.data.frame` <- function(x, ..., value) {
  rm.last.data.frame(x, n = value, ...)
}

#' @export
`rm.last<-.array` <- function(x, ..., value) {
  rm.last.array(x, n = value, ...)
}

test_that("rm.first() dispatches correctly by input class", {
  x <- setNames(1:5, letters[1:5])
  expect_identical(rm.first(x, 2), x[-(1:2)])

  lst <- list(a = 1, b = 2, c = 3, d = 4)
  expect_identical(rm.first(lst, 2), list(c = 3, d = 4))

  m <- matrix(1:6, nrow = 3)
  dimnames(m) <- list(c("r1", "r2", "r3"), c("x", "y"))
  expect_identical(rm.first(m, 1), m[-1, , drop = FALSE])

  arr <- array(1:24, dim = c(4, 2, 3))
  dimnames(arr) <- list(
    c("r1", "r2", "r3", "r4"),
    c("x", "y"),
    c("z1", "z2", "z3")
  )
  expect_identical(rm.first(arr, 2), arr[-(1:2), , , drop = FALSE])

  df <- data.frame(a = 1:3, b = 4:6)
  rownames(df) <- c("r1", "r2", "r3")
  expect_identical(rm.first(df, 1), df[-1, , drop = FALSE])
})

test_that("rm.first() errors for unsupported classes", {
  env <- new.env(parent = emptyenv())
  expect_error(rm.first(env, 1), "atomic vectors and lists")
})

test_that("rm.first<- assignment dispatches correctly by input class", {
  x <- setNames(1:5, letters[1:5])
  x_expected <- x[-(1:2)]
  rm.first(x) <- 2
  expect_identical(x, x_expected)

  lst <- list(a = 1, b = 2, c = 3, d = 4)
  lst_expected <- lst[-(1:2)]
  rm.first(lst) <- 2
  expect_identical(lst, lst_expected)

  m <- matrix(1:6, nrow = 3)
  dimnames(m) <- list(c("r1", "r2", "r3"), c("x", "y"))
  m_expected <- m[-1, , drop = FALSE]
  rm.first(m) <- 1
  expect_identical(m, m_expected)

  arr <- array(1:24, dim = c(4, 2, 3))
  dimnames(arr) <- list(
    c("r1", "r2", "r3", "r4"),
    c("x", "y"),
    c("z1", "z2", "z3")
  )
  arr_expected <- arr[-(1:2), , , drop = FALSE]
  rm.first(arr) <- 2
  expect_identical(arr, arr_expected)

  df <- data.frame(a = 1:3, b = 4:6)
  rownames(df) <- c("r1", "r2", "r3")
  df_expected <- df[-1, , drop = FALSE]
  rm.first(df) <- 1
  expect_identical(df, df_expected)
})

test_that("rm.last() dispatches correctly by input class", {
  x <- setNames(1:5, letters[1:5])
  expect_identical(rm.last(x, 2), x[-(4:5)])

  lst <- list(a = 1, b = 2, c = 3, d = 4)
  expect_identical(rm.last(lst, 2), list(a = 1, b = 2))

  m <- matrix(1:6, nrow = 3)
  dimnames(m) <- list(c("r1", "r2", "r3"), c("x", "y"))
  expect_identical(rm.last(m, 1), m[-3, , drop = FALSE])

  arr <- array(1:24, dim = c(4, 2, 3))
  dimnames(arr) <- list(
    c("r1", "r2", "r3", "r4"),
    c("x", "y"),
    c("z1", "z2", "z3")
  )
  expect_identical(rm.last(arr, 2), arr[-(3:4), , , drop = FALSE])

  df <- data.frame(a = 1:3, b = 4:6)
  rownames(df) <- c("r1", "r2", "r3")
  expect_identical(rm.last(df, 1), df[-3, , drop = FALSE])
})

test_that("rm.last() errors for unsupported classes", {
  env <- new.env(parent = emptyenv())
  expect_error(rm.last(env, 1), "atomic vectors and lists")
})

test_that("rm.last<- assignment dispatches correctly by input class", {
  x <- setNames(1:5, letters[1:5])
  x_expected <- x[-(4:5)]
  rm.last(x) <- 2
  expect_identical(x, x_expected)

  lst <- list(a = 1, b = 2, c = 3, d = 4)
  lst_expected <- lst[-(3:4)]
  rm.last(lst) <- 2
  expect_identical(lst, lst_expected)

  m <- matrix(1:6, nrow = 3)
  dimnames(m) <- list(c("r1", "r2", "r3"), c("x", "y"))
  m_expected <- m[-3, , drop = FALSE]
  rm.last(m) <- 1
  expect_identical(m, m_expected)

  arr <- array(1:24, dim = c(4, 2, 3))
  dimnames(arr) <- list(
    c("r1", "r2", "r3", "r4"),
    c("x", "y"),
    c("z1", "z2", "z3")
  )
  arr_expected <- arr[-(3:4), , , drop = FALSE]
  rm.last(arr) <- 2
  expect_identical(arr, arr_expected)

  df <- data.frame(a = 1:3, b = 4:6)
  rownames(df) <- c("r1", "r2", "r3")
  df_expected <- df[-3, , drop = FALSE]
  rm.last(df) <- 1
  expect_identical(df, df_expected)
})

test_that("array methods use first-dimension slicing for 2D/3D/4D", {
  arr2 <- array(1:12, dim = c(4, 3))
  dimnames(arr2) <- list(paste0("r", 1:4), paste0("c", 1:3))

  arr3 <- array(1:24, dim = c(4, 2, 3))
  dimnames(arr3) <- list(
    paste0("r", 1:4),
    paste0("c", 1:2),
    paste0("z", 1:3)
  )

  arr4 <- array(1:48, dim = c(4, 2, 3, 2))
  dimnames(arr4) <- list(
    paste0("r", 1:4),
    paste0("c", 1:2),
    paste0("z", 1:3),
    paste0("w", 1:2)
  )

  arrs <- list(arr2 = arr2, arr3 = arr3, arr4 = arr4)

  for (arr in arrs) {
    ndim <- length(dim(arr))

    if (ndim == 2L) {
      exp_first <- arr[-(1:2), , drop = FALSE]
      exp_last <- arr[-(3:4), , drop = FALSE]
    } else if (ndim == 3L) {
      exp_first <- arr[-(1:2), , , drop = FALSE]
      exp_last <- arr[-(3:4), , , drop = FALSE]
    } else if (ndim == 4L) {
      exp_first <- arr[-(1:2), , , , drop = FALSE]
      exp_last <- arr[-(3:4), , , , drop = FALSE]
    } else {
      stop("Unexpected dimension in test fixture")
    }

    expect_identical(rm.first(arr, 2), exp_first)
    expect_identical(rm.last(arr, 2), exp_last)
    expect_identical(dim(rm.first(arr, 2))[1], dim(arr)[1] - 2L)
    expect_identical(dim(rm.last(arr, 2))[1], dim(arr)[1] - 2L)
    expect_identical(dimnames(rm.first(arr, 2)), dimnames(exp_first))
    expect_identical(dimnames(rm.last(arr, 2)), dimnames(exp_last))
  }
})

test_that("array replacement methods preserve shape and dimnames by rank", {
  arr2 <- array(1:12, dim = c(4, 3))
  dimnames(arr2) <- list(paste0("r", 1:4), paste0("c", 1:3))

  arr3 <- array(1:24, dim = c(4, 2, 3))
  dimnames(arr3) <- list(
    paste0("r", 1:4),
    paste0("c", 1:2),
    paste0("z", 1:3)
  )

  arr4 <- array(1:48, dim = c(4, 2, 3, 2))
  dimnames(arr4) <- list(
    paste0("r", 1:4),
    paste0("c", 1:2),
    paste0("z", 1:3),
    paste0("w", 1:2)
  )

  arrs <- list(arr2 = arr2, arr3 = arr3, arr4 = arr4)

  for (arr in arrs) {
    ndim <- length(dim(arr))

    if (ndim == 2L) {
      exp_first <- arr[-(1:2), , drop = FALSE]
      exp_last <- arr[-(3:4), , drop = FALSE]
    } else if (ndim == 3L) {
      exp_first <- arr[-(1:2), , , drop = FALSE]
      exp_last <- arr[-(3:4), , , drop = FALSE]
    } else if (ndim == 4L) {
      exp_first <- arr[-(1:2), , , , drop = FALSE]
      exp_last <- arr[-(3:4), , , , drop = FALSE]
    }

    a_first <- arr
    rm.first(a_first) <- 2
    expect_identical(a_first, exp_first)

    a_last <- arr
    rm.last(a_last) <- 2
    expect_identical(a_last, exp_last)
  }
})

test_that("array methods handle first-dimension size 1", {
  arr <- array(1:6, dim = c(1, 2, 3))
  dimnames(arr) <- list("r1", c("c1", "c2"), c("z1", "z2", "z3"))

  exp_empty <- arr[-1, , , drop = FALSE]

  expect_identical(rm.first(arr, 1), exp_empty)
  expect_identical(rm.last(arr, 1), exp_empty)
  expect_identical(dim(rm.first(arr, 1)), c(0L, 2L, 3L))
  expect_identical(dim(rm.last(arr, 1)), c(0L, 2L, 3L))
  expect_identical(dimnames(rm.first(arr, 1)), dimnames(exp_empty))
  expect_identical(dimnames(rm.last(arr, 1)), dimnames(exp_empty))
})

test_that("array replacement methods handle first-dimension size 1", {
  arr <- array(1:6, dim = c(1, 2, 3))
  dimnames(arr) <- list("r1", c("c1", "c2"), c("z1", "z2", "z3"))

  exp_empty <- arr[-1, , , drop = FALSE]

  a_first <- arr
  rm.first(a_first) <- 1
  expect_identical(a_first, exp_empty)

  a_last <- arr
  rm.last(a_last) <- 1
  expect_identical(a_last, exp_empty)
})

test_that("array methods error when n exceeds first dimension", {
  arr <- array(1:6, dim = c(1, 2, 3))

  expect_error(rm.first(arr, 2))
  expect_error(rm.last(arr, 2))

  expect_error({
    a <- arr
    rm.first(a) <- 2
  })
  expect_error({
    a <- arr
    rm.last(a) <- 2
  })
})

#' @title Display Warnings and Errors with Call Information
#' @description
#' Wrappers around [stop] and [warning] that
#' enable the `call.` argument to derive a call from the
#' stack.
#' @param ... zero or more objects which can be coerced to
#' character (and which are pasted together with no separator).
#' @param call. call, logical, integer, or environment. logical, indicating
#' if the calling call should become part of the error message with same
#' semantics as [stop]. integer, specifying how many calls to go 'up'
#' the call stack to extract a call for the message. A value of
#' `0` will give the call to `stop2()` itself, `1` will give the
#' call of the caller, and so on. Numeric values are coerced to integer
#' and absolute values are taken. Values outside either boundary of the
#' call stack will be clamped to the nearest boundary. environment,
#' which will be matched against the calling stack and the corresponding
#' call will be shown.
#' @param domain see [gettext]. If `NA`, messages will not be translated.
#' @return Called for side effects only.
#' @details These functions derive a call to be displayed and then construct
#' their own 'simple' conditions using [simpleError] and [simpleWarning].
#'
#' If a condition object is given as the first argument, it will be
#' treated in the same way as the base functions do, by warning that
#' other arguments will be ignored and then signalling the condition.
#'
#' See [stop] and [warning] for full details.
#' @seealso [stopifnot2] and [stopifnot.with] for validations with
#' call information.
#' @examples
#' f1 <- function(call.) stop2("error", call. = call.)
#' f2 <- function(call.) f1(call. = call.)
#' f <- function(call.) f2(call. = call.)
#'
#' try(f(call. = FALSE))
#' try(f(call. = TRUE))
#'
#' try(f(call. = 0))
#' try(f(call. = 1))
#' try(f(call. = 2))
#'
#' f <- function() {
#'   e <- environment()
#'   f1(call. = e)
#' }
#'
#' try(f())
#'
#' f1 <- function(call.) warning2("warning", call. = call.)
#' try(f())
#' @export
stop2 <- function(..., call. = TRUE, domain = NULL) {
  if (...length() == 1L && inherits(..1, "condition")) {
    cond <- ..1
    if (nargs() > 1L) {
      warning(
        "condition object passed: all additional arguments ignored in stop2()"
      )
    }
    stop(cond)
  }

  msg <- .makeMessage(..., domain = domain)
  call. <- get_call.(call.)
  stop(simpleError(msg, call = call.))
}

#' @rdname stop2
#' @export
warning2 <- function(..., call. = TRUE, domain = NULL) {
  if (...length() == 1L && inherits(..1, "condition")) {
    cond <- ..1
    if (nargs() > 1L) {
      cat(
        gettext("condition object passed: all additional arguments ignored in warning2()"),
        "\n",
        sep = "",
        file = stderr()
      )
    }
    warning(cond)
    return(invisible(NULL))
  }

  msg <- .makeMessage(..., domain = domain)
  call. <- get_call.(call.)
  warning(simpleWarning(msg, call = call.))
}

get_call. <- function(call.) {
  if (is.logical(call.)) {
    if (length(call.) != 1L || is.na(call.)) {
      stop("Logical `call.` inputs must be TRUE or FALSE")
    }

    call. <- if (call.) {
      if (p <- sys.parent(2L)) sys.call(p)
    } else {
      NULL
    }
  } else if (is.numeric(call.)) {
    if (length(call.) != 1L || is.na(call.)) {
      stop("Numeric `call.` inputs must be scalar non-NA")
    }

    call. <- abs(as.integer(call.))
    calls <- sys.calls()
    calls <- calls[-length(calls)]
    i <- length(calls) - call.
    if (i < 1L) i <- 1L else if (i > length(calls)) i <- length(calls)
    call. <- calls[[i]]
  } else if (is.environment(call.)) {
    call. <- get_call_from_frame(sys.calls(), sys.frames(), call.)
  } else if (!is.call(call.)) {
    stop("`call.` must be either a call, an integer, an environment, or TRUE/FALSE")
  }

  call.
}

get_call_from_frame <- function(all_calls, all_envs, given_env) {
  for (k in seq_along(all_envs)) {
    if (identical(all_envs[[k]], given_env)) {
      return(all_calls[[k]])
    }
  }
}

test_that("stop2() creates simpleError conditions", {
  err <- rlang::catch_cnd(
    stop2("hello"),
    "error"
  )

  expect_true(inherits(err, "simpleError"))
  expect_identical(conditionMessage(err), "hello")
})


test_that("warning2() creates simpleWarning conditions", {
  warn <- rlang::catch_cnd(
    warning2("hello"),
    "warning"
  )

  expect_true(inherits(warn, "simpleWarning"))
  expect_identical(conditionMessage(warn), "hello")
})

test_that("multiple arguments are pasted together", {
  err <- rlang::catch_cnd(
    stop2("hello", " ", "world"),
    "error"
  )

  expect_identical(
    conditionMessage(err),
    "hello world"
  )

  warn <- rlang::catch_cnd(
    warning2("hello", " ", "world"),
    "warning"
  )

  expect_identical(
    conditionMessage(warn),
    "hello world"
  )
})


test_that("call. = FALSE removes calls", {
  err <- rlang::catch_cnd(
    stop2("failure", call. = FALSE),
    "error"
  )

  warn <- rlang::catch_cnd(
    warning2("failure", call. = FALSE),
    "warning"
  )

  expect_null(conditionCall(err))
  expect_null(conditionCall(warn))
})


test_that("call. = TRUE captures the caller", {
  helper_error <- function() {
    rlang::catch_cnd(
      stop2("failure", call. = TRUE),
      "error"
    )
  }

  helper_warning <- function() {
    rlang::catch_cnd(
      warning2("failure", call. = TRUE),
      "warning"
    )
  }

  err <- helper_error()
  warn <- helper_warning()

  expect_identical(conditionCall(err)[[1]], quote(helper_error))
  expect_identical(conditionCall(warn)[[1]], quote(helper_warning))
})


test_that("numeric call. = 0 identifies the wrapper", {
  err <- rlang::catch_cnd(
    stop2("failure", call. = 0),
    "error"
  )

  warn <- rlang::catch_cnd(
    warning2("failure", call. = 0),
    "warning"
  )

  expect_identical(conditionCall(err)[[1]], quote(stop2))
  expect_identical(conditionCall(warn)[[1]], quote(warning2))
})


test_that("numeric call. = 1 identifies caller", {
  err <- tryCatch(stop2(call. = 1), error = function(x) x)
  warn <- tryCatch(warning2(call. = 1), warning = function(x) x)

  expect_identical(conditionCall(err)[[1]], quote(doTryCatch))
  expect_identical(conditionCall(warn)[[1]], quote(doTryCatch))
})


test_that("negative numeric call values use absolute value", {
  err <- tryCatch(stop2(call. = -1), error = function(x) x)
  warn <- tryCatch(warning2(call. = -1), warning = function(x) x)

  expect_identical(conditionCall(err)[[1]], quote(doTryCatch))
  expect_identical(conditionCall(warn)[[1]], quote(doTryCatch))
})


test_that("fractional numeric call values are coerced", {
  # 1.5 -> as.integer() -> 1
  err <- tryCatch(stop2(call. = 1.5), error = function(x) x)
  warn <- tryCatch(warning2(call. = 1.5), warning = function(x) x)

  expect_identical(conditionCall(err)[[1]], quote(doTryCatch))
  expect_identical(conditionCall(warn)[[1]], quote(doTryCatch))
})


test_that("large numeric call values are clamped", {
  err <- rlang::catch_cnd(
    stop2("failure", call. = 100000),
    "error"
  )

  expect_true(inherits(err, "simpleError"))
  expect_identical(class(conditionCall(err)), "call")
})


test_that("explicit calls are accepted", {
  err <- rlang::catch_cnd(
    stop2("failure", call. = quote(foo())),
    "error"
  )

  warn <- rlang::catch_cnd(
    warning2("failure", call. = quote(bar())),
    "warning"
  )

  expect_identical(conditionCall(err), quote(foo()))
  expect_identical(conditionCall(warn), quote(bar()))
})


test_that("call. accepts environments", {
  helper <- function() {
    env <- environment()

    rlang::catch_cnd(
      stop2("failure", call. = env),
      "error"
    )
  }

  err <- helper()

  expect_true(inherits(err, "simpleError"))
  expect_identical(class(conditionCall(err)), "call")
})


test_that("invalid call. inputs error", {
  expect_error(
    stop2("failure", call. = c(TRUE, FALSE)),
    regexp = "Logical `call\\.` inputs must be TRUE or FALSE"
  )

  expect_error(
    warning2("failure", call. = c(1, 2)),
    regexp = "Numeric `call\\.` inputs must be scalar non-NA"
  )
})


test_that("condition objects are passed through", {
  err <- simpleError("existing error")

  expect_error(
    stop2(err),
    regexp = "existing error"
  )


  warn <- simpleWarning("existing warning")

  expect_warning(warning2(warn),
    regexp = "existing warning"
  )
})


test_that("condition object ignores additional arguments", {
  err <- simpleError("existing error")

  expect_error(
    stop2(err, "ignored"),
    regexp = "existing error"
  )

  warn <- simpleWarning("existing warning")

  expect_warning(
    warning2(warn, "ignored"),
    regexp = "existing warning"
  )
})

test_that("stop2 call information snapshot", {
  helper <- function() {
    stop2(
      "failure",
      call. = TRUE
    )
  }

  expect_snapshot(error = TRUE, {
    helper()
  })
})


test_that("warning2 call information snapshot", {
  helper <- function() {
    warning2(
      "failure",
      call. = TRUE
    )
  }

  expect_snapshot({
    helper()
  })
})

#' @title Backquote Text
#' @description
#' Backquote text by combining with backticks.
#' @param x an **R** object, to be coerced to a [character] vector.
#' @return
#' A character vector of the same length as `x` (after any coercion).
#' @seealso [Quotes], [dQuote] and [sQuote].
#' @examples
#' bckQuote("example")
#' bckQuote(c("one", "two", "three"))
#' bckQuote(123)
#' @export
bckQuote <- function(x) {
  if (!length(x)) {
    return(character(0))
  }

  paste0("`", x, "`")
}

#' @title Concatenate and Print with No Separator
#' @description
#' Outputs the objects, concatenating the representations
#' with no separator.
#' @param ... **R** objects (see [cat] for the types of objects allowed).
#' @param file a connection, or a character string naming the file to
#' print to. If "" (the default), `cat0` prints to the standard output
#' connection, the console unless redirected by sink.
#' @param fill a logical or (positive) numeric controlling how the
#' output is broken into successive lines. If `FALSE` (default), only
#' newlines created explicitly by `"\n"` are printed. Otherwise, the
#' output is broken into lines with print width equal to the option
#' width if fill is `TRUE`, or the value of fill if this is numeric.
#' Linefeeds are only inserted between elements, strings wider than
#' fill are not wrapped. Non-positive fill values are ignored, with a
#' warning.
#' @param labels character vector of labels for the lines printed.
#' Ignored if fill is `FALSE`.
#' @param append logical. Only used if the argument file is the name
#' of file (and not a connection or `"|cmd"`). If `TRUE` output will be
#' appended to file; otherwise, it will overwrite the contents of file.
#' @return
#' None (invisible `NULL`).
#' @details
#' All arguments are passed to a call to [cat] with `sep` set to `""`.
#' @seealso [cat], [print], [format] and [paste] which concatenates into
#' a string.
#' @examples
#' cat(letters[1:3])
#' cat0(letters[1:3])
#'
#' cat(
#'   paste(letters, 100 * 1:26),
#'   fill = TRUE, labels = paste0("{", 1:10, "}:")
#' )
#' cat0(
#'   paste(letters, 100 * 1:26),
#'   fill = TRUE, labels = paste0("{", 1:10, "}:")
#' )
#' @export
cat0 <- function(
  ..., file = "", fill = FALSE, labels = NULL,
  append = FALSE
) {
  cat(...,
    file = file, sep = "", fill = fill, labels = labels,
    append = append
  )
}

#' @title Collapse a Vector of Strings into a Single String
#' @description
#' Collapse a character vector into a single string, with an optional
#' separator, and for `listing()` an optional conjunction and period,
#' with options to quote the terms.
#' @param ... one or more **R** objects, to be converted to [character] vectors.
#' @param x a character vector from which to create the human readable list.
#' @param sep character string to collapse the terms, not [`NA_character_`].
#' @param recurse [`logical`]. If `TRUE`, collapse each argument separately
#' first, before collapsing the results into a single string.
#' @param conjunction character string to use as a conjunction for the
#' last two terms.
#' @param period [`logical`]. If `TRUE`, append a period to the end of the
#' string.
#' @param quote [`NULL`] or a character string indicating the type of quotes
#' to use for quoting the terms. If `NULL`, no quoting is done. If `"single"`,
#' single quotes are used, if `"double"`, double quotes are used, and if
#' `"back"`, backquotes are used.
#' @return a single character string.
#' @details
#' `collapse` and `collapse0` are simple wrappers for
#' `paste0(..., collapse = sep)` and `paste(..., collapse = sep)`, with
#' an option to collapse each argument separately first, before collapsing
#' the results.
#' @seealso [paste0], [sQuote], [dQuote], [bckQuote].
#' @examples
#' collapse(c("a", "b", "c"), "d")
#' collapse0(c("a", "b", "c"), "d")
#'
#' collapse(c("a", "b", "c"), "d", sep = ", ")
#' collapse0(c("a", "b", "c"), "d", sep = ", ")
#'
#' collapse(c("a", "b"), c("c", "d"), sep = ", ")
#' collapse(c("a", "b"), c("c", "d"), sep = ", ", recurse = TRUE)
#'
#' listing(c("a", "b", "c"), sep = ", ", conjunction = "and")
#' listing(c("a", "b"), conjunction = "or", period = FALSE)
#'
#' listing(c("a", "b", "c"), quote = "single")
#' listing(c("a", "b", "c"), quote = "double")
#' listing(c("a", "b", "c"), quote = "back")
#' @export
collapse <- function(..., sep = "", recurse = FALSE) {
  if (...length() == 0L) {
    return(character(0))
  }

  if (isTRUE(recurse)) {
    x <- lapply(list(...), function(x) paste(x, collapse = sep))
    do.call(paste, c(x, list(collapse = sep)))
  } else {
    paste(..., collapse = sep)
  }
}

#' @rdname collapse
#' @export
collapse0 <- function(..., sep = "", recurse = FALSE) {
  if (...length() == 0L) {
    return(character(0))
  }

  if (isTRUE(recurse)) {
    x <- lapply(list(...), function(x) paste0(x, collapse = sep))
    do.call(paste0, c(x, list(collapse = sep)))
  } else {
    paste0(..., collapse = sep)
  }
}

#' @rdname collapse
#' @export
listing <- function(
  x, sep = ", ", conjunction = "and", period = TRUE, quote = NULL
) {
  le <- length(x)
  if (le == 0L) {
    return(character(0))
  }

  if (!is.null(quote)) {
    quote <- match.arg(quote, c("single", "double", "back"))
    x <- switch(quote,
      single = sQuote(x),
      double = dQuote(x),
      back = bckQuote(x)
    )
  }

  if (le == 1L) {
    if (period) {
      paste0(x, ".")
    } else {
      x
    }
  } else {
    x <- paste(
      paste(x[-le], collapse = sep),
      conjunction,
      x[le]
    )

    if (isTRUE(period)) {
      paste0(x, ".")
    } else {
      x
    }
  }
}

#-- grepi, grepf

#' @title Pattern Matching
#' @description
#' Strongly typed wrappers around [`grep`] that have the
#' `fixed` and `ignore.case` arguments set internally.
#' @details
#' `*f()` suffixed functions have `fixed = TRUE` and conflicting
#' arguments (`perl` and `ignore.case`) set as `FALSE`.
#'
#' `*i()` suffixed functions have `ignore.case = TRUE` and the
#' conflicting `fixed` argument set as `FALSE`.
#'
#' For full documentation of the wrapped functions, see the help
#' pages for [`grep`].
#' @param pattern
#' character string containing a regular expression (or character string
#' for `fixed = TRUE` to be matched in the given character vector.
#' Coerced by [as.character] to a character string if possible.
#' If a character vector of length `2` or more is supplied, the first
#' element is used with a warning. Missing values are allowed.
#' @param x
#' a character vector where matches are sought, or an object
#' which can be coerced by [as.character] to a character vector.
#' Long vectors are supported.
#' @param value
#' logical. If `FALSE`, a vector containing the (integer) indices of
#' the matches determined by grep is returned, and if `TRUE`, a vector
#' containing the matching elements themselves is returned.
#' @param useBytes
#' logical. If `TRUE` the matching is done byte-by-byte rather
#' than character-by-character.
#' @param invert
#' logical. If `TRUE` return indices or values for elements that
#' do not match.
#' @param perl
#' logical. Should Perl-compatible regexps be used?
#' @return
#' with `value = FALSE`, return a vector of the
#' indices of the elements of `x` that yielded a match (or not,
#' for `invert = TRUE`). This will be an integer vector unless
#' the input is a long vector, when it will be a double vector.
#'
#' with `value = TRUE`, return a character vector containing the
#' selected elements of `x` (after coercion, preserving names but
#' no other attributes).
#' @examples
#' grepf("foo", c("foo", "Foo", "bar"))
#' grepf("foo", c("foo", "Foo", "bar"), value = TRUE)
#' grepi("foo", c("foo", "Foo", "bar"))
#' grepi("foo", c("foo", "Foo", "bar"), value = TRUE)
#' @family pattern-match-replacement-wrappers
#' @name grep-wrappers
NULL

#' @rdname grep-wrappers
#' @export
grepf <- function(
  pattern, x, value = FALSE, useBytes = FALSE, invert = FALSE
) {
  grep(
    pattern = pattern, x = x, ignore.case = FALSE,
    perl = FALSE, value = value, fixed = TRUE,
    useBytes = useBytes, invert = invert
  )
}

#' @rdname grep-wrappers
#' @export
grepi <- function(
  pattern, x, perl = FALSE, value = FALSE,
  useBytes = FALSE, invert = FALSE
) {
  grep(
    pattern = pattern, x = x, ignore.case = TRUE,
    perl = perl, value = value, fixed = FALSE,
    useBytes = useBytes, invert = invert
  )
}

#-- grepli, greplf

#' @inherit grep-wrappers title details
#' @description
#' Strongly typed wrappers around [`grepl`] that have the
#' `fixed` and `ignore.case` arguments set internally (as
#' well as the conflicting arguments).
#' @inheritParams grep-wrappers pattern x perl useBytes
#' @return
#' logical vector (match or not for each element of `x`).
#' @family pattern-match-replacement-wrappers
#' @name grepl-wrappers
#' @examples
#' greplf("foo", c("foo", "Foo", "bar"))
#' grepli("foo", c("foo", "Foo", "bar"))
NULL

#' @rdname grepl-wrappers
#' @export
greplf <- function(pattern, x, useBytes = FALSE) {
  grepl(
    pattern = pattern, x = x, ignore.case = FALSE,
    perl = FALSE, fixed = TRUE, useBytes = useBytes
  )
}

#' @rdname grepl-wrappers
#' @export
grepli <- function(pattern, x, perl = FALSE, useBytes = FALSE) {
  grepl(
    pattern = pattern, x = x, ignore.case = TRUE,
    perl = perl, fixed = FALSE, useBytes = useBytes
  )
}

#-- grepv, grepvi, grepvf

#' @inherit grep-wrappers title details
#' @description
#' Strongly typed wrappers around [`grep`] that have the
#' `value` (see note), `ignore.case` and `fixed` arguments
#' set internally (as well as the conflicting arguments).
#'
#' If `grepv` is found in the current **R** version, it is
#' reexported from base.
#' @inheritParams grep-wrappers pattern x perl useBytes invert value
#' @param ignore.case
#' logical. if `FALSE`, the pattern matching is case sensitive
#' and if `TRUE`, case is ignored during matching.
#' @param fixed
#' logical. If `TRUE`, pattern is a string to be matched as is.
#' Overrides all conflicting arguments.
#' @return
#' character vector containing the selected elements of `x`
#' (after coercion, preserving names but no other attributes).
#'
#' `grepv()` can also return a vector of the indices of the
#' elements of `x` that yielded a match (or not, for
#' `invert = TRUE`) if `value = FALSE` (see note). This will
#' be an integer vector unless the input is a long vector,
#' when it will be a double vector.
#' @note
#' suppr wrappers of the base grep/sub functions remove the
#' arguments that relate to the strong typing, just like
#' `grepl` does by not having a `value` argument. However,
#' the base `grepv` implementation has kept the `value`
#' argument, so the version here keeps the `value` argument
#' for compatibility.
#' @family pattern-match-replacement-wrappers
#' @name grepv-wrappers
#' @examples
#' grepv("foo", c("foo", "Foo", "bar"))
#' grepvf("foo", c("foo", "Foo", "bar"))
#' grepvi("foo", c("foo", "Foo", "bar"))
NULL

#' @rdname grepv-wrappers
#' @export
grepv <- function(
  pattern, x, ignore.case = FALSE, perl = FALSE,
  value = TRUE, fixed = FALSE, useBytes = FALSE,
  invert = FALSE
) {
  grep(
    pattern = pattern, x = x, ignore.case = ignore.case,
    perl = perl, value = value, fixed = fixed,
    useBytes = useBytes, invert = invert
  )
}

if (exists("grepv", envir = baseenv())) {
  grepv <- get("grepv", envir = baseenv())
}

#' @rdname grepv-wrappers
#' @export
grepvf <- function(pattern, x, useBytes = FALSE, invert = FALSE) {
  grepv(
    pattern = pattern, x = x, ignore.case = FALSE,
    perl = FALSE, value = TRUE, fixed = TRUE,
    useBytes = useBytes, invert = invert
  )
}

#' @rdname grepv-wrappers
#' @export
grepvi <- function(
  pattern, x, perl = FALSE, useBytes = FALSE, invert = FALSE
) {
  grepv(
    pattern = pattern, x = x, ignore.case = TRUE,
    perl = perl, value = TRUE, fixed = FALSE,
    useBytes = useBytes, invert = invert
  )
}

#-- subi, subf

#' @title Pattern Replacement Wrappers
#' @description
#' Strongly typed wrappers around [`sub`] and [`gsub`] that have the
#' `fixed` and `ignore.case` arguments set internally (as well as
#' the conflicting arguments).
#' @inherit grep-wrappers details
#' @inheritParams grep-wrappers pattern x perl useBytes
#' @param replacement
#' a replacement for the matched pattern in sub and gsub. Coerced
#' to character if possible. For `fixed = FALSE` this can include
#' backreferences `"\1"` to `"\9"` to parenthesized subexpressions
#' of pattern. For `perl = TRUE` only, it can also contain `"\U"`
#' or `"\L"` to convert the rest of the replacement to upper or
#' lower case and `"\E"` to end case conversion. If a character
#' vector of length 2 or more is supplied, the first element is
#' used with a warning. If NA, all elements in the result
#' corresponding to matches will be set to `NA`.
#' @return
#' a character vector of the same length and with the same attributes
#' as `x` (after possible coercion to character). Elements of
#' character vectors `x` which are not substituted will be returned
#' unchanged (including any declared encoding if `useBytes = FALSE`).
#' If `useBytes = FALSE` a non-ASCII substituted result will often be
#' in UTF-8 with a marked encoding (e.g., if there is a UTF-8 input,
#' and in a multibyte locale unless `fixed = TRUE`). Such strings can
#' be re-encoded by [`enc2native`]. If any of the inputs is marked as
#' "bytes", elements of character vectors `x` which are substituted
#' will be returned marked as "bytes", but the encoding flag on
#' elements not substituted is unspecified (it may be the original or
#' "bytes"). If none of the inputs is marked as "bytes", but
#' `useBytes = TRUE` is given explicitly, the encoding flag is
#' unspecified even on the substituted elements (it may be "bytes" or
#' "unknown", possibly invalid in the current encoding). Mixed use of
#' "bytes" and other marked encodings is discouraged, but if still
#' desired one may use [`iconv`] to re-encode the result e.g. to UTF-8
#' with suitably substituted invalid bytes.
#' @family pattern-match-replacement-wrappers
#' @name sub-wrappers
#' @examples
#' subf("foo", "X", c("foo", "Foo", "bar"))
#' subi("foo", "X", c("foo", "Foo", "bar"))
#'
#' gsubf("foo", "X", c("foo foo", "Foo", "bar"))
#' gsubi("foo", "X", c("foo foo", "Foo", "bar"))
NULL

#' @rdname sub-wrappers
#' @export
subf <- function(pattern, replacement, x, useBytes = FALSE) {
  sub(
    pattern = pattern, replacement = replacement, x = x,
    ignore.case = FALSE, perl = FALSE, fixed = TRUE,
    useBytes = useBytes
  )
}

#' @rdname sub-wrappers
#' @export
subi <- function(
  pattern, replacement, x, perl = FALSE, useBytes = FALSE
) {
  sub(
    pattern = pattern, replacement = replacement, x = x,
    ignore.case = TRUE, perl = perl, fixed = FALSE,
    useBytes = useBytes
  )
}

# gsubi, gsubf

#' @rdname sub-wrappers
#' @export
gsubf <- function(pattern, replacement, x, useBytes = FALSE) {
  gsub(
    pattern = pattern, replacement = replacement, x = x,
    ignore.case = FALSE, perl = FALSE, fixed = TRUE,
    useBytes = useBytes
  )
}

#' @rdname sub-wrappers
#' @export
gsubi <- function(
  pattern, replacement, x, perl = FALSE, useBytes = FALSE
) {
  gsub(
    pattern = pattern, replacement = replacement, x = x,
    ignore.case = TRUE, perl = perl, fixed = FALSE,
    useBytes = useBytes
  )
}

test_that("bckQuote() tests", {
  expect_identical(bckQuote(character()), character())
  expect_identical(bckQuote(c("a", "b", "c")), c("`a`", "`b`", "`c`"))
  expect_identical(bckQuote(1:3), c("`1`", "`2`", "`3`"))
})

test_that("cat0() tests", {
  expect_output(cat0("a", "b", "c"), "abc")
  expect_identical(
    capture.output(cat0(1:3)),
    capture.output(cat(1:3, sep = ""))
  )
})

test_that("collapse tests", {
  expect_equal(collapse(character()), "")
  expect_equal(collapse0(character()), "")

  expect_equal(collapse(c("a", "b", "c")), "abc")
  expect_equal(collapse(c("a", "b", "c"), sep = ", "), "a, b, c")

  expect_equal(collapse0(c("a", "b", "c")), "abc")
  expect_equal(collapse0(c("a", "b", "c"), sep = ", "), "a, b, c")

  expect_equal(
    collapse(c("a", "b"), "c"),
    "a cb c"
  )

  expect_equal(
    collapse(c("a", "b"), "c", sep = ", "),
    "a c, b c"
  )

  expect_equal(
    collapse0(c("a", "b"), "c"),
    "acbc"
  )

  expect_equal(
    collapse0(c("a", "b"), "c", sep = ", "),
    "ac, bc"
  )
})

test_that("collapse() recurse = TRUE collapses each argument first", {
  expect_equal(
    collapse(
      c("a", "b"),
      c("c", "d"),
      sep = ", ",
      recurse = TRUE
    ),
    "a, b c, d"
  )

  expect_equal(
    collapse0(
      c("a", "b"),
      c("c", "d"),
      sep = ", ",
      recurse = TRUE
    ),
    "a, bc, d"
  )
})

test_that("listing() tests", {
  expect_equal(listing(character()), character())

  expect_equal(
    listing(c("a", "b", "c")),
    "a, b and c."
  )

  expect_equal(
    listing(c("a", "b"), conjunction = "or", period = FALSE),
    "a or b"
  )

  expect_equal(
    listing(c("a", "b", "c"), quote = "s"),
    paste0(sQuote("a"), ", ", sQuote("b"), " and ", sQuote("c"), ".")
  )

  expect_equal(
    listing(c("a", "b", "c"), quote = "d"),
    "\"a\", \"b\" and \"c\"."
  )

  expect_equal(
    listing(c("a", "b", "c"), quote = "b"),
    "`a`, `b` and `c`."
  )
})

test_that("grep wrappers match their base equivalents", {
  x <- c("Foo", "foo", "bar", "foo.bar", NA_character_)

  expect_identical(
    grepf("foo", x),
    grep("foo", x, fixed = TRUE)
  )
  expect_identical(
    grepf("foo", x, value = TRUE, invert = TRUE),
    grep("foo", x, fixed = TRUE, value = TRUE, invert = TRUE)
  )

  expect_identical(
    grepi("foo", x),
    grep("foo", x, ignore.case = TRUE)
  )
  expect_identical(
    grepi("f.o", x, perl = TRUE, value = TRUE),
    grep("f.o", x, ignore.case = TRUE, perl = TRUE, value = TRUE)
  )
})

test_that("grepl wrappers match their base equivalents", {
  x <- c("Foo", "foo", "bar", "foo.bar", NA_character_)

  expect_identical(
    greplf("foo", x),
    grepl("foo", x, fixed = TRUE)
  )
  expect_identical(
    grepli("foo", x),
    grepl("foo", x, ignore.case = TRUE)
  )
  expect_identical(
    grepli("f.o", x, perl = TRUE),
    grepl("f.o", x, ignore.case = TRUE, perl = TRUE)
  )
})

test_that("grepv wrappers match their base equivalents", {
  x <- c("Foo", "foo", "bar", "foo.bar", NA_character_)

  expect_identical(
    grepvf("foo", x),
    grep("foo", x, fixed = TRUE, value = TRUE)
  )
  expect_identical(
    grepvi("foo", x),
    grep("foo", x, ignore.case = TRUE, value = TRUE)
  )
})

test_that("sub/gsub wrappers match their base equivalents", {
  x <- c("Foo foo", "bar", "FOO")

  expect_identical(
    subf("foo", "X", x),
    sub("foo", "X", x, fixed = TRUE)
  )
  expect_identical(
    subi("foo", "X", x),
    sub("foo", "X", x, ignore.case = TRUE)
  )
  expect_identical(
    subi("(foo)", "\\1!", x, perl = TRUE),
    sub("(foo)", "\\1!", x, ignore.case = TRUE, perl = TRUE)
  )

  expect_identical(
    gsubf("foo", "X", x),
    gsub("foo", "X", x, fixed = TRUE)
  )
  expect_identical(
    gsubi("foo", "X", x),
    gsub("foo", "X", x, ignore.case = TRUE)
  )
  expect_identical(
    gsubi("(foo)", "\\1!", x, perl = TRUE),
    gsub("(foo)", "\\1!", x, ignore.case = TRUE, perl = TRUE)
  )
})

#' @title Where is the min or max?
#' @description
#' Determines the location (i.e., index) of the (first, last, or all)
#' minima or maxima of a numeric (or logical) vector.
#' @param x numeric (logical, integer or double) vector or an **R**
#' object for which the internal coercion to [double] works whose [min]
#' or [max] is searched for.
#' @param loc `'first'`, `'last'` or `'all'` to specify which
#' index/indices to return.
#' @param value value/s to replace the min or max values with when
#' using the assignment functions.
#' @return integer of indices. For the assignment functions, the
#' modified object with min or max values replaced by `value`.
#' @note
#' For `logical` vectors, `which(x)` is faster than
#' `whichMax(x, loc = "all")`, but `whichMin(x, loc = "all")` can
#' be faster than `which(!x)` for medium to large vectors due to
#' not having the performance cost of negating the vector.
#' @seealso [which], [which.max] and [which.min]
#' @examples
#' x <- c(1:4, 0:5, 11, 1:4, 0:5, 11)
#' whichMin(x)
#' whichMin(x, loc = "last")
#' whichMax(x)
#' whichMax(x, loc = "all")
#'
#' # it *does* work with NA's present, by discarding them:
#' presidents[1:30]
#' whichMin(presidents) # 28
#' whichMax(presidents) #  2
#'
#' # Find the first occurrence, i.e. the first TRUE, if there is at least one:
#' x <- rpois(10000, lambda = 10)
#' x[sample.int(50, 20)] <- NA
#' # where is the first value >= 20 ?
#' whichMax(x >= 20)
#' whichMax(x >= 20, loc = "last")
#' whichMax(x >= 20, loc = "all")
#'
#' # objects are coerced to numeric vectors if possible:
#' whichMin(list(A = 7, pi = pi)) ##  ->  c(pi = 2L)
#'
#' x <- 1:4
#' whichMin(x) <- 999
#' whichMax(x) <- -999
#' x
#' @export
whichMin <- function(x, loc = c("first", "last", "all")) {
  loc <- match.arg(loc, c("first", "last", "all"))
  switch(loc,
    first = which.min(x),
    last = .Call(C_which_last_min_max, x, 0L),
    all = .Call(C_which_all_min_max, x, 0L)
  )
}

#' @rdname whichMin
#' @export
whichMax <- function(x, loc = c("first", "last", "all")) {
  loc <- match.arg(loc, c("first", "last", "all"))
  switch(loc,
    first = which.max(x),
    last = .Call(C_which_last_min_max, x, 1L),
    all = .Call(C_which_all_min_max, x, 1L)
  )
}

#' @rdname whichMin
#' @export
`whichMin<-` <- function(x, loc = c("first", "last", "all"), value) {
  x[whichMin(x, loc = loc)] <- value
  x
}

#' @rdname whichMin
#' @export
`whichMax<-` <- function(x, loc = c("first", "last", "all"), value) {
  x[whichMax(x, loc = loc)] <- value
  x
}

#' @title Which indices are NA?
#' @description
#' Give the indices of `NA` values, allowing for array indices.
#' Use the assignment function `whichNA<-` to replace `NA` values
#' with a given value/s.
#' @param x numeric **R** object. Does not accept `complex` or `raw.`
#' @param value value/s to replace `NA` values with when using the
#' assignment function.
#' @return If using `whichNA`, integer vector of indices of `NA` values
#' in `x`, or matrix of array indices if `arr.ind` is `TRUE`.
#' If using `whichNA<-`, the modified object with `NA` values replaced by
#' `value`.
#' @details `whichNA<-` follows **R**'s usual recycling rules when
#' replacing `NA` values with `value`. If there are no `NA` values in `x`,
#' no replacement is made.
#' @seealso [is.na], [setNA], [whichMin], [whichMax]
#' @examples
#' x <- c(1, NA, 3, NA, 5)
#' whichNA(x)
#' whichNA(x) <- 0
#' x
#'
#' m <- matrix(c(1, NA, 3, NA, 5, NA), nrow = 2)
#' whichNA(m)
#'
#' y <- c("a" = 1, "b" = NA, "c" = 2, "d" = NA, "e" = NA, "f" = NA)
#' whichNA(y)
#' whichNA(y) <- c(91, 92) # value recycled to number of NA's
#' y
#' @export
whichNA <- function(x) {
  .Call(C_which_na, x)
}

#' @rdname whichNA
#' @export
`whichNA<-` <- function(x, value) {
  x[whichNA(x)] <- value
  x
}

test_that("whichMin() and whichMax() return correct indices", {
  x <- c(3, 1, 4, 1, 5, 9, 2, 6, 5, 9)

  expect_identical(whichMin(x), which.min(x))
  expect_identical(whichMax(x), which.max(x))

  expect_identical(whichMin(x, loc = "last"), 4L)
  expect_identical(whichMax(x, loc = "last"), 10L)

  expect_identical(whichMin(x, loc = "all"), c(2L, 4L))
  expect_identical(whichMax(x, loc = "all"), c(6L, 10L))
})

test_that("empty input or no min/max returns empty logical", {
  for (tst in list(
    numeric(0), integer(0), logical(0), character(0),
    NaN, NA_real_, NA_integer_, NA_character_
  )) {
    expect_identical(whichMin(tst), which.min(tst))
    expect_identical(whichMax(tst), which.max(tst))

    expect_identical(whichMin(tst, loc = "last"), integer(0))
    expect_identical(whichMax(tst, loc = "last"), integer(0))

    expect_identical(whichMin(tst, loc = "all"), integer(0))
    expect_identical(whichMax(tst, loc = "all"), integer(0))
  }
})

test_that("Inf and -Inf are handled correctly", {
  x <- c(3, 1, 4, Inf, 5, 9, -Inf, 6, 5, 9)

  expect_identical(whichMin(x), which.min(x))
  expect_identical(whichMax(x), which.max(x))

  expect_identical(whichMin(x, loc = "last"), 7L)
  expect_identical(whichMax(x, loc = "last"), 4L)

  expect_identical(whichMin(x, loc = "all"), 7L)
  expect_identical(whichMax(x, loc = "all"), 4L)
})

test_that("work on numeric and logical types", {
  for (tst in list(
    1:10, 1L:10, c(TRUE, FALSE, NA)
  )) {
    expect_identical(whichMin(tst), which.min(tst))
    expect_identical(whichMax(tst), which.max(tst))
    expect_no_error(whichMin(tst, loc = "last"))
    expect_no_error(whichMax(tst, loc = "last"))
    expect_no_error(whichMin(tst, loc = "all"))
    expect_no_error(whichMax(tst, loc = "all"))
  }
})

test_that("coerces to numeric where possible", {
  for (tst in list(
    c(1 + 0i, 2 + 0i, NA_complex_), list(1, 2, 3), c("1", "2", "3"),
    data.frame(x = 1, y = 2, z = 3), factor(c("a", "b", "c"))
  )) {
    expect_identical(whichMin(tst), which.min(tst))
    expect_identical(whichMax(tst), which.max(tst))
    expect_no_error(whichMin(tst, loc = "last"))
    expect_no_error(whichMax(tst, loc = "last"))
    expect_no_error(whichMin(tst, loc = "all"))
    expect_no_error(whichMax(tst, loc = "all"))
  }
})

test_that("errors if numeric coercion not possible", {
  for (tst in list(
    environment(), mean, call("mean"), data.frame(x = 1:3),
    list(1:3)
  )) {
    expect_error(whichMin(tst))
    expect_error(whichMax(tst))
    expect_error(whichMin(tst, loc = "last"))
    expect_error(whichMax(tst, loc = "last"))
    expect_error(whichMin(tst, loc = "all"))
    expect_error(whichMax(tst, loc = "all"))
  }
})

test_that("preserves names of input vector", {
  x <- c(a = 3, b = 1, b = 1, c = 4, d = 9, e = 9)
  nms <- names(x)
  expect_identical(names(whichMin(x)), names(which.min(x)))
  expect_identical(names(whichMax(x)), names(which.max(x)))

  expect_identical(names(whichMin(x, loc = "last")), nms[3L])
  expect_identical(names(whichMax(x, loc = "last")), nms[6L])

  expect_identical(names(whichMin(x, loc = "all")), nms[c(2L, 3L)])
  expect_identical(names(whichMax(x, loc = "all")), nms[c(5L, 6L)])
})

test_that("whichMin<- and whichMax<- modify the correct elements", {
  x <- c(3, 1, 4, 1, 5, 9, 2, 6, 5, 9)

  x1 <- x
  whichMin(x1) <- -999
  expect_identical(x1[2], -999)

  x2 <- x
  whichMax(x2) <- -999
  expect_identical(x2[6], -999)

  x3 <- x
  whichMin(x3, loc = "last") <- -999
  expect_identical(x3[4], -999)

  x4 <- x
  whichMax(x4, loc = "last") <- -999
  expect_identical(x4[10], -999)

  x5 <- x
  whichMin(x5, loc = "all") <- c(-999, 999)
  expect_identical(x5[c(2, 4)], c(-999, 999))

  x6 <- x
  whichMax(x6, loc = "all") <- c(-999, 999)
  expect_identical(x6[c(6, 10)], c(-999, 999))
})

test_that("whichNA() return correct indices", {
  x <- c(3, 1, 4, NA, 5, 9, NA, 6, 5, 9)
  expect_identical(whichNA(x), which(is.na(x)))
})

test_that("whichNA() also flags NaN's", {
  y <- c(1, Inf, -Inf, NaN, NA, 5)
  expect_identical(whichNA(y), which(is.na(y)))
})

test_that("empty input or no NA returns empty logical", {
  for (tst in list(
    numeric(0), integer(0), logical(0), character(0), list(),
    1:10, 1L:10, c(TRUE, FALSE), c(1.5, 2.5, 3.5), c("a", "b", "c")
  )) {
    expect_identical(whichNA(tst), which(is.na(tst)))
  }
})

test_that("work on numeric, logical, complex, chr, list, pairlist types", {
  # !Rf_isNumber(x) && TYPEOF(x) != STRSXP && TYPEOF(x) != VECSXP && TYPEOF(x) != LISTSXP
  for (tst in list(
    c(1.5, 2.5, NA), c(1L:3L, NA), c(TRUE, FALSE, NA), c("a", "b", NA),
    c(1 + 0i, 2 + 0i, NA), list(1, 2, NA), pairlist(a = 1, b = NA)
  )) {
    expect_identical(whichNA(tst), which(is.na(tst)))
  }
})

test_that("errors if wrong type", {
  for (tst in list(
    environment(), mean, call("mean")
  )) {
    expect_error(whichNA(tst))
  }
})

test_that("preserves names of input vector", {
  x <- c(a = 3, b = 1, b = 1, c = 4, d = 9, e = 9)
  nms <- names(x)
  expect_identical(names(whichNA(x)), names(which(is.na(x))))

  x <- list(a = 1, b = 2, c = NA, d = 4)
  nms <- names(x)
  expect_identical(names(whichNA(x)), names(which(is.na(x))))
})

test_that("whichNA<-() replaces NA values correctly", {
  x <- c(1, NA, 3, NA, 5)
  whichNA(x) <- 0
  expect_identical(x, c(1, 0, 3, 0, 5))

  y <- c("a" = 1, "b" = NA, "c" = 2, "d" = NA, "e" = NA, "f" = NA)
  whichNA(y) <- c(91, 92) # value recycled to number of NA's
  expect_identical(
    y,
    c("a" = 1, "b" = 91, "c" = 2, "d" = 92, "e" = 91, "f" = 92)
  )
})

#' @title Loading/Attaching Multiple Packages
#' @description Wraps [library()] and [require()] to
#' load multiple packages.
#' @param ...
#' the names of the packages, given as [name]s, character strings,
#' a combination of both, or character vectors (see `character.only`
#' below).
#' @param pos
#' the position on the search list at which to attach the loaded
#' namespace. Can also be the name of a position on the current
#' search list as given by [`search()`].
#' @param lib.loc
#' a character vector describing the location of **R** library trees to
#' search through, or `NULL`. The default value of `NULL` corresponds
#' to all libraries currently known to [`.libPaths()`]. Non-existent
#' library trees are silently ignored.
#' @param character.only
#' a logical indicating whether package or help can be assumed to be
#' character strings. If `TRUE`, dot arguments are coerced to be
#' character before being unlisted into a single character vector.
#' @param logical.return
#' logical. If it is `TRUE`, `FALSE` or `TRUE` is returned to indicate
#' success.
#' @param warn.conflicts
#' logical. If `TRUE`, warnings are printed about [conflicts] from
#' attaching the new package. A conflict is a function masking a
#' function, or a non-function masking a non-function. The default
#' is `TRUE` unless specified as `FALSE` in the `conflicts.policy` option.
#' @param quietly
#' a logical. If `TRUE`, no message confirming package attaching
#' is printed, and most often, no errors/warnings are printed
#' if package attaching fails.
#' @param verbose
#' a logical. If `TRUE`, additional diagnostics are printed.
#' @param mask.ok
#' character vector of names of objects that can mask objects on the
#' search path without signaling an error when strict conflict checking
#' is enabled.
#' @param exclude,include.only
#' character vector of names of objects to exclude or include in the
#' attached frame. Only one of these arguments may be used in a
#' call to `libraries` or `requires`.
#' @param attach.required
#' logical specifying whether required packages listed in the
#' `Depends` clause of the `DESCRIPTION` file should be attached
#' automatically.
#' @details All non-dot arguments are passed in their entirety to
#' each `library` or `require` call, so the same arguments are
#' used for each package.
#'
#' For the `help` of a package, call `library(help = <package>)`
#' directly.
#'
#' For full details see [library].
#' @return
#' `libraries()` and `requires()` return the value of the last
#' dot argument evaluated, invisibly:
#'
#' Normally `library` returns (invisibly) the list of attached
#' packages, but `TRUE` or `FALSE` if `logical.return` is `TRUE`.
#' When called as `library()` it returns an object of class
#' `"libraryIQR"`, and for `library(help=)`, one of class
#' `"packageInfo"`.
#'
#' `require` returns (invisibly) a logical indicating whether the
#' required package is available.
#' @seealso [attach], [detach], [install.packages]
#' @examples
#' libraries("stats", "graphics", methods)
#' requires("stats", graphics, "methods")
#'
#' x <- c("stats", "graphics")
#' libraries(x, "methods", character.only = TRUE)
#' try(requires(methods, x, character.only = TRUE))
#' @export
libraries <- function(
  ...,
  pos = 2,
  lib.loc = NULL,
  character.only = FALSE,
  logical.return = FALSE,
  warn.conflicts,
  quietly = FALSE,
  verbose = getOption("verbose"),
  mask.ok,
  exclude,
  include.only,
  attach.required = missing(include.only)
) {
  if (isTRUE(character.only)) {
    pkgs <- unlist(lapply(list(...), as.character))
  } else {
    pkgs <- as.character(subDots(...))
  }

  if (length(pkgs) == 0L) {
    return(
      library(
        pos = pos,
        lib.loc = lib.loc,
        character.only = character.only,
        logical.return = logical.return,
        warn.conflicts = warn.conflicts,
        quietly = quietly,
        verbose = verbose,
        mask.ok = mask.ok,
        exclude = exclude,
        include.only = include.only,
        attach.required = attach.required
      )
    )
  }

  for (pkg in pkgs) {
    x <- library(
      package = pkg,
      pos = pos,
      lib.loc = lib.loc,
      character.only = TRUE,
      logical.return = logical.return,
      warn.conflicts = warn.conflicts,
      quietly = quietly,
      verbose = verbose,
      mask.ok = mask.ok,
      exclude = exclude,
      include.only = include.only,
      attach.required = attach.required
    )
  }

  invisible(x)
}

#' @rdname libraries
#' @export
requires <- function(
  ...,
  lib.loc = NULL,
  quietly = FALSE,
  warn.conflicts,
  character.only = FALSE,
  mask.ok,
  exclude,
  include.only,
  attach.required = missing(include.only)
) {
  if (isTRUE(character.only)) {
    pkgs <- unlist(lapply(list(...), as.character))
  } else {
    pkgs <- as.character(subDots(...))
  }

  if (length(pkgs) == 0L) {
    return(
      require(
        lib.loc = lib.loc,
        quietly = quietly,
        warn.conflicts = warn.conflicts,
        character.only = character.only,
        mask.ok = mask.ok,
        exclude = exclude,
        include.only = include.only,
        attach.required = attach.required
      )
    )
  }

  for (pkg in pkgs) {
    x <- require(
      package = pkg,
      lib.loc = lib.loc,
      quietly = quietly,
      warn.conflicts = warn.conflicts,
      character.only = TRUE,
      mask.ok = mask.ok,
      exclude = exclude,
      include.only = include.only,
      attach.required = attach.required
    )
  }

  invisible(x)
}

#' @title Argument Verification
#' @description
#' `match.argv()` matches a given argument against a
#' list of candidate values as specified by `choices`.
#' @details
#' If `arg` is the same as `choices`, then the first element
#' of `arg` is returned. This check is done using
#' [`identical()`] with `ignore.environment = TRUE`, regardless
#' of the `match.fn` argument.
#'
#' In the one-argument form `match.argv(arg)`, the `choices`
#' are obtained from a default setting for the formal argument
#' `arg` of the function from which `match.argv` was called.
#' @param arg an **R** object.
#' @param choices a list of candidate values to match
#' against that will be extracted with `[[`.
#' @param match.fn a function to use for matching the
#' argument against the choices. This function must
#' take two arguments: the first is the argument to be
#' matched, and the second is a candidate value
#' extracted from `choices` with `[[`. It must return
#' a single `TRUE` or `FALSE` value indicating whether
#' the argument matches the candidate value.
#'
#' If `NULL`, the default matching function is used,
#' which checks for equality using`identical()` with
#' `ignore.environment = TRUE`.
#' @return
#' If `arg` is identical to `choices`, then the first
#' element of `arg` is returned. If `arg` is matched
#' against a candidate value in `choices`, then `arg`
#' is returned. If no match is found, an error is thrown.
#' @seealso [match.arg], [match.call], [match.fun].
#' @examples
#' # default matching function is strict.
#' match.argv(1:10, list(c("a", "b"), list(1, 2), 1:10))
#' try(match.argv(1, list(c("a", "b"), list(1, 2), 1:10)))
#'
#' # NULL can be given as a candidate.
#' match.argv(NULL, list(NULL, 1:10))
#'
#' # default matching function is strict.
#' try(match.argv(NA, list(NA_real_, NA_integer_, NA_character_)))
#'
#' # a custom matching function can be used.
#' match.argv("A", list("a", "b", "c"), match.fn = function(x, y) {
#'   is.character(x) && length(x) == 1L && tolower(x) == tolower(y)
#' })
#' @export
match.argv <- function(arg, choices, match.fn = NULL) {
  defaults <- NULL

  if (missing(choices)) {
    formal.args <- formals(
      sys.function(sys_p <- sys.parent())
    )

    defaults <- formal.args[[as.character(substitute(arg))]]

    choices <- eval(
      defaults,
      envir = sys.frame(sys_p)
    )
  }

  if (is.null(defaults)) {
    defaults <- substitute(choices)
  }

  if (!is.list(choices)) {
    stop(sQuote("choices"), " must be a list.")
  }

  if (is.null(match.fn)) {
    match.fn <- function(x, y) {
      identical(x, y, ignore.environment = TRUE)
    }
  } else {
    if (!is.function(match.fn)) {
      stop(sQuote("match.fn"), " must be a function.")
    }
  }

  # if arg and choices same, return [[1]]
  if (identical(arg, choices, ignore.environment = TRUE)) {
    return(arg[[1]])
  }

  # for loop for early return, ignore subsequent matches
  for (i in seq_along(choices)) {
    if (match.fn(arg, choices[[i]])) {
      return(choices[[i]])
    }
  }

  defaults <- as.list(defaults)[-1]

  err_args <- collapse(
    vapply(
      defaults,
      fmt_err_arg,
      character(1)
    ),
    sep = ", "
  )

  stop(
    sprintf(
      ngettext(
        length(defaults),
        "'arg' should be: %s",
        "'arg' should be one of: %s"
      ),
      err_args
    ),
    domain = NA
  )
}

fmt_err_arg <- function(x) {
  if (is.character(x) && length(x) == 1L) {
    sQuote(x)
  } else {
    deparse1(x)
  }
}

test_that("match.argv() returns an exact matching object", {
  expect_identical(
    match.argv(1:3, list("a", 1:3, TRUE)),
    1:3
  )

  expect_identical(
    match.argv(NULL, list(1:3, NULL)),
    NULL
  )

  expect_identical(
    match.argv(list(a = 1), list(list(a = 1), list(b = 2))),
    list(a = 1)
  )
})

test_that("match.argv() uses strict matching by default", {
  expect_error(
    match.argv(1, list(1L))
  )

  expect_error(
    match.argv(NA, list(NA_real_, NA_integer_, NA_character_))
  )

  expect_identical(
    match.argv(NA_integer_, list(NA_integer_)),
    NA_integer_
  )

  expect_identical(
    match.argv(1L, list(1L)),
    1L
  )
})

test_that("match.argv() ignores function environments", {
  f1 <- function(x) x
  f2 <- local({
    y <- 1
    function(x) x
  })

  expect_identical(
    match.argv(f1, list(f2)),
    f2
  )
})

test_that("match.argv() returns the first matching choice", {
  expect_identical(
    match.argv(
      1,
      list(1, 1, 1),
      match.fn = function(x, y) x == y
    ),
    1
  )
})

test_that("match.argv() supports custom matching functions", {
  expect_identical(
    match.argv(
      "A",
      list("a", "b", "c"),
      match.fn = function(x, y) tolower(x) == y
    ),
    "a"
  )

  expect_identical(
    match.argv(
      5,
      list(1:3, 4:6),
      match.fn = function(x, y) x %in% y
    ),
    4:6
  )
})

test_that("match.argv() validates choices", {
  expect_error(
    match.argv(1, 1:5),
    "'choices' must be a list."
  )
})

test_that("match.argv() validates match.fn", {
  expect_error(
    match.argv(1, list(1), match.fn = 1),
    "'match.fn' must be a function."
  )
})

test_that("match.argv() errors when no match is found", {
  expect_snapshot(error = TRUE, {
    match.argv(4, list(1, 2, 3))
  })
})

test_that(
  "match.argv() uses formal argument defaults when choices is omitted",
  {
    f <- function(x = c("a", "b", "c")) {
      match.argv(x)
    }

    expect_error(f("a"), "'choices' must be a list.")

    f <- function(x = list("a", "b", "c")) {
      match.argv(x)
    }

    expect_identical(
      f("a"),
      "a"
    )

    expect_snapshot(error = TRUE, {
      f("d")
    })
  }
)

test_that("match.argv() works with list defaults", {
  f <- function(x = list(1:3, letters[1:3], NULL)) {
    match.argv(x)
  }

  expect_identical(
    f(NULL),
    NULL
  )

  expect_identical(
    f(1:3),
    1:3
  )
})

test_that("match.argv() returns the choice object", {
  x <- structure(1:3, class = "myclass")

  expect_identical(
    match.argv(x, list(x)),
    x
  )
})

test_that(
  "match.argv() returns arg[[1]] when arg and choices are identical",
  {
    x <- list(1L, "a", TRUE)

    expect_identical(
      match.argv(x, x),
      x[[1]]
    )

    f <- function(x = list(1L, "a", TRUE)) {
      match.argv(x)
    }

    expect_identical(
      f(list(1L, "a", TRUE)),
      1L
    )

    expect_identical(
      f(),
      1L
    )

    x <- list(structure(1:3, class = "myclass"), 1L)

    expect_identical(
      match.argv(x, x),
      x[[1]]
    )
  }
)

#' @title Is a Number Even or Odd?
#' @description Show where a numeric input is even or odd.
#' @param x numeric (logical, integer or double) vector.
#' @param noparity.na logical, whether values without parity
#' (e.g., `NA`, `NaN`, `Inf`, `-Inf`, and decimal numbers)
#' should return `NA` (when `noparity.na = TRUE`) or `FALSE`
#' (when `noparity.na = FALSE`).
#' @return logical vector the length of `x`.
#' @examples
#' is.even(2)
#' is.odd(1)
#'
#' is.even(-5:5)
#' is.odd(-5:5)
#'
#' m <- matrix(1:4, nrow = 2, ncol = 2)
#' is.even(m)
#' is.odd(m)
#'
#' # inputs without parity can be handled as NA or FALSE:
#' x <- c(2.0, 3.0, 2.2, 3.1, NA, Inf, -Inf, NaN)
#' is.even(x)
#' is.odd(x)
#' is.even(x, noparity.na = TRUE)
#' is.odd(x, noparity.na = TRUE)
#' @export
is.even <- function(x, noparity.na = FALSE) {
  if (isTRUE(noparity.na)) {
    .Call(C_is_even_odd, x, 0L, 1L)
  } else {
    .Call(C_is_even_odd, x, 0L, 0L)
  }
}

#' @export
#' @rdname is.even
is.odd <- function(x, noparity.na = FALSE) {
  if (isTRUE(noparity.na)) {
    .Call(C_is_even_odd, x, 1L, 1L)
  } else {
    .Call(C_is_even_odd, x, 1L, 0L)
  }
}

test_that("is.even() and is.odd() classify parity", {
  x <- c(-2L, -1L, 0L, 1L, 2L)

  expect_identical(is.even(x), c(TRUE, FALSE, TRUE, FALSE, TRUE))
  expect_identical(is.odd(x), c(FALSE, TRUE, FALSE, TRUE, FALSE))
})

test_that("noparity.na controls how non-parity values are treated", {
  x <- c(2, 3, 2.2, NA, Inf, -Inf, NaN)

  expect_identical(
    is.even(x),
    c(TRUE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE)
  )

  expect_identical(
    is.odd(x),
    c(FALSE, TRUE, FALSE, FALSE, FALSE, FALSE, FALSE)
  )

  expect_identical(
    is.even(x, noparity.na = TRUE),
    c(TRUE, FALSE, NA, NA, NA, NA, NA)
  )

  expect_identical(
    is.odd(x, noparity.na = TRUE),
    c(FALSE, TRUE, NA, NA, NA, NA, NA)
  )
})

test_that("is.even() and is.odd() return logical(0) for empty inputs", {
  expect_identical(is.even(numeric(0)), logical(0))
  expect_identical(is.odd(numeric(0)), logical(0))
})

test_that("is.even() and is.odd() work on logical and numeric types", {
  for (tst in list(
    1.5:10.5, 1L:10, c(TRUE, FALSE, NA), matrix(1:10, nrow = 2),
    array(1:10, dim = c(2, 5))
  )) {
    expect_no_error(is.even(tst))
    expect_no_error(is.odd(tst))
  }
})

test_that("is.even() and is.odd() error on incorrect types", {
  for (tst in list(
    list(1:10), environment(), mean, data.frame(x = 1), call("mean"),
    c("1", "2", "3"), factor(c("a", "b", "c")), c(1 + 0i, 2 + 0i, NA_complex_),
    raw(10)
  )) {
    expect_error(is.even(tst))
    expect_error(is.odd(tst))
  }
})

test_that("is.even() and is.odd() preserve names", {
  x <- c(a = 2, b = 3, c = 4)

  expect_named(is.even(x), names(x))
  expect_named(is.odd(x), names(x))
})

#' @title Determine Repeated Elements
#' @description
#' Return a logical vector, indices, or the values of repeated elements
#' in a vector.
#' @details
#' The `repeated` functions determine which elements of a vector
#' or data frame are duplicates of elements with smaller subscripts.
#' They are very similar in functionality to [duplicated] but
#' instead mark **all** duplicates (not just those after the
#' first/last occurrence), and do not have an `incomparables`
#' argument.
#'
#' These are generic functions with methods for vectors
#' (including lists and expressions), data frames and arrays
#' (including matrices).
#'
#' The array method calculates for each element of the sub-array
#' specified by `MARGIN` if the dimensions are identical
#' to those for an earlier or later element (in row-major order).
#' This would most commonly be used to find repeated rows
#' (the default) or columns (with `MARGIN = 2`). Note that
#' `MARGIN = 0` returns an array of the same dimensionality
#' attributes as `x`.
#'
#' `non.unique()` is an alias for `repeats()`.
#' @param x a vector, a data frame, an array, or `NULL`.
#' @param ... additional arguments passed to methods.
#' @param MARGIN the array margin to be held fixed: see [apply],
#' and note that `MARGIN = 0` may be useful.
#' @return
#' `repeated()`: For a vector input, a logical vector of the
#' same length as `x`. For a data frame, a logical vector
#' with one element for each row. For a matrix or array, and
#' when `MARGIN = 0`, a logical array with the same dimensions
#' and dimnames.
#'
#' `whichRepeated()`: For a vector input, an integer vector
#' giving the indices of the repeated values. For a data frame,
#' an integer vector giving the indices of the repeated rows.
#' For a matrix or array, an integer vector giving the indices
#' of the repeated elements across the margin specified.
#'
#' `repeats()` and its alias `non.unique()`: an object of
#' the same type as `x`, containing the repeated values
#' (vector input), rows (data frame input), or elements across
#' the margin (matrix/array input).
#' @seealso [duplicated] and [unique].
#' @examples
#' # Repeated values in a vector
#' x <- c(1, 2, 3, 2, 1)
#'
#' repeated(x)
#' whichRepeated(x)
#' repeats(x)
#'
#' # Repeated rows in a data frame
#' df <- data.frame(
#'   x = c(1, 2, 1),
#'   y = c("a", "b", "a")
#' )
#'
#' repeated(df)
#' repeats(df)
#'
#' # Repeated rows/columns in a matrix
#' m <- cbind(
#'   c(1, 2),
#'   c(3, 4),
#'   c(1, 2)
#' )
#'
#' repeated(m)
#' repeated(m, MARGIN = 2)
#' repeats(m, MARGIN = 2)
#'
#' # non.unique() is an alias for repeats()
#' identical(repeats(x), non.unique(x))
#' @export
repeated <- function(x, ...) {
  UseMethod("repeated")
}

# handle same cases as base::duplicated, in the same way
#' @export
repeated.default <- function(x, ...) {
  .Call(C_repeated, x)
}

#' @export
repeated.data.frame <- function(x, ...) {
  n <- length(x)
  if (!n) {
    !logical(nrow(x))
  } else if (n == 1L) {
    repeated(x[[1L]], ...)
  } else {
    x <- .prep_repeat_df(x)
    repeated(
      do.call(Map, `names<-`(c(list, x), NULL))
    )
  }
}

#' @rdname repeated
#' @export
repeated.array <- function(x, MARGIN = 1L, ...) {
  .repeated_array_matrix(x, MARGIN, ...)
}

#' @export
repeated.matrix <- function(x, MARGIN = 1L, ...) {
  .repeated_array_matrix(x, MARGIN, ...)
}

.repeated_array_matrix <- function(x, MARGIN = 1L, ...) {
  dx <- dim(x)
  ndim <- length(dx)
  y <- .prep_repeat_array(x, MARGIN, dx, ndim)

  res <- repeated.default(y, ...)

  dim(res) <- dim(y)
  dimnames(res) <- dimnames(y)

  res
}

#' @rdname repeated
#' @export
whichRepeated <- function(x, ...) {
  UseMethod("whichRepeated")
}

#' @export
whichRepeated.default <- function(x, ...) {
  .Call(C_repeated_indices, x)
}

#' @export
whichRepeated.data.frame <- function(x, ...) {
  n <- length(x)

  if (!n) {
    integer(0L)
  } else if (n == 1L) {
    whichRepeated(x[[1L]], ...)
  } else {
    x <- .prep_repeat_df(x)
    whichRepeated(
      do.call(Map, `names<-`(c(list, x), NULL))
    )
  }
}

#' @rdname repeated
#' @export
whichRepeated.array <- function(x, MARGIN = 1L, ...) {
  .whichRepeated_array_matrix(x, MARGIN, ...)
}

#' @export
whichRepeated.matrix <- function(x, MARGIN = 1L, ...) {
  .whichRepeated_array_matrix(x, MARGIN, ...)
}

.whichRepeated_array_matrix <- function(x, MARGIN = 1L, ...) {
  dx <- dim(x)
  ndim <- length(dx)
  y <- .prep_repeat_array(x, MARGIN, dx, ndim)

  whichRepeated.default(y, ...)
}

#' @rdname repeated
#' @export
repeats <- function(x, ...) {
  UseMethod("repeats")
}

# handle same cases as base::unique, in the same way
#' @export
repeats.default <- function(x, ...) {
  if (!is.object(x)) {
    return(.Call(C_repeats, x))
  }

  if (is.factor(x)) {
    return(
      factor(
        .Call(C_repeats, x),
        levels = seq_len(nlevels(x)),
        labels = levels(x),
        ordered = is.ordered(x)
      )
    )
  }

  res <- .Call(C_repeats, x)

  if (inherits(x, "POSIXct")) {
    .POSIXct(res, attr(x, "tzone"), class(x))
  } else if (inherits(x, "Date")) {
    .Date(res, class(x))
  } else if (inherits(x, "difftime")) {
    .difftime(res, attr(x, "units"), class(x))
  } else {
    res
  }
}

#' @export
repeats.data.frame <- function(x, ...) {
  x[repeated.data.frame(x, ...), , drop = FALSE]
}

#' @rdname repeated
#' @export
repeats.array <- function(x, MARGIN = 1L, ...) {
  .repeats_array_matrix(x, MARGIN, ...)
}

#' @export
repeats.matrix <- function(x, MARGIN = 1L, ...) {
  .repeats_array_matrix(x, MARGIN, ...)
}

.repeats_array_matrix <- function(x, MARGIN = 1L, ...) {
  dx <- dim(x)
  ndim <- length(dx)
  temp <- .prep_repeat_array(x, MARGIN, dx, ndim, msize = 1L)

  args <- rep(alist(a = ), ndim)
  names(args) <- NULL

  args[[MARGIN]] <- repeated.default(temp, ...)
  do.call(`[`, c(list(x), args, list(drop = FALSE)))
}

#' @rdname repeated
#' @export
non.unique <- function(x, ...) {
  repeats(x, ...)
}

.prep_repeat_df <- function(x) {
  if (any(i <- vapply(x, is.factor, NA))) {
    x[i] <- lapply(x[i], as.numeric)
  }

  if (any(i <- lengths(lapply(x, dim)) == 2L)) {
    x[i] <- lapply(x[i], split.data.frame, seq_len(nrow(x)))
  }

  x
}

.prep_repeat_array <- function(x, MARGIN, dx, ndim, msize = NULL) {
  i <- if (!is.null(msize)) {
    length(MARGIN) != msize || (MARGIN > ndim)
  } else {
    any(MARGIN > ndim)
  }

  if (i) {
    stop(
      gettextf(
        "MARGIN = %s is invalid for dim = %s",
        paste(MARGIN, collapse = ","),
        paste(dx, collapse = ",")
      ),
      domain = NA
    )
  }

  if ((ndim > 1L) && (prod(dx[-MARGIN]) > 1L)) {
    asplit(x, MARGIN, TRUE)
  } else {
    x
  }
}

vectors <- list(
  empty_integer = integer(),
  empty_character = character(),
  empty_logical = logical(),
  integer_unique = 1:10,
  integer_repeated = c(1, 2, 3, 2, 4, 1, 5, 1),
  double = c(1, 2, 2, 3.5, 1, 5.5),
  logical = c(TRUE, FALSE, TRUE, TRUE, FALSE),
  character = c("a", "b", "a", "c", "b", "d"),
  factor = factor(c("a", "b", "a", "c", "b")),
  raw = as.raw(c(1, 2, 3, 2, 1)),
  complex = c(1 + 1i, 2 + 2i, 1 + 1i, 3 + 0i),
  integer_na = c(1L, NA, 2L, NA, 1L),
  double_na = c(1, NA_real_, NaN, NaN, 1, NA_real_),
  character_na = c("a", NA, "b", NA, "a"),
  logical_na = c(TRUE, NA, FALSE, NA, TRUE),
  all_same = rep(42L, 10),
  alternating = rep(1:2, 5),
  singleton = 1L
)

br_repeated <- function(x) {
  duplicated(x, fromLast = FALSE) | duplicated(x, fromLast = TRUE)
}

br_whichRepeated <- function(x) {
  which(br_repeated(x))
}

br_repeats <- function(x) {
  x[br_repeated(x)]
}

test_that("basic API works", {
  x <- c(1, 2, 3, 2, 1)

  expect_identical(
    repeated(x),
    c(TRUE, TRUE, FALSE, TRUE, TRUE)
  )

  expect_identical(
    whichRepeated(x),
    c(1L, 2L, 4L, 5L)
  )

  expect_identical(
    repeats(x),
    c(1, 2, 2, 1)
  )
})

test_that("all unique values", {
  x <- 1:5

  expect_false(any(repeated(x)))
  expect_length(whichRepeated(x), 0)
  expect_length(repeats(x), 0)
})

test_that("all duplicated values", {
  x <- rep(1L, 5)

  expect_true(all(repeated(x)))
  expect_identical(whichRepeated(x), 1:5)
  expect_identical(repeats(x), x)
})

test_that("repeated matches reference implementation", {
  for (nm in names(vectors)) {
    x <- vectors[[nm]]

    expect_identical(
      repeated(x),
      br_repeated(x),
      info = nm
    )

    expect_identical(
      whichRepeated(x),
      br_whichRepeated(x),
      info = nm
    )

    expect_identical(
      repeats(x),
      br_repeats(x),
      info = nm
    )
  }
})

test_that("random integer vectors agree with reference", {
  set.seed(1)

  for (i in seq_len(100)) {
    x <- sample(1:20, size = 200, replace = TRUE)

    expect_identical(repeated(x), br_repeated(x))
    expect_identical(whichRepeated(x), br_whichRepeated(x))
    expect_identical(repeats(x), br_repeats(x))
  }
})

test_that("Date vectors", {
  x <- as.Date(c(
    "2020-01-01",
    "2020-01-02",
    "2020-01-01",
    "2020-01-03",
    "2020-01-02"
  ))

  expect_identical(repeated(x), br_repeated(x))
  expect_identical(whichRepeated(x), br_whichRepeated(x))
  expect_identical(repeats(x), br_repeats(x))
})

test_that("POSIXct vectors", {
  x <- as.POSIXct(c(
    "2020-01-01 00:00:00",
    "2020-01-01 01:00:00",
    "2020-01-01 00:00:00",
    "2020-01-01 02:00:00"
  ), tz = "UTC")

  expect_identical(repeated(x), br_repeated(x))
  expect_identical(whichRepeated(x), br_whichRepeated(x))
  expect_identical(repeats(x), br_repeats(x))
})

test_that("difftime vectors", {
  x <- as.difftime(c(1, 2, 1, 3, 2), units = "hours")

  expect_identical(repeated(x), br_repeated(x))
  expect_identical(whichRepeated(x), br_whichRepeated(x))
  expect_identical(repeats(x), br_repeats(x))
})

test_that("ordered factors", {
  x <- ordered(c("low", "med", "low", "high", "med"))

  expect_identical(repeated(x), br_repeated(x))
  expect_identical(whichRepeated(x), br_whichRepeated(x))
  expect_identical(repeats(x), br_repeats(x))
})

test_that("expression vectors", {
  x <- expression(x, y, x, z, y)

  expect_identical(repeated(x), br_repeated(x))
  expect_identical(whichRepeated(x), br_whichRepeated(x))
  expect_identical(repeats(x), br_repeats(x))
})

test_that("named vectors preserve names", {
  x <- c(a = 1, b = 2, c = 1, d = 3, e = 2)

  expect_equal(
    repeated(x),
    br_repeated(x),
    ignore_attr = TRUE
  )
  expect_named(repeated(x), names(x))

  expect_equal(
    whichRepeated(x),
    br_whichRepeated(x),
    ignore_attr = TRUE
  )
  expect_named(whichRepeated(x), c("a", "b", "c", "e"))

  expect_equal(
    repeats(x),
    br_repeats(x),
    ignore_attr = TRUE
  )
  expect_named(repeats(x), c("a", "b", "c", "e"))
})

test_that("zero-length vectors of many types", {
  xs <- list(
    integer(),
    double(),
    logical(),
    character(),
    complex(),
    raw(),
    factor(character()),
    as.Date(character()),
    as.POSIXct(character(), tz = "UTC")
  )

  for (x in xs) {
    expect_identical(repeated(x), br_repeated(x))
    expect_identical(whichRepeated(x), br_whichRepeated(x))
    expect_identical(repeats(x), br_repeats(x))
  }
})

test_that("list vectors", {
  x <- list(
    1,
    "a",
    1,
    TRUE,
    "a",
    TRUE
  )

  expect_identical(repeated(x), br_repeated(x))
  expect_identical(whichRepeated(x), br_whichRepeated(x))
  expect_identical(repeats(x), br_repeats(x))
})

test_that("lists containing objects", {
  x <- list(
    1:3,
    letters[1:2],
    1:3,
    data.frame(x = 1:2),
    data.frame(x = 1:2)
  )

  expect_identical(repeated(x), br_repeated(x))
  expect_identical(whichRepeated(x), br_whichRepeated(x))
  expect_identical(repeats(x), br_repeats(x))
})

test_that("matrix repeated defaults to repeated rows", {
  x <- rbind(
    c(1, 2),
    c(1, 2),
    c(3, 4),
    c(3, 4)
  )

  expect_identical(
    repeated(x),
    structure(c(TRUE, TRUE, TRUE, TRUE), dim = 4L)
  )

  expect_identical(
    whichRepeated(x),
    1:4
  )

  expect_identical(
    repeats(x),
    x
  )
})

test_that("matrix repeated finds repeated columns with MARGIN = 2", {
  x <- cbind(
    c(1, 2),
    c(3, 4),
    c(1, 2)
  )

  expect_identical(
    repeated(x, MARGIN = 2),
    structure(c(TRUE, FALSE, TRUE), dim = 3L)
  )

  expect_identical(
    whichRepeated(x, MARGIN = 2),
    c(1L, 3L)
  )

  expect_identical(
    repeats(x, MARGIN = 2),
    x[, c(1, 3), drop = FALSE]
  )
})

test_that("matrix MARGIN = 0 returns element-wise result", {
  x <- matrix(
    c(
      1, 2,
      1, 2
    ),
    nrow = 2
  )

  expect_identical(
    dim(repeated(x, MARGIN = 0)),
    dim(x)
  )

  expect_identical(
    repeated(x, MARGIN = 0),
    matrix(
      c(TRUE, TRUE, TRUE, TRUE),
      nrow = 2
    )
  )

  expect_identical(
    whichRepeated(x, MARGIN = 0),
    1:4
  )
})

test_that("matrix repeated has one value per row", {
  x <- matrix(
    1:9,
    nrow = 3,
    dimnames = list(
      c("a", "b", "c"),
      c("x", "y", "z")
    )
  )

  res <- repeated(x)

  expect_identical(dim(res), 3L)
  expect_identical(dimnames(res), list(c("a", "b", "c")))
})

test_that("3 dimensional arrays repeat slices by MARGIN", {
  x <- array(0, c(2, 2, 3))

  x[, , 1] <- matrix(c(
    1, 2,
    3, 4
  ), 2)

  x[, , 2] <- matrix(c(
    5, 6,
    7, 8
  ), 2)

  x[, , 3] <- matrix(c(
    1, 2,
    3, 4
  ), 2)

  expect_identical(
    repeated(x, MARGIN = 3),
    structure(c(TRUE, FALSE, TRUE), dim = 3L)
  )

  expect_identical(
    whichRepeated(x, MARGIN = 3),
    c(1L, 3L)
  )

  expect_identical(
    repeats(x, MARGIN = 3),
    x[, , c(1, 3), drop = FALSE]
  )
})

test_that("3 dimensional arrays repeat rows", {
  x <- array(0, c(2, 2, 2))

  x[1, , ] <- 1
  x[2, , ] <- 1

  expect_identical(
    repeated(x, MARGIN = 1),
    structure(c(TRUE, TRUE), dim = 2L)
  )

  expect_identical(
    whichRepeated(x, MARGIN = 1),
    c(1L, 2L)
  )
})

test_that("3 dimensional arrays with MARGIN = 0 operate element-wise", {
  x <- array(
    c(
      1, 2,
      1, 2,
      3, 4
    ),
    dim = c(3, 2, 1)
  )

  res <- repeated(x, MARGIN = 0)

  expect_identical(
    dim(res),
    dim(x)
  )

  expect_true(all(res[1:4]))
})

test_that(
  "matrix and array methods agree with vectorised behaviour for MARGIN = 0",
  {
    x <- matrix(
      c(1, 2, 1, 2),
      nrow = 2
    )

    expect_identical(
      whichRepeated(x, MARGIN = 0),
      whichRepeated(as.vector(x))
    )

    expect_identical(
      repeated(x, MARGIN = 0),
      matrix(
        repeated(as.vector(x)),
        nrow = 2
      )
    )
  }
)

test_that("invalid MARGIN is rejected", {
  x <- matrix(1:4, 2)

  expect_error(repeated(x, MARGIN = 3))
  expect_error(whichRepeated(x, MARGIN = 3))
  expect_error(repeats(x, MARGIN = 3))
})

test_that("repeated() matches duplicated() dimensions and dimnames", {
  x <- array(
    seq_len(24),
    dim = c(2, 3, 4),
    dimnames = list(
      c("r1", "r2"),
      c("c1", "c2", "c3"),
      c("s1", "s2", "s3", "s4")
    )
  )

  for (m in 0:3) {
    expect_identical(
      dim(repeated(x, MARGIN = m)),
      dim(duplicated(x, MARGIN = m)),
      info = paste("MARGIN =", m)
    )

    expect_identical(
      dimnames(repeated(x, MARGIN = m)),
      dimnames(duplicated(x, MARGIN = m)),
      info = paste("MARGIN =", m)
    )
  }
})

test_that("%''% and %\"\"% tests", {
  expect_identical("" %''% "default", "default")
  expect_identical("value" %''% "default", "value")
  expect_identical("" %""% "default", "default")
  expect_identical("value" %""% "default", "value")
})

test_that("%!||% tests", {
  expect_identical(NULL %!||% "default", NULL)
  expect_identical("value" %!||% "default", "default")
})

test_that("%0% tests", {
  expect_identical(integer(0) %0% 5L, 5L)
  expect_identical(c(1, 2, 3) %0% 5L, c(1, 2, 3))
})

test_that("%allin% tests", {
  expect_true(c(1, 2, 3) %allin% c(1, 2, 3, 4))
  expect_false(c(1, 2, 3) %allin% c(1, 2))
  expect_true(NA %allin% c(1, NA))
  expect_false(c(1, NA) %allin% NA)
})

test_that("%allin% NULL checks", {
  expect_identical(NULL %allin% c(1, 2, 3), logical(0))
  expect_false(c(1, 2, 3) %allin% NULL)
  expect_identical(NULL %allin% NULL, logical(0))
  expect_true(list(1, NULL) %allin% list(1, NULL))
})

test_that("%anyin% tests", {
  expect_true(c(1, 2, 3) %anyin% c(1, 2, 3, 4))
  expect_true(c(1, 2, 3) %anyin% c(1, 2))
  expect_true(NA %anyin% c(1, NA))
  expect_true(c(1, NA) %anyin% NA)
})

test_that("%anyin% NULL checks", {
  expect_identical(NULL %anyin% c(1, 2, 3), logical(0))
  expect_false(c(1, 2, 3) %anyin% NULL)
  expect_identical(NULL %anyin% NULL, logical(0))
  expect_true(list(1, NULL) %anyin% list(NULL, 2))
})

test_that("%nonein% tests", {
  expect_false(c(1, 2, 3) %nonein% c(1, 2, 3, 4))
  expect_false(c(1, 2, 3) %nonein% c(1, 2))
  expect_true(c(6, 7, 8) %nonein% c(1, 2, 3, 4, 5))
  expect_false(NA %nonein% c(1, NA))
  expect_false(c(1, NA) %nonein% NA)
})

test_that("%nonein% NULL checks", {
  expect_identical(NULL %nonein% c(1, 2, 3), logical(0))
  expect_true(c(1, 2, 3) %nonein% NULL)
  expect_identical(NULL %nonein% NULL, logical(0))
  expect_false(list(1, NULL) %nonein% list(NULL, 2))
})

test_that("%onein% tests", {
  expect_false(c(1, 2, 3) %onein% c(1, 2, 3, 4))
  expect_false(c(1, 2, 3) %onein% c(1, 2))
  expect_true(c(5, 6, 7, 8) %onein% c(1, 2, 3, 4, 5))
  expect_true(NA %onein% c(1, NA))
  expect_true(c(1, NA) %onein% NA)
})

test_that("%onein% NULL checks", {
  expect_identical(NULL %onein% c(1, 2, 3), logical(0))
  expect_false(c(1, 2, 3) %onein% NULL)
  expect_identical(NULL %onein% NULL, logical(0))
  expect_true(list(1, NULL) %onein% list(NULL, 2))
})

test_that("%notin% tests", {
  expect_identical(c(1, 2, 3) %notin% c(1, 2, 3, 4), c(FALSE, FALSE, FALSE))
  expect_identical(c(1, 2, 3) %notin% c(1, 2), c(FALSE, FALSE, TRUE))
  expect_identical(c(6, 7, 8) %notin% c(1, 2, 3, 4, 5), c(TRUE, TRUE, TRUE))
  expect_identical(NA %notin% c(1, NA), FALSE)
  expect_identical(c(1, NA) %notin% NA, c(TRUE, FALSE))
})

test_that("%notin% NULL checks", {
  expect_identical(NULL %notin% c(1, 2, 3), logical(0))
  expect_identical(c(1, 2, 3) %notin% NULL, c(TRUE, TRUE, TRUE))
  expect_identical(NULL %notin% NULL, logical(0))
  expect_identical(list(1, NULL) %notin% list(NULL, 2), c(TRUE, FALSE))
})

# stopifnot2() snapshot

    Code
      stopifnot2(all.equal(c("a", "b", "c"), c("a", "x", "z")))
    Condition
      Error:
      ! c("a", "b", "c") and c("a", "x", "z") are not equal:
        2 string mismatches

# stopifnot2() call information snapshot

    Code
      helper()
    Condition
      Error in `helper()`:
      ! c(TRUE, FALSE, TRUE) are not all TRUE

# match.argv() errors when no match is found

    Code
      match.argv(4, list(1, 2, 3))
    Condition
      Error in `match.argv()`:
      ! 'arg' should be one of: 1, 2, 3

# match.argv() uses formal argument defaults when choices is omitted

    Code
      f("d")
    Condition
      Error in `match.argv()`:
      ! 'arg' should be one of: 'a', 'b', 'c'

# checkDots() warns

    Code
      f(1, 2, 3, x = 1)
    Condition
      Warning:
      In f(1, 2, 3, x = 1) :
       extra named argument 'x' is not allowed.
       extra unnamed argument '3' is not allowed.

# checkDots() errors

    Code
      f(1, 2, 3, x = 1)
    Condition
      Error:
      ! In f(1, 2, 3, x = 1) :
       extra named argument 'x' is not allowed.
       extra unnamed argument '3' is not allowed.

# stopifnot.with() snapshot

    Code
      dat <- data.frame(expected = c(1, 2, 3), actual = c(1, 4, 5))
      stopifnot.with(dat, all.equal(expected, actual))
    Condition
      Error:
      ! with dat : expected and actual are not equal:
        Mean relative difference: 0.8

# predapply() validates reduce, na.as and FUN output shape

    Code
      predapply(1:3, is.numeric, reduce = "invalid")
    Condition
      Error in `match.arg()`:
      ! 'arg' should be one of "all", "any", "none"

# warningifnot() snapshot

    Code
      warningifnot(all.equal(c("a", "b", "c"), c("a", "x", "z")))
    Condition
      Warning:
      c("a", "b", "c") and c("a", "x", "z") are not equal:
        2 string mismatches

# warningifnot() call information snapshot

    Code
      helper()
    Condition
      Warning in `helper()`:
      c(TRUE, FALSE, TRUE) are not all TRUE

# stop2 call information snapshot

    Code
      helper()
    Condition
      Error in `helper()`:
      ! failure

# warning2 call information snapshot

    Code
      helper()
    Condition
      Warning in `helper()`:
      failure

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stopifnot.r
\name{stopifnot2}
\alias{stopifnot2}
\alias{warningifnot}
\title{Ensure the Truth of R Expressions with Call Information}
\usage{
stopifnot2(..., call. = TRUE)

warningifnot(..., warn.all = FALSE, call. = TRUE)
}
\arguments{
\item{...}{any number of \strong{R} expressions, which should each evaluate
to (a logical vector of \link{all}) \code{\link{TRUE}}. If named, the names will be used
in lieu of the default error/warning message.}

\item{call.}{call, logical, integer, or environment. logical, indicating
if the calling call should become part of the error message with same
semantics as \link{stop}. integer, specifying how many calls to go 'up'
the call stack to extract a call for the message. A value of
\code{0} will give the call to \code{stop2()} itself, \code{1} will give the
call of the caller, and so on. Numeric values are coerced to integer
and absolute values are taken. Values outside either boundary of the
call stack will be clamped to the nearest boundary. environment,
which will be matched against the calling stack and the corresponding
call will be shown.}

\item{warn.all}{logical, indicating if all failed expressions should produce
warnings, or only the first failed expression. Default is \code{FALSE},
which means only the first failed expression will produce a warning.}
}
\value{
Called for side effects only.
}
\description{
Wrapper around \link{stopifnot} that leaves only the \code{...} argument and
adds a \code{call.} argument that shows a call in the message that
is derived from the call stack. \code{warningifnot()} implements the same
functionality but produces a warning instead of an error.
}
\details{
If any of the expressions are not \link{all} \code{TRUE}, \link{stop} or \link{warning}
is called, producing an error/warning message indicating the first
(or all, if \code{warn.all = TRUE} for \code{warningifnot()}) expression
which was not (\link{all}) true. See \link{stopifnot} for full details.

Special care must be taken for handlers on the call stack, as they
may affect the call displayed in the error or warning message. In
such instances, passing an environment to \code{call.} may be helpful.
}
\examples{
f1 <- function(call.) stopifnot2(1 == 2, call. = call.)
f2 <- function(call.) f1(call. = call.)
f <- function(call.) f2(call. = call.)

try(f(call. = FALSE))
try(f(call. = TRUE))

try(f(call. = 0))
try(f(call. = 1))
try(f(call. = 2))

f <- function() {
  e <- environment()
  f1(call. = e)
}

try(f())

try(stopifnot2(all.equal(1, 2)))

warningifnot(1 == 2, 2 == 3)
warningifnot(1 == 2, 2 == 3, warn.all = TRUE)
}
\seealso{
\link{stopifnot.with} for a data-masked version of this function.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/class.r
\name{suppr-predicates}
\alias{suppr-predicates}
\alias{is.boolean}
\alias{is.string}
\alias{nzstring}
\title{Value Predicates for Common Object Types}
\usage{
is.boolean(x)

is.string(x)

nzstring(x)
}
\arguments{
\item{x}{an object to be tested.}
}
\value{
\code{TRUE} or \code{FALSE}.
}
\description{
\code{is.boolean} checks if an object is a single (non-NA) logical value
(\code{TRUE} or \code{FALSE}).

\code{is.string} checks if an object is a single (non-NA) character string.

\code{nzstring} checks if an object is a single (non-NA) non-empty character
string.
}
\details{
The \code{string} helpers differ slightly from what you \emph{may} expect
from base \strong{R} as \code{NA_character_} is not considered a string.
For example:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{nzchar(NA_character_)
#> [1] TRUE
is.string(NA_character_)
#> [1] FALSE
nzstring(NA_character_)
#> [1] FALSE
}\if{html}{\out{</div>}}
}
\examples{
is.boolean(TRUE)
is.boolean(NA)

is.string("hello")
is.string(NA_character_)
is.string("")

nzstring("")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/even_odd.r
\name{is.even}
\alias{is.even}
\alias{is.odd}
\title{Is a Number Even or Odd?}
\usage{
is.even(x, noparity.na = FALSE)

is.odd(x, noparity.na = FALSE)
}
\arguments{
\item{x}{numeric (logical, integer or double) vector.}

\item{noparity.na}{logical, whether values without parity
(e.g., \code{NA}, \code{NaN}, \code{Inf}, \code{-Inf}, and decimal numbers)
should return \code{NA} (when \code{noparity.na = TRUE}) or \code{FALSE}
(when \code{noparity.na = FALSE}).}
}
\value{
logical vector the length of \code{x}.
}
\description{
Show where a numeric input is even or odd.
}
\examples{
is.even(2)
is.odd(1)

is.even(-5:5)
is.odd(-5:5)

m <- matrix(1:4, nrow = 2, ncol = 2)
is.even(m)
is.odd(m)

# inputs without parity can be handled as NA or FALSE:
x <- c(2.0, 3.0, 2.2, 3.1, NA, Inf, -Inf, NaN)
is.even(x)
is.odd(x)
is.even(x, noparity.na = TRUE)
is.odd(x, noparity.na = TRUE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/character.r
\name{grep-wrappers}
\alias{grep-wrappers}
\alias{grepf}
\alias{grepi}
\title{Pattern Matching}
\usage{
grepf(pattern, x, value = FALSE, useBytes = FALSE, invert = FALSE)

grepi(
  pattern,
  x,
  perl = FALSE,
  value = FALSE,
  useBytes = FALSE,
  invert = FALSE
)
}
\arguments{
\item{pattern}{character string containing a regular expression (or character string
for \code{fixed = TRUE} to be matched in the given character vector.
Coerced by \link{as.character} to a character string if possible.
If a character vector of length \code{2} or more is supplied, the first
element is used with a warning. Missing values are allowed.}

\item{x}{a character vector where matches are sought, or an object
which can be coerced by \link{as.character} to a character vector.
Long vectors are supported.}

\item{value}{logical. If \code{FALSE}, a vector containing the (integer) indices of
the matches determined by grep is returned, and if \code{TRUE}, a vector
containing the matching elements themselves is returned.}

\item{useBytes}{logical. If \code{TRUE} the matching is done byte-by-byte rather
than character-by-character.}

\item{invert}{logical. If \code{TRUE} return indices or values for elements that
do not match.}

\item{perl}{logical. Should Perl-compatible regexps be used?}
}
\value{
with \code{value = FALSE}, return a vector of the
indices of the elements of \code{x} that yielded a match (or not,
for \code{invert = TRUE}). This will be an integer vector unless
the input is a long vector, when it will be a double vector.

with \code{value = TRUE}, return a character vector containing the
selected elements of \code{x} (after coercion, preserving names but
no other attributes).
}
\description{
Strongly typed wrappers around \code{\link{grep}} that have the
\code{fixed} and \code{ignore.case} arguments set internally.
}
\details{
\verb{*f()} suffixed functions have \code{fixed = TRUE} and conflicting
arguments (\code{perl} and \code{ignore.case}) set as \code{FALSE}.

\verb{*i()} suffixed functions have \code{ignore.case = TRUE} and the
conflicting \code{fixed} argument set as \code{FALSE}.

For full documentation of the wrapped functions, see the help
pages for \code{\link{grep}}.
}
\examples{
grepf("foo", c("foo", "Foo", "bar"))
grepf("foo", c("foo", "Foo", "bar"), value = TRUE)
grepi("foo", c("foo", "Foo", "bar"))
grepi("foo", c("foo", "Foo", "bar"), value = TRUE)
}
\seealso{
Other pattern-match-replacement-wrappers:
\code{\link{grepl-wrappers}},
\code{\link{grepv-wrappers}},
\code{\link{sub-wrappers}}
}
\concept{pattern-match-replacement-wrappers}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/predapply.r
\name{predapply}
\alias{predapply}
\title{Apply a predicate function over a list or vector}
\usage{
predapply(X, FUN, ..., reduce = NULL, na.as = NA)
}
\arguments{
\item{X}{a vector (atomic or list) or an expression object.
Other objects (including classed objects) will be coerced by
\code{\link{as.list}}.}

\item{FUN}{a predicate function to be applied to each element of
\code{X} that returns a single logical value.}

\item{...}{optional arguments to \code{FUN}.}

\item{reduce}{\code{NULL} or one of \code{"all"}, \code{"any"}, or \code{"none"}. When
non-\code{NULL}, the output logical vector is reduced to a single boolean
value using \link{all}, \link{any} or \code{"none"} (implemented as \code{all(!logi)}).}

\item{na.as}{logical value to return for \code{NA} values in the output logical
vector (\code{NA}, \code{TRUE} or \code{FALSE}).}
}
\value{
logical vector or boolean if \code{reduce} is non-\code{NULL}.
}
\description{
Returns a logical of the same length as \code{X}, each element of which is
the result of applying predicate \code{FUN} to the corresponding element
of \code{X.}
}
\details{
\code{na.as} is most meaningful when \code{reduce} is non-\code{NULL}, as it allows control
flow calls (e.g., \verb{if (predapply(...))}) to proceed without error.
See examples.
}
\examples{
x <- list(a = 1, b = 2, c = NA)
predapply(x, is.numeric)
predapply(x, is.numeric, reduce = "any")

x <- list(a = 1, b = 2, c = 3)
predapply(x, is.numeric, reduce = "all")

x <- list(a = "1", b = "2", c = "3")
predapply(x, is.numeric, reduce = "none")

x <- c(1, 2, NA)
predapply(x, function(x) x > 0)
predapply(x, function(x) x > 0, reduce = "all")
predapply(x, function(x) x > 0, reduce = "all", na.as = TRUE)
}
\seealso{
\link{apply}, \link{lapply}, \link{mapply}, \link{all}, \link{any}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/infix.r
\name{suppr-infix}
\alias{suppr-infix}
\alias{\%''\%}
\alias{\%""\%}
\alias{\%!||\%}
\alias{\%0\%}
\alias{\%allin\%}
\alias{\%anyin\%}
\alias{\%nonein\%}
\alias{\%onein\%}
\alias{\%notin\%}
\title{Infix Operator Helpers}
\usage{
lhs \%''\% rhs

lhs \%""\% rhs

lhs \%!||\% rhs

lhs \%0\% rhs

x \%allin\% table

x \%anyin\% table

x \%nonein\% table

x \%onein\% table

x \%notin\% table
}
\arguments{
\item{lhs}{left-hand side object.}

\item{rhs}{right-hand side object.}

\item{x}{\link{vector} or \code{NULL}: the values to be matched.
\link{Long vectors} are supported.}

\item{table}{vector or \code{NULL}: the values to be matched against.
\link{Long vectors} are not supported.}
}
\value{
For the non-\verb{\%*in\%} operators, either the left-hand side or
right-hand side, depending on the result of the operator.

For \verb{\%allin\%}, \verb{\%anyin\%}, \verb{\%nonein\%}, and \verb{\%onein\%}
a single logical value (or empty logical if \code{x} has length \code{0}) is
returned. For \verb{\%notin\%}, a logical vector of the same length as
\code{x} is returned.
}
\description{
Infix operators for common tasks.

\verb{\%''\%} and \verb{\%""\%} return the right-hand side if the left-hand side is
an empty string (\code{""}).

\verb{\%!||\%} returns the right-hand side if the left-hand side is not
\code{NULL}.

\verb{\%0\%} returns the right-hand side if the left-hand side has length 0.

\verb{\%allin\%} returns \code{TRUE} if all elements of \code{x} are in \code{table}.

\verb{\%anyin\%} returns \code{TRUE} if any elements of \code{x} are in \code{table}.

\verb{\%nonein\%} returns \code{TRUE} if none of the elements of \code{x} are in \code{table}.

\verb{\%onein\%} returns \code{TRUE} if exactly one element of \code{x} is in \code{table}.

\verb{\%notin\%} returns \code{TRUE} for elements of \code{x} that are not in \code{table}.
This is implemented in the same way as base \strong{R} and will be
replaced by the base version in the \strong{R} versions that have it.
}
\details{
The \verb{\%*in\%} operators follow the semantics of \code{\%in\%} for \code{NULL}
values:
\itemize{
\item Singular \code{NULL}'s on the lhs always returns a length \code{0} logical vector.
\item \code{NULL} elements are not considered equal to singular \code{NULL}'s so will
give a \code{TRUE} for \verb{\%nonein\%} and \verb{\%notin\%} and \code{FALSE} for \verb{\%allin\%},
\verb{\%anyin\%} and \verb{\%onein\%}.
}

See \code{\%in\%} semantics:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{NULL \%in\% NULL
#> logical(0)
NULL \%in\% list(1, NULL)
#> logical(0)
list(1, NULL) \%in\% NULL
#> [1] FALSE FALSE
list(1, NULL) \%in\% list(1, NULL)
#> [1] TRUE TRUE
}\if{html}{\out{</div>}}
}
\examples{
"" \%''\% "default" # if lhs is "", return rhs

NULL \%!||\% "default" # if lhs is NULL, return *lhs* (NULL)
# useful for when using NULL as a default value
# or when using elements of a list that may be NULL
# e.g.,
lst <- list(a = 1, b = 2)
x <- lst$nope \%!||\% mean(lst$nope) # returns NULL

integer(0) \%0\% 5L # if lhs is length 0, return rhs

c(1, 2, 3) \%allin\% c(1, 2, 3, 4) # TRUE

c(1, 2, 3) \%anyin\% c(1, 2, 3, 4) # TRUE

c(1, 2, 3) \%nonein\% c(4, 5, 6) # TRUE

c(1, 2, 3) \%onein\% c(1, 4, 5) # TRUE

c(1, 2, 3) \%notin\% c(4, 5, 6) # TRUE
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/character.r
\name{cat0}
\alias{cat0}
\title{Concatenate and Print with No Separator}
\usage{
cat0(..., file = "", fill = FALSE, labels = NULL, append = FALSE)
}
\arguments{
\item{...}{\strong{R} objects (see \link{cat} for the types of objects allowed).}

\item{file}{a connection, or a character string naming the file to
print to. If "" (the default), \code{cat0} prints to the standard output
connection, the console unless redirected by sink.}

\item{fill}{a logical or (positive) numeric controlling how the
output is broken into successive lines. If \code{FALSE} (default), only
newlines created explicitly by \code{"\\n"} are printed. Otherwise, the
output is broken into lines with print width equal to the option
width if fill is \code{TRUE}, or the value of fill if this is numeric.
Linefeeds are only inserted between elements, strings wider than
fill are not wrapped. Non-positive fill values are ignored, with a
warning.}

\item{labels}{character vector of labels for the lines printed.
Ignored if fill is \code{FALSE}.}

\item{append}{logical. Only used if the argument file is the name
of file (and not a connection or \code{"|cmd"}). If \code{TRUE} output will be
appended to file; otherwise, it will overwrite the contents of file.}
}
\value{
None (invisible \code{NULL}).
}
\description{
Outputs the objects, concatenating the representations
with no separator.
}
\details{
All arguments are passed to a call to \link{cat} with \code{sep} set to \code{""}.
}
\examples{
cat(letters[1:3])
cat0(letters[1:3])

cat(
  paste(letters, 100 * 1:26),
  fill = TRUE, labels = paste0("{", 1:10, "}:")
)
cat0(
  paste(letters, 100 * 1:26),
  fill = TRUE, labels = paste0("{", 1:10, "}:")
)
}
\seealso{
\link{cat}, \link{print}, \link{format} and \link{paste} which concatenates into
a string.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/class.r
\name{is.datetype}
\alias{is.datetype}
\alias{is.Date}
\alias{is.POSIXt}
\alias{is.POSIXct}
\alias{is.POSIXlt}
\title{Is object of a Date type?}
\usage{
is.datetype(x)

is.Date(x)

is.POSIXt(x)

is.POSIXct(x)

is.POSIXlt(x)
}
\arguments{
\item{x}{an \strong{R} object.}
}
\value{
\code{TRUE} or \code{FALSE}.
}
\description{
Tests if an object inherits from some/all of \strong{R}'s date types:
\code{Date}, \code{POSIXt}, \code{POSIXct} and \code{POSIXlt}.
}
\details{
\code{is.datetype} checks if the object inherits from either \code{Date} or \code{POSIXt}.

\code{is.Date} checks if the object inherits from \code{Date}.

\code{is.POSIXt} checks if the object inherits from \code{POSIXt}.

\code{is.POSIXct} checks if the object inherits from \code{POSIXct}.

\code{is.POSIXlt} checks if the object inherits from \code{POSIXlt}.
}
\examples{
a <- "2020-01-01"
b <- as.Date("2020-01-01")
c <- 123

is.Date(a)
is.Date(b)
is.Date(c)

is.Date(as.POSIXct(a))
is.POSIXt(as.POSIXct(a))
is.POSIXct(as.POSIXct(a))
is.POSIXlt(as.POSIXct(a))
is.datetype(as.POSIXct(a))
}
\seealso{
\link{as.Date}, \link{as.POSIXct}, \link{as.POSIXlt}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/class.r
\name{isVector}
\alias{isVector}
\title{Check if Any of Given Vector Types}
\usage{
isVector(x, mode = "any")
}
\arguments{
\item{x}{an \strong{R} object.}

\item{mode}{character string (or chr vector) naming an atomic mode
or \code{"list"} or \code{"expression"} or \code{"any"}. When using \code{"any"}, it
must be given on its own.}
}
\value{
\code{TRUE} or \code{FALSE}.
}
\description{
Wrapper around \link{is.vector} that allows the \code{mode} argument to
accept a character vector of multiple specific types. \code{TRUE}
is returned if the given object is \strong{any} of the given types.
}
\details{
See \link{is.vector} for full details and for the types that can be
checked with \code{mode}.
}
\examples{
x <- c(a = 1, b = 2)
isVector(x) # default `mode` is "any"

# "any" can't be given with other types.
try(isVector(x, mode = c("numeric", "any")))

# `TRUE` is returned if *any* of the types are matched.
isVector(x, mode = c("character", "list", "logical", "numeric"))
isVector(x, mode = c("character", "list", "logical"))
}
\seealso{
\link{is.vector}, \link{typeof}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/suppr-package.R
\docType{package}
\name{suppr-package}
\alias{suppr}
\alias{suppr-package}
\title{suppr: Supplementary Idiomatic Utilities and Extensions}
\description{
\if{html}{\figure{logo.png}{options: style='float: right' alt='logo' width='120'}}

Miscellaneous supplementary functions designed to follow idiomatic 'R' conventions. Some functions are simple wrappers that reduce repetitive code, while others address common tasks or extend existing 'R' functions.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://lj-jenkins.github.io/suppr/}
  \item \url{https://github.com/LJ-Jenkins/suppr}
  \item Report bugs at \url{https://github.com/LJ-Jenkins/suppr/issues}
}

}
\author{
\strong{Maintainer}: Luke Jenkins \email{luke-jenkins-dev@outlook.com} (\href{https://orcid.org/0000-0002-7206-7242}{ORCID}) [copyright holder]

Authors:
\itemize{
  \item Luke Jenkins \email{luke-jenkins-dev@outlook.com} (\href{https://orcid.org/0000-0002-7206-7242}{ORCID}) [copyright holder]
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/na.r
\name{setNA}
\alias{setNA}
\alias{setNA<-}
\title{Set given indices as NA}
\usage{
setNA(x, indices)

setNA(x) <- value
}
\arguments{
\item{x}{an \strong{R} object.}

\item{indices}{integer vector of indices to set as \code{NA}.}

\item{value}{integer vector of indices to set as \code{NA} for the replacement
function.}
}
\value{
the modified object with given indices set to \code{NA}.
}
\description{
For given \code{indices}, set those indices of an object as \code{NA}.
}
\details{
This function is a S3 generic. The default method sets indices
to \code{NA} using \verb{[<-}, passing the indices first to \code{\link{arrayInd}}
if the input has a non-\code{NULL} \code{dim} attribute.

The \verb{setNA<-} function is meant to be a direct replacement for \verb{is.na<-}
with (in my opinion) a clearer naming convention. The base methods are
implemented verbatim (for \link{factor} and \link{numeric_version} objects),
whereas the default method differs by using \code{arrayInd} (see above),
whereas \verb{is.na<-} is implemented just as \code{x[value] <- NA}.
}
\note{
Complex inputs will have indices set to \code{NA_complex_}, meaning that
both the real and imaginary parts will be set to \code{NA}, not just the
real part which can happen (depending on \strong{R} version) with
\code{x_complex[indices] <- NA}.
}
\examples{
setNA(1:5, c(1, 4))
setNA(c("hi", "hello", "bye", "goodbye"), c(1, 4))
setNA(matrix(1:4, 2, 2), c(1, 4))
setNA(list(1, 2, 3, list(1, 2)), c(1, 4))

x <- 1:10
setNA(x) <- c(1, 7, 9)
x
}
\seealso{
\code{\link{is.na<-}}, \link{whichNA}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stopifnot.r
\name{stopifnot.with}
\alias{stopifnot.with}
\title{Ensure the Truth of R Expressions in a Data Environment}
\usage{
stopifnot.with(data, ..., call. = TRUE)
}
\arguments{
\item{data}{data to use for constructing an environment. This may be an
\code{environment}, a \code{list}, a \code{data.frame}, or an \code{integer} as in
\code{sys.call}.}

\item{...}{any number of \strong{R} expressions, which should each evaluate
to (a logical vector of \link{all}) \code{\link{TRUE}}. If named, the names will be used
in lieu of the default error message.}

\item{call.}{call, logical, integer, or environment. logical, indicating
if the calling call should become part of the error message with same
semantics as \link{stop}. integer, specifying how many calls to go 'up'
the call stack to extract a call for the message. A value of
\code{0} will give the call to \code{stop2()} itself, \code{1} will give the
call of the caller, and so on. Numeric values are coerced to integer
and absolute values are taken. Values outside either boundary of the
call stack will be clamped to the nearest boundary. environment,
which will be matched against the calling stack and the corresponding
call will be shown.}
}
\value{
If no errors are thrown, the function returns \code{data} invisibly.
}
\description{
Wrapper around \link{stopifnot2} that evaluates \strong{R} expressions
in an environment constructed from \code{data}.
}
\details{
If any of the expressions are not \link{all} \code{TRUE}, \link{stop} is called,
producing an error message indicating the first expression which
was not (\link{all}) true. See \link{stopifnot} and \link{stopifnot2} for full details.

Special care must be taken for handlers on the call stack, as they
may affect the call displayed in the error message. In
such instances, passing an environment to \code{call.} may be helpful.
}
\examples{
try(stopifnot.with(data.frame(x = 1, y = 2), x == y))
try(stopifnot.with(list(x = 1, y = 2), all.equal(x, y)))

f1 <- function(x, ..., call.) stopifnot.with(x, ..., call. = call.)
f2 <- function(x, ..., call.) f1(x, ..., call. = call.)
f <- function(x, ..., call.) f2(x, ..., call. = call.)

x <- list(a = 1, b = 2)
try(f(x, a == b, call. = FALSE))
try(f(x, a == b, call. = TRUE))

try(f(x, a == 1, b < 1, call. = 0))
try(f(x, b > 3, call. = 1))
try(f(x, a != 1, call. = 2))

f <- function(x, ...) {
  e <- environment()
  f1(x, ..., call. = e)
}

try(f(x, a == 1, b < 1))
}
\seealso{
\link{stop2} and \link{warning2} for errors and warnings
with call information.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/which.r
\name{whichNA}
\alias{whichNA}
\alias{whichNA<-}
\title{Which indices are NA?}
\usage{
whichNA(x)

whichNA(x) <- value
}
\arguments{
\item{x}{numeric \strong{R} object. Does not accept \code{complex} or \code{raw.}}

\item{value}{value/s to replace \code{NA} values with when using the
assignment function.}
}
\value{
If using \code{whichNA}, integer vector of indices of \code{NA} values
in \code{x}, or matrix of array indices if \code{arr.ind} is \code{TRUE}.
If using \verb{whichNA<-}, the modified object with \code{NA} values replaced by
\code{value}.
}
\description{
Give the indices of \code{NA} values, allowing for array indices.
Use the assignment function \verb{whichNA<-} to replace \code{NA} values
with a given value/s.
}
\details{
\verb{whichNA<-} follows \strong{R}'s usual recycling rules when
replacing \code{NA} values with \code{value}. If there are no \code{NA} values in \code{x},
no replacement is made.
}
\examples{
x <- c(1, NA, 3, NA, 5)
whichNA(x)
whichNA(x) <- 0
x

m <- matrix(c(1, NA, 3, NA, 5, NA), nrow = 2)
whichNA(m)

y <- c("a" = 1, "b" = NA, "c" = 2, "d" = NA, "e" = NA, "f" = NA)
whichNA(y)
whichNA(y) <- c(91, 92) # value recycled to number of NA's
y
}
\seealso{
\link{is.na}, \link{setNA}, \link{whichMin}, \link{whichMax}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/character.r
\name{grepv-wrappers}
\alias{grepv-wrappers}
\alias{grepv}
\alias{grepvf}
\alias{grepvi}
\title{Pattern Matching}
\usage{
grepv(
  pattern,
  x,
  ignore.case = FALSE,
  perl = FALSE,
  value = TRUE,
  fixed = FALSE,
  useBytes = FALSE,
  invert = FALSE
)

grepvf(pattern, x, useBytes = FALSE, invert = FALSE)

grepvi(pattern, x, perl = FALSE, useBytes = FALSE, invert = FALSE)
}
\arguments{
\item{pattern}{character string containing a regular expression (or character string
for \code{fixed = TRUE} to be matched in the given character vector.
Coerced by \link{as.character} to a character string if possible.
If a character vector of length \code{2} or more is supplied, the first
element is used with a warning. Missing values are allowed.}

\item{x}{a character vector where matches are sought, or an object
which can be coerced by \link{as.character} to a character vector.
Long vectors are supported.}

\item{ignore.case}{logical. if \code{FALSE}, the pattern matching is case sensitive
and if \code{TRUE}, case is ignored during matching.}

\item{perl}{logical. Should Perl-compatible regexps be used?}

\item{value}{logical. If \code{FALSE}, a vector containing the (integer) indices of
the matches determined by grep is returned, and if \code{TRUE}, a vector
containing the matching elements themselves is returned.}

\item{fixed}{logical. If \code{TRUE}, pattern is a string to be matched as is.
Overrides all conflicting arguments.}

\item{useBytes}{logical. If \code{TRUE} the matching is done byte-by-byte rather
than character-by-character.}

\item{invert}{logical. If \code{TRUE} return indices or values for elements that
do not match.}
}
\value{
character vector containing the selected elements of \code{x}
(after coercion, preserving names but no other attributes).

\code{grepv()} can also return a vector of the indices of the
elements of \code{x} that yielded a match (or not, for
\code{invert = TRUE}) if \code{value = FALSE} (see note). This will
be an integer vector unless the input is a long vector,
when it will be a double vector.
}
\description{
Strongly typed wrappers around \code{\link{grep}} that have the
\code{value} (see note), \code{ignore.case} and \code{fixed} arguments
set internally (as well as the conflicting arguments).

If \code{grepv} is found in the current \strong{R} version, it is
reexported from base.
}
\details{
\verb{*f()} suffixed functions have \code{fixed = TRUE} and conflicting
arguments (\code{perl} and \code{ignore.case}) set as \code{FALSE}.

\verb{*i()} suffixed functions have \code{ignore.case = TRUE} and the
conflicting \code{fixed} argument set as \code{FALSE}.

For full documentation of the wrapped functions, see the help
pages for \code{\link{grep}}.
}
\note{
suppr wrappers of the base grep/sub functions remove the
arguments that relate to the strong typing, just like
\code{grepl} does by not having a \code{value} argument. However,
the base \code{grepv} implementation has kept the \code{value}
argument, so the version here keeps the \code{value} argument
for compatibility.
}
\examples{
grepv("foo", c("foo", "Foo", "bar"))
grepvf("foo", c("foo", "Foo", "bar"))
grepvi("foo", c("foo", "Foo", "bar"))
}
\seealso{
Other pattern-match-replacement-wrappers:
\code{\link{grep-wrappers}},
\code{\link{grepl-wrappers}},
\code{\link{sub-wrappers}}
}
\concept{pattern-match-replacement-wrappers}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stop.r
\name{stop2}
\alias{stop2}
\alias{warning2}
\title{Display Warnings and Errors with Call Information}
\usage{
stop2(..., call. = TRUE, domain = NULL)

warning2(..., call. = TRUE, domain = NULL)
}
\arguments{
\item{...}{zero or more objects which can be coerced to
character (and which are pasted together with no separator).}

\item{call.}{call, logical, integer, or environment. logical, indicating
if the calling call should become part of the error message with same
semantics as \link{stop}. integer, specifying how many calls to go 'up'
the call stack to extract a call for the message. A value of
\code{0} will give the call to \code{stop2()} itself, \code{1} will give the
call of the caller, and so on. Numeric values are coerced to integer
and absolute values are taken. Values outside either boundary of the
call stack will be clamped to the nearest boundary. environment,
which will be matched against the calling stack and the corresponding
call will be shown.}

\item{domain}{see \link{gettext}. If \code{NA}, messages will not be translated.}
}
\value{
Called for side effects only.
}
\description{
Wrappers around \link{stop} and \link{warning} that
enable the \code{call.} argument to derive a call from the
stack.
}
\details{
These functions derive a call to be displayed and then construct
their own 'simple' conditions using \link{simpleError} and \link{simpleWarning}.

If a condition object is given as the first argument, it will be
treated in the same way as the base functions do, by warning that
other arguments will be ignored and then signalling the condition.

See \link{stop} and \link{warning} for full details.
}
\examples{
f1 <- function(call.) stop2("error", call. = call.)
f2 <- function(call.) f1(call. = call.)
f <- function(call.) f2(call. = call.)

try(f(call. = FALSE))
try(f(call. = TRUE))

try(f(call. = 0))
try(f(call. = 1))
try(f(call. = 2))

f <- function() {
  e <- environment()
  f1(call. = e)
}

try(f())

f1 <- function(call.) warning2("warning", call. = call.)
try(f())
}
\seealso{
\link{stopifnot2} and \link{stopifnot.with} for validations with
call information.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/na.r
\name{na.vector}
\alias{na.vector}
\title{Create a vector of NA's}
\usage{
na.vector(
  length = 1L,
  type = c("logical", "integer", "double", "character", "complex", "numeric", "list")
)
}
\arguments{
\item{length}{integer, length of the output vector.}

\item{type}{character string naming an atomic type that has an
equivalent \code{NA} value (i.e., not \link{raw}), or \code{"list"}.}
}
\value{
vector of given mode and length filled with \code{NA} values.
}
\description{
For a given type and length, create a vector of \code{NA}'s.
}
\details{
This function also offers a \code{"list"} type, which gives a list
of single (logical) \code{NA} values. To initialize an empty list (of \code{NULL}'s)
of a given length, use \link{empty.list} instead.
}
\examples{
na.vector(5L)
x <- na.vector(3L, "character")
class(x)

x <- complex(1:5, 6:10)
y <- na.vector(length(x), typeof(x))
class(y)
length(y)

na.vector(2L, "list")
}
\seealso{
\link{vector}, \link{whichNA}, \link{setNA}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/character.r
\name{bckQuote}
\alias{bckQuote}
\title{Backquote Text}
\usage{
bckQuote(x)
}
\arguments{
\item{x}{an \strong{R} object, to be coerced to a \link{character} vector.}
}
\value{
A character vector of the same length as \code{x} (after any coercion).
}
\description{
Backquote text by combining with backticks.
}
\examples{
bckQuote("example")
bckQuote(c("one", "two", "three"))
bckQuote(123)
}
\seealso{
\link{Quotes}, \link{dQuote} and \link{sQuote}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/character.r
\name{sub-wrappers}
\alias{sub-wrappers}
\alias{subf}
\alias{subi}
\alias{gsubf}
\alias{gsubi}
\title{Pattern Replacement Wrappers}
\usage{
subf(pattern, replacement, x, useBytes = FALSE)

subi(pattern, replacement, x, perl = FALSE, useBytes = FALSE)

gsubf(pattern, replacement, x, useBytes = FALSE)

gsubi(pattern, replacement, x, perl = FALSE, useBytes = FALSE)
}
\arguments{
\item{pattern}{character string containing a regular expression (or character string
for \code{fixed = TRUE} to be matched in the given character vector.
Coerced by \link{as.character} to a character string if possible.
If a character vector of length \code{2} or more is supplied, the first
element is used with a warning. Missing values are allowed.}

\item{replacement}{a replacement for the matched pattern in sub and gsub. Coerced
to character if possible. For \code{fixed = FALSE} this can include
backreferences \code{"\\1"} to \code{"\\9"} to parenthesized subexpressions
of pattern. For \code{perl = TRUE} only, it can also contain \code{"\\U"}
or \code{"\\L"} to convert the rest of the replacement to upper or
lower case and \code{"\\E"} to end case conversion. If a character
vector of length 2 or more is supplied, the first element is
used with a warning. If NA, all elements in the result
corresponding to matches will be set to \code{NA}.}

\item{x}{a character vector where matches are sought, or an object
which can be coerced by \link{as.character} to a character vector.
Long vectors are supported.}

\item{useBytes}{logical. If \code{TRUE} the matching is done byte-by-byte rather
than character-by-character.}

\item{perl}{logical. Should Perl-compatible regexps be used?}
}
\value{
a character vector of the same length and with the same attributes
as \code{x} (after possible coercion to character). Elements of
character vectors \code{x} which are not substituted will be returned
unchanged (including any declared encoding if \code{useBytes = FALSE}).
If \code{useBytes = FALSE} a non-ASCII substituted result will often be
in UTF-8 with a marked encoding (e.g., if there is a UTF-8 input,
and in a multibyte locale unless \code{fixed = TRUE}). Such strings can
be re-encoded by \code{\link{enc2native}}. If any of the inputs is marked as
"bytes", elements of character vectors \code{x} which are substituted
will be returned marked as "bytes", but the encoding flag on
elements not substituted is unspecified (it may be the original or
"bytes"). If none of the inputs is marked as "bytes", but
\code{useBytes = TRUE} is given explicitly, the encoding flag is
unspecified even on the substituted elements (it may be "bytes" or
"unknown", possibly invalid in the current encoding). Mixed use of
"bytes" and other marked encodings is discouraged, but if still
desired one may use \code{\link{iconv}} to re-encode the result e.g. to UTF-8
with suitably substituted invalid bytes.
}
\description{
Strongly typed wrappers around \code{\link{sub}} and \code{\link{gsub}} that have the
\code{fixed} and \code{ignore.case} arguments set internally (as well as
the conflicting arguments).
}
\details{
\verb{*f()} suffixed functions have \code{fixed = TRUE} and conflicting
arguments (\code{perl} and \code{ignore.case}) set as \code{FALSE}.

\verb{*i()} suffixed functions have \code{ignore.case = TRUE} and the
conflicting \code{fixed} argument set as \code{FALSE}.

For full documentation of the wrapped functions, see the help
pages for \code{\link{grep}}.
}
\examples{
subf("foo", "X", c("foo", "Foo", "bar"))
subi("foo", "X", c("foo", "Foo", "bar"))

gsubf("foo", "X", c("foo foo", "Foo", "bar"))
gsubi("foo", "X", c("foo foo", "Foo", "bar"))
}
\seealso{
Other pattern-match-replacement-wrappers:
\code{\link{grep-wrappers}},
\code{\link{grepl-wrappers}},
\code{\link{grepv-wrappers}}
}
\concept{pattern-match-replacement-wrappers}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/repeated.r
\name{repeated}
\alias{repeated}
\alias{repeated.array}
\alias{whichRepeated}
\alias{whichRepeated.array}
\alias{repeats}
\alias{repeats.array}
\alias{non.unique}
\title{Determine Repeated Elements}
\usage{
repeated(x, ...)

\method{repeated}{array}(x, MARGIN = 1L, ...)

whichRepeated(x, ...)

\method{whichRepeated}{array}(x, MARGIN = 1L, ...)

repeats(x, ...)

\method{repeats}{array}(x, MARGIN = 1L, ...)

non.unique(x, ...)
}
\arguments{
\item{x}{a vector, a data frame, an array, or \code{NULL}.}

\item{...}{additional arguments passed to methods.}

\item{MARGIN}{the array margin to be held fixed: see \link{apply},
and note that \code{MARGIN = 0} may be useful.}
}
\value{
\code{repeated()}: For a vector input, a logical vector of the
same length as \code{x}. For a data frame, a logical vector
with one element for each row. For a matrix or array, and
when \code{MARGIN = 0}, a logical array with the same dimensions
and dimnames.

\code{whichRepeated()}: For a vector input, an integer vector
giving the indices of the repeated values. For a data frame,
an integer vector giving the indices of the repeated rows.
For a matrix or array, an integer vector giving the indices
of the repeated elements across the margin specified.

\code{repeats()} and its alias \code{non.unique()}: an object of
the same type as \code{x}, containing the repeated values
(vector input), rows (data frame input), or elements across
the margin (matrix/array input).
}
\description{
Return a logical vector, indices, or the values of repeated elements
in a vector.
}
\details{
The \code{repeated} functions determine which elements of a vector
or data frame are duplicates of elements with smaller subscripts.
They are very similar in functionality to \link{duplicated} but
instead mark \strong{all} duplicates (not just those after the
first/last occurrence), and do not have an \code{incomparables}
argument.

These are generic functions with methods for vectors
(including lists and expressions), data frames and arrays
(including matrices).

The array method calculates for each element of the sub-array
specified by \code{MARGIN} if the dimensions are identical
to those for an earlier or later element (in row-major order).
This would most commonly be used to find repeated rows
(the default) or columns (with \code{MARGIN = 2}). Note that
\code{MARGIN = 0} returns an array of the same dimensionality
attributes as \code{x}.

\code{non.unique()} is an alias for \code{repeats()}.
}
\examples{
# Repeated values in a vector
x <- c(1, 2, 3, 2, 1)

repeated(x)
whichRepeated(x)
repeats(x)

# Repeated rows in a data frame
df <- data.frame(
  x = c(1, 2, 1),
  y = c("a", "b", "a")
)

repeated(df)
repeats(df)

# Repeated rows/columns in a matrix
m <- cbind(
  c(1, 2),
  c(3, 4),
  c(1, 2)
)

repeated(m)
repeated(m, MARGIN = 2)
repeats(m, MARGIN = 2)

# non.unique() is an alias for repeats()
identical(repeats(x), non.unique(x))
}
\seealso{
\link{duplicated} and \link{unique}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/first_last.r
\name{rm.first}
\alias{rm.first}
\alias{rm.first.default}
\alias{rm.first<-}
\alias{rm.first<-.default}
\alias{rm.last}
\alias{rm.last.default}
\alias{rm.last<-}
\alias{rm.last<-.default}
\title{Remove First or Last N Elements}
\usage{
rm.first(x, n = 1L, ...)

\method{rm.first}{default}(x, n = 1L, ...)

rm.first(x, ...) <- value

\method{rm.first}{default}(x, ...) <- value

rm.last(x, n = 1L, ...)

\method{rm.last}{default}(x, n = 1L, ...)

rm.last(x, ...) <- value

\method{rm.last}{default}(x, ...) <- value
}
\arguments{
\item{x}{an \strong{R} object with a \code{[} method, e.g., a vector, matrix, list.}

\item{n}{integer, number of elements to remove from the beginning or end.}

\item{...}{additional arguments passed to methods.}

\item{value}{integer, same as \code{n}.}
}
\value{
The modified object with the first or last \code{n} elements removed.
}
\description{
Remove the first or last \code{n} elements of an \strong{R} object.
}
\details{
The default methods operate on atomic
vectors and lists, removing \code{n} elements from the beginning or end of
the object.

Dimensional objects (\link{matrix}, \link{data.frame}, \link{array}, etc.) are handled by
removing \code{n} entries along the first dimension ('row-wise' for
matrices/data.frames and for each slice of higher-dimensional arrays).
Remaining dimensions are preserved.
}
\examples{
x <- 1:10
rm.first(x, 3)
rm.last(x, 3)

x <- matrix(1:10, nrow = 5)
rm.first(x, 2)
rm.last(x, 2)

x <- list(a = 1, b = 2, c = 3, d = 4)
rm.first(x, 2)
rm.last(x, 2)

x <- 1:10
rm.first(x) <- 3
rm.last(x) <- 3
x
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/character.r
\name{collapse}
\alias{collapse}
\alias{collapse0}
\alias{listing}
\title{Collapse a Vector of Strings into a Single String}
\usage{
collapse(..., sep = "", recurse = FALSE)

collapse0(..., sep = "", recurse = FALSE)

listing(x, sep = ", ", conjunction = "and", period = TRUE, quote = NULL)
}
\arguments{
\item{...}{one or more \strong{R} objects, to be converted to \link{character} vectors.}

\item{sep}{character string to collapse the terms, not \code{\link{NA_character_}}.}

\item{recurse}{\code{\link{logical}}. If \code{TRUE}, collapse each argument separately
first, before collapsing the results into a single string.}

\item{x}{a character vector from which to create the human readable list.}

\item{conjunction}{character string to use as a conjunction for the
last two terms.}

\item{period}{\code{\link{logical}}. If \code{TRUE}, append a period to the end of the
string.}

\item{quote}{\code{\link{NULL}} or a character string indicating the type of quotes
to use for quoting the terms. If \code{NULL}, no quoting is done. If \code{"single"},
single quotes are used, if \code{"double"}, double quotes are used, and if
\code{"back"}, backquotes are used.}
}
\value{
a single character string.
}
\description{
Collapse a character vector into a single string, with an optional
separator, and for \code{listing()} an optional conjunction and period,
with options to quote the terms.
}
\details{
\code{collapse} and \code{collapse0} are simple wrappers for
\code{paste0(..., collapse = sep)} and \code{paste(..., collapse = sep)}, with
an option to collapse each argument separately first, before collapsing
the results.
}
\examples{
collapse(c("a", "b", "c"), "d")
collapse0(c("a", "b", "c"), "d")

collapse(c("a", "b", "c"), "d", sep = ", ")
collapse0(c("a", "b", "c"), "d", sep = ", ")

collapse(c("a", "b"), c("c", "d"), sep = ", ")
collapse(c("a", "b"), c("c", "d"), sep = ", ", recurse = TRUE)

listing(c("a", "b", "c"), sep = ", ", conjunction = "and")
listing(c("a", "b"), conjunction = "or", period = FALSE)

listing(c("a", "b", "c"), quote = "single")
listing(c("a", "b", "c"), quote = "double")
listing(c("a", "b", "c"), quote = "back")
}
\seealso{
\link{paste0}, \link{sQuote}, \link{dQuote}, \link{bckQuote}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/libraries.r
\name{libraries}
\alias{libraries}
\alias{requires}
\title{Loading/Attaching Multiple Packages}
\usage{
libraries(
  ...,
  pos = 2,
  lib.loc = NULL,
  character.only = FALSE,
  logical.return = FALSE,
  warn.conflicts,
  quietly = FALSE,
  verbose = getOption("verbose"),
  mask.ok,
  exclude,
  include.only,
  attach.required = missing(include.only)
)

requires(
  ...,
  lib.loc = NULL,
  quietly = FALSE,
  warn.conflicts,
  character.only = FALSE,
  mask.ok,
  exclude,
  include.only,
  attach.required = missing(include.only)
)
}
\arguments{
\item{...}{the names of the packages, given as \link{name}s, character strings,
a combination of both, or character vectors (see \code{character.only}
below).}

\item{pos}{the position on the search list at which to attach the loaded
namespace. Can also be the name of a position on the current
search list as given by \code{\link[=search]{search()}}.}

\item{lib.loc}{a character vector describing the location of \strong{R} library trees to
search through, or \code{NULL}. The default value of \code{NULL} corresponds
to all libraries currently known to \code{\link[=.libPaths]{.libPaths()}}. Non-existent
library trees are silently ignored.}

\item{character.only}{a logical indicating whether package or help can be assumed to be
character strings. If \code{TRUE}, dot arguments are coerced to be
character before being unlisted into a single character vector.}

\item{logical.return}{logical. If it is \code{TRUE}, \code{FALSE} or \code{TRUE} is returned to indicate
success.}

\item{warn.conflicts}{logical. If \code{TRUE}, warnings are printed about \link{conflicts} from
attaching the new package. A conflict is a function masking a
function, or a non-function masking a non-function. The default
is \code{TRUE} unless specified as \code{FALSE} in the \code{conflicts.policy} option.}

\item{quietly}{a logical. If \code{TRUE}, no message confirming package attaching
is printed, and most often, no errors/warnings are printed
if package attaching fails.}

\item{verbose}{a logical. If \code{TRUE}, additional diagnostics are printed.}

\item{mask.ok}{character vector of names of objects that can mask objects on the
search path without signaling an error when strict conflict checking
is enabled.}

\item{exclude, include.only}{character vector of names of objects to exclude or include in the
attached frame. Only one of these arguments may be used in a
call to \code{libraries} or \code{requires}.}

\item{attach.required}{logical specifying whether required packages listed in the
\code{Depends} clause of the \code{DESCRIPTION} file should be attached
automatically.}
}
\value{
\code{libraries()} and \code{requires()} return the value of the last
dot argument evaluated, invisibly:

Normally \code{library} returns (invisibly) the list of attached
packages, but \code{TRUE} or \code{FALSE} if \code{logical.return} is \code{TRUE}.
When called as \code{library()} it returns an object of class
\code{"libraryIQR"}, and for \code{library(help=)}, one of class
\code{"packageInfo"}.

\code{require} returns (invisibly) a logical indicating whether the
required package is available.
}
\description{
Wraps \code{\link[=library]{library()}} and \code{\link[=require]{require()}} to
load multiple packages.
}
\details{
All non-dot arguments are passed in their entirety to
each \code{library} or \code{require} call, so the same arguments are
used for each package.

For the \code{help} of a package, call \verb{library(help = <package>)}
directly.

For full details see \link{library}.
}
\examples{
libraries("stats", "graphics", methods)
requires("stats", graphics, "methods")

x <- c("stats", "graphics")
libraries(x, "methods", character.only = TRUE)
try(requires(methods, x, character.only = TRUE))
}
\seealso{
\link{attach}, \link{detach}, \link{install.packages}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/whole.r
\name{is.whole}
\alias{is.whole}
\alias{is.wholenumber}
\alias{is.integerish}
\title{Are vectors whole or integer-like?}
\usage{
is.whole(x, tol = .Machine$double.eps^0.5)

is.wholenumber(x, tol = .Machine$double.eps^0.5)

is.integerish(x)
}
\arguments{
\item{x}{a logical, numeric, or complex vector.}

\item{tol}{numeric tolerance for wholeness.}
}
\value{
For \code{is.whole()} and \code{is.integerish()} a single \code{TRUE} or \code{FALSE}.

For \code{is.wholenumber()}, a logical vector of the same length as \code{x}.
}
\description{
Tests if numeric vectors are integerish, or whole according to a
given tolerance.

\code{is.whole()} and \code{is.integerish()} check if the entire vector
is whole or integerish, whilst \code{is.wholenumber()} checks element-wise
for wholeness.
}
\details{
\code{is.integerish()} tests if a vector is integerish by evaluating if the
remainder of the \link[=abs]{absolute} value of \code{x} divided by \code{1} is 'equal'
to \code{0.0} in the \code{C} code.

\code{is.whole()} and \code{is.wholenumber()} test for wholeness by evaluating
if the \link[=abs]{absolute} value of \code{x} minus its rounded value is less than
the given tolerance.

Both \code{is.integerish()} and \code{is.whole()} ignore non-finite values (i.e.,
treat them as integerish/whole) and only test finite values for
integerishness or wholeness. If you do not want this behavior, use
\link{anyNF}, e.g., \code{!anyNF(x) && is.whole(x)}.

\code{is.wholenumber()} returns \code{NA} for non-finite elements.
}
\examples{
is.integerish(1)
is.integerish(1.0)
is.integerish(1.0000000001)
is.integerish(1.0000000000000001)

is.wholenumber(1)
x <- c(1.0, 1.0000001, 1.0000000001)
is.wholenumber(x)
is.whole(x)


# ignores non-finite values:
is.integerish(c(Inf, -Inf, NaN, NA))
is.whole(c(Inf, -Inf, NaN, NA))

# non-finite values flag as NA:
is.wholenumber(c(Inf, -Inf, NaN, NA))

# all error on non-numeric vector inputs:
try(is.integerish("1"))
try(is.whole("1"))
try(is.wholenumber("1"))
}
\seealso{
\link{is.integerish}, \link{anyNF}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/na.r
\name{is.nonfinite}
\alias{is.nonfinite}
\alias{is.nf}
\alias{anyNF}
\title{Are non-finite values present?}
\usage{
is.nonfinite(x)

is.nf(x)

anyNF(x)
}
\arguments{
\item{x}{\strong{R} object to be tested: the default methods handle atomic vectors.}
}
\value{
For \code{is.nonfinite()} and \code{is.nf()}, a logical vector of the same
length as \code{x}.

For \code{anyNF()}, an integer or real vector of length one with value
the \code{1}-based index of the first non-finite value if any,
otherwise \code{0}.
}
\description{
Tests if a vector contains non-finite values
(\code{Inf}, \code{-Inf}, \code{NaN}, or \code{NA}).
}
\details{
\code{is.nonfinite()} (and alias \code{is.nf()}) check for non-finite
values, returning a logical vector of the same length as \code{x},
whereas \code{anyNF()} returns an index immediately when encountering
a non-finite value.

\code{is.nonfinite()} and \code{anyNF()} are S3 generics, so custom
methods can be defined for different object types.

Similar to \code{is.finite()} semantics, \code{is.nonfinite()} returns all
\code{TRUE} for character and raw vectors, and \code{anyNF()} returns \code{1L}.
}
\note{
For character vectors use \link{is.na} and \link{anyNA}.
}
\examples{
is.nonfinite(1:10)
anyNF(1:10)

is.nonfinite(c(1, 2, NA, 4))
anyNF(c(1, 2, NA, 4))

is.nonfinite(c(1, 2, NaN, 4))
anyNF(c(1, 2, NaN, 4))

is.nonfinite(c(1, 2, Inf, 4))
anyNF(c(1, 2, Inf, 4))

is.nf(c(1, 2, -Inf, 4))
anyNF(c(1, 2, -Inf, 4))
}
\seealso{
\link{is.finite}, \link{is.whole}, \link{anyZchar}, \link{anyWS}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/helpers.r
\name{empty.list}
\alias{empty.list}
\title{Create an Empty list of Given Length}
\usage{
empty.list(length = 0L)
}
\arguments{
\item{length}{integer, specified length of the output list.}
}
\value{
an empty list of given length.
}
\description{
For a given length, create an empty list of that length.
}
\details{
This is a simple wrapper of \code{vector("list", length)} with a
clearer naming convention.
}
\examples{
empty.list()
empty.list(5L)
empty.list(length = 3L)
}
\seealso{
\link{vector}, \link{na.vector}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/which.r
\name{whichMin}
\alias{whichMin}
\alias{whichMax}
\alias{whichMin<-}
\alias{whichMax<-}
\title{Where is the min or max?}
\usage{
whichMin(x, loc = c("first", "last", "all"))

whichMax(x, loc = c("first", "last", "all"))

whichMin(x, loc = c("first", "last", "all")) <- value

whichMax(x, loc = c("first", "last", "all")) <- value
}
\arguments{
\item{x}{numeric (logical, integer or double) vector or an \strong{R}
object for which the internal coercion to \link{double} works whose \link{min}
or \link{max} is searched for.}

\item{loc}{\code{'first'}, \code{'last'} or \code{'all'} to specify which
index/indices to return.}

\item{value}{value/s to replace the min or max values with when
using the assignment functions.}
}
\value{
integer of indices. For the assignment functions, the
modified object with min or max values replaced by \code{value}.
}
\description{
Determines the location (i.e., index) of the (first, last, or all)
minima or maxima of a numeric (or logical) vector.
}
\note{
For \code{logical} vectors, \code{which(x)} is faster than
\code{whichMax(x, loc = "all")}, but \code{whichMin(x, loc = "all")} can
be faster than \code{which(!x)} for medium to large vectors due to
not having the performance cost of negating the vector.
}
\examples{
x <- c(1:4, 0:5, 11, 1:4, 0:5, 11)
whichMin(x)
whichMin(x, loc = "last")
whichMax(x)
whichMax(x, loc = "all")

# it *does* work with NA's present, by discarding them:
presidents[1:30]
whichMin(presidents) # 28
whichMax(presidents) #  2

# Find the first occurrence, i.e. the first TRUE, if there is at least one:
x <- rpois(10000, lambda = 10)
x[sample.int(50, 20)] <- NA
# where is the first value >= 20 ?
whichMax(x >= 20)
whichMax(x >= 20, loc = "last")
whichMax(x >= 20, loc = "all")

# objects are coerced to numeric vectors if possible:
whichMin(list(A = 7, pi = pi)) ##  ->  c(pi = 2L)

x <- 1:4
whichMin(x) <- 999
whichMax(x) <- -999
x
}
\seealso{
\link{which}, \link{which.max} and \link{which.min}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dots.r
\name{suppr-dots}
\alias{suppr-dots}
\alias{dotsNames}
\alias{subDots}
\alias{dp1Dots}
\alias{checkDots}
\title{Process the \code{...} arguments of a function.}
\usage{
dotsNames(...)

subDots(...)

dp1Dots(..., collapse = " ", width.cutoff = 500L)

checkDots(..., error = TRUE, which.call = -1, allowed = character(0))
}
\arguments{
\item{...}{"the dots", as passed from the caller.}

\item{collapse}{a string, passed to \link{paste}.}

\item{width.cutoff}{integer in \verb{[20, 500]} determining the cutoff
(in bytes) at which line-breaking is tried.}

\item{error}{a logical value indicating whether to throw an error (\code{TRUE})
or a warning (\code{FALSE}) for extraneous arguments.}

\item{which.call}{passed to \link{sys.call}. A caller may use \code{-2} if the
message should mention its caller.}

\item{allowed}{character vector of named elements in \code{...} which are
"allowed" and hence do not cause an error or warning.}
}
\value{
For \code{dotsNames}, a character vector of the names of the \code{...} arguments.

For \code{subDots}, a list of expressions.

For \code{dp1Dots}, a character vector of deparsed expressions.

For \code{checkDots}, \code{NULL} (invisibly), called for its side effects.
}
\description{
\code{dotsNames} returns the names of the \code{...} arguments, or a character
vector of empty strings if they are unnamed (without evaluating
\code{...}).

\code{subDots} returns the \code{...} arguments as a list of expressions.

\code{dp1Dots} returns the \code{...} arguments as a character vector of deparsed
expressions.

\code{checkDots} errors or warns about extraneous arguments in the \code{...}
of its caller.
}
\details{
\code{dotsNames} is an implementation of \link{allNames} for \code{...} arguments.

\code{subDots} is a simple wrapper for \code{as.list(substitute(...()))}.

\code{dp1Dots} applies \link{deparse1} to each element of \code{subDots(...)}.

\code{checkDots} is a variation of \link{chkDots} for use in functions that want
to error in case of extraneous arguments, not just warn. \code{checkDots}
also shows whether extraneous arguments are named or unnamed, and if
unnamed, the message will show the deparsed expressions of the unnamed
arguments. See examples.
}
\examples{
f <- function(...) dotsNames(...)
f(1, 2, mean(1:10))
f(a = 1, b = 2, mean(1:10))

f <- function(...) subDots(...)
f(a = 1, b = 2, mean(1:10))

f <- function(...) dp1Dots(...)
f(a = 1, b = 2, mean(1:10))

f <- function(x, ...) checkDots(..., allowed = "b")
f(1, b = 1)
try(f(1, a = 1, b = 2, mean(1:10)))
}
\seealso{
\link{...}, \link{chkDots}, \link{stop}, \link{warning}, \link{substitute}, \link{deparse1}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/arg.r
\name{match.argv}
\alias{match.argv}
\title{Argument Verification}
\usage{
match.argv(arg, choices, match.fn = NULL)
}
\arguments{
\item{arg}{an \strong{R} object.}

\item{choices}{a list of candidate values to match
against that will be extracted with \code{[[}.}

\item{match.fn}{a function to use for matching the
argument against the choices. This function must
take two arguments: the first is the argument to be
matched, and the second is a candidate value
extracted from \code{choices} with \code{[[}. It must return
a single \code{TRUE} or \code{FALSE} value indicating whether
the argument matches the candidate value.

If \code{NULL}, the default matching function is used,
which checks for equality using\code{identical()} with
\code{ignore.environment = TRUE}.}
}
\value{
If \code{arg} is identical to \code{choices}, then the first
element of \code{arg} is returned. If \code{arg} is matched
against a candidate value in \code{choices}, then \code{arg}
is returned. If no match is found, an error is thrown.
}
\description{
\code{match.argv()} matches a given argument against a
list of candidate values as specified by \code{choices}.
}
\details{
If \code{arg} is the same as \code{choices}, then the first element
of \code{arg} is returned. This check is done using
\code{\link[=identical]{identical()}} with \code{ignore.environment = TRUE}, regardless
of the \code{match.fn} argument.

In the one-argument form \code{match.argv(arg)}, the \code{choices}
are obtained from a default setting for the formal argument
\code{arg} of the function from which \code{match.argv} was called.
}
\examples{
# default matching function is strict.
match.argv(1:10, list(c("a", "b"), list(1, 2), 1:10))
try(match.argv(1, list(c("a", "b"), list(1, 2), 1:10)))

# NULL can be given as a candidate.
match.argv(NULL, list(NULL, 1:10))

# default matching function is strict.
try(match.argv(NA, list(NA_real_, NA_integer_, NA_character_)))

# a custom matching function can be used.
match.argv("A", list("a", "b", "c"), match.fn = function(x, y) {
  is.character(x) && length(x) == 1L && tolower(x) == tolower(y)
})
}
\seealso{
\link{match.arg}, \link{match.call}, \link{match.fun}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/na.r
\name{na.refill}
\alias{na.refill}
\title{Refill the NAs for a 'na.action' Object}
\usage{
na.refill(object, ...)
}
\arguments{
\item{object}{a \link{na.action} object (atomic vector, matrix or data.frame).}

\item{...}{further arguments special methods could require.}
}
\value{
vector, matrix or data.frame with the indices from \code{na.action}
refilled with \code{NA}s. \link{rownames} and \link{colnames} are preserved.

If the object given is not of those types, or not a \code{na.action} object,
it is returned unchanged.
}
\description{
For a \link{na.action} object, use the indices of where \code{NA}s were removed
to refill the object back to its original size with \code{NA}s in the
appropriate positions.
}
\details{
For objects where \link{na.omit} removes whole rows (e.g., matrices,
data.frames), the information about that row is lost, so \code{na.refill}
will refill those \strong{entire rows} with \code{NA}s.
}
\examples{
x <- c(1, 2, NA, 4, NA, 6)
na_x <- na.omit(x)
na_x
na.refill(na_x)

m <- matrix(1:9, 3, 3)
m[c(1, 3), 1:2] <- NA
dimnames(m) <- list(c("r1", "r2", "r3"), c("a", "b", "c"))
na_m <- na.omit(m)
na_m
na.refill(na_m) # previous data in NA row is lost

df <- data.frame(x = 1:5, y = c("a", NA, "c", "d", NA))
na_df <- na.omit(df)
na_df
na.refill(na_df)
}
\seealso{
\link{na.action}, \link{na.omit}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/whitespace.r
\name{anyZchar}
\alias{anyZchar}
\alias{anyWS}
\title{Are any zero char or all whitespace elements present?}
\usage{
anyZchar(x)

anyWS(x, zchar = FALSE)
}
\arguments{
\item{x}{a character vector.}

\item{zchar}{if \code{TRUE} then zero character elements
will be treated as all whitespace.}
}
\value{
an integer or real vector of length one with value
the \code{1}-based index of the first zero char/all whitespace value
if any, otherwise \code{0}.
}
\description{
Tests if a character vector contains any zero character
or all whitespace elements.
}
\details{
\code{anyZchar()} and \code{anyWS()} return an index immediately when
encountering a zero character or a whitespace element,
respectively.

Whitespace elements are defined as any character that is a
space, horizontal tab, carriage return or newline,
aka \code{"[ \\t\\r\\n]"}. See \link{trimws} for more details and how to
instead match all unicode whitespace.

\code{anyZchar()} implements the same definition of a zero char
as \code{\link{nzchar}}.

\code{NA_character_} is not considered zero char or all whitespace.
}
\note{
Unlike the similar base functions, these do not coerce
the input to character.
}
\examples{
anyZchar(c("hi", "bye", " ", ""))
anyWS(c("hi", "bye", " ", ""))
anyWS(c("hi", "bye", "who", ""), zchar = TRUE)
}
\seealso{
\link{nzchar}, \link{trimws}, \link{anyNF}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/helpers.r
\name{suppr-helpers}
\alias{suppr-helpers}
\alias{path}
\alias{dims}
\alias{enumerate}
\title{Miscellaneous Helper Functions}
\usage{
path(..., sharedDrive = FALSE, mustWork = NA)

dims(x)

enumerate(x)
}
\arguments{
\item{...}{character vectors. \link{Long vectors} are not supported.}

\item{sharedDrive}{logical, whether the path is on a shared drive.
If \code{TRUE}, then \code{.Platform$file.sep} is given as the first element
of the path, e.g., \verb{"mysd}, \code{"mydir"} becomes \code{"\\\\\\\\mysd\\\\mydir"}
(on windows).}

\item{mustWork}{logical: if \code{TRUE} then an error is given if the result cannot be
determined; if \code{NA} then a warning; if \code{FALSE} then no error or
warning is given.}

\item{x}{For \code{dims()}, an \strong{R} object.

For \code{enumerate()}, a vector or list to be enumerated.}
}
\value{
For \code{path()}, a character string of the expanded, normalized path.

For \code{dims()}, an integer of length 2 or greater that specifies
the dimensions of an object.

For \code{enumerate()}, a list of lists, where each inner list has
three elements: \code{idx}, \code{val}, and \code{name}, which are the index,
value, and name of the corresponding element.
}
\description{
\code{path()} builds a file path using \link{file.path}, before normalizing
the path with \link{normalizePath}.

\code{dims()} returns the dimensions of an object (from \link{dim}), but for
objects without dimensions the length of the object is returned
along with \code{0L} (e.g., \code{c(length(x), 0L)}).

\code{enumerate} maps a list to each element of a vector, containing the
index, value, and name of each element.
}
\details{
\code{path()} will expand paths, see example.

Unnamed elements given to \code{enumerate()} will have an empty string
(\code{""}) as their name.
}
\examples{
path("path", "expansion", "occurs", mustWork = FALSE)
path("mysd", "mydir", sharedDrive = TRUE, mustWork = FALSE)

# objects with dimensions give same output as dim():
dims(matrix(1:6, nrow = 2))

# those without give length and 0:
dims(1:5)
dims(list(a = 1, b = 2, c = 3))

for (x in enumerate(c(a = 1, b = 2, 3))) print(x)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/class.r
\name{addClass}
\alias{addClass}
\title{Add a Class to an Object}
\usage{
addClass(x, class, prepend = TRUE)
}
\arguments{
\item{x}{an \strong{R} object.}

\item{class}{character vector, or object coercible to character,
of one or more class names to add.}

\item{prepend}{logical. If \code{TRUE} the new class(es) are
prepended to the existing class vector. If \code{FALSE}, the class
vector is replaced entirely.}
}
\value{
The input object \code{x} with its class attribute updated.
}
\description{
Add a class to an object, either appending to, or replacing, the
existing class vector.
}
\details{
With \code{prepend = TRUE}, \code{addClass()} is equivalent to:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{class(x) <- c(class, class(x))
x
}\if{html}{\out{</div>}}

With \code{prepend = FALSE}:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{class(x) <- class
x
}\if{html}{\out{</div>}}
}
\examples{
x <- structure(1, class = "base_class")
y <- addClass(x, c("new_class", "another_class"))
class(y)

y <- addClass(x, c("new_class", "another_class"), prepend = FALSE)
class(y)
}
\seealso{
\link{class}, \link{inherits}, \link{is}.
}
